unit jString;


{**************************************************************************}
{   Delphi Orignal Run-time Library                          JString.pas   }
{                                                                          }
{      { Object Pascal in Delphi2.0 񏈗Cu            }
{                                                                          }
{                                    Copyright (c) 1996 by Akiyoshi.Ohki   }
{**************************************************************************}

{**************************************************************************}
{ 1999-02-14 BXA03027@nifty.ne.jp ΍i                                 }
{ Delphi40ɑΉ邽߂ɁAL֐ύX                                 }
{function IsTRIM(const pC: PChar; const JisChk: Boolean): Boolean;         }
{function ReText(const Source, ChkStr, ReStr: String): String;             }
{**************************************************************************}
{ 1999-03-06 BXA03027@nifty.ne.jp ΍i                                 }
{**************************************************************************}
{ 1999-06-06 BXA03027@nifty.ne.jp ΍i                                 }
{**************************************************************************}
{ 1999-07-16 BXA03027@nifty.ne.jp ΍i                                 }
{**************************************************************************}


{$O+,A+,W-,U+}
{$R-,S-,I-,Q-}            // {$R+,S+,I+,Q+}
{$V+,B-,X+,T-,P+,H+,J-}


interface


const
  trSideTrim  = 0;  { StrTrimp: TCh̋󔒍폜 }
  trLeftTrim  = 1;  { StrTrimp: 擪󔒂̍폜 }
  trRightTrim = 2;  { StrTrimp: 󔒂̍폜 }
  trMidTrim   = 3;  { StrTrimp: SĂ̋󔒍폜 }

{**************************************************************************}
{ 1999-06-06 BXA03027@nifty.ne.jp ΍i                                 }
  KANA:array[#$A6..#$DF] of BYTE=
     ($72,$21,
      $23,$25,$27,$29,$63,$65,$67,$43,
      $00,$22,$24,$26,$28,$2A,$AB,$AD,
      $AF,$B1,$B3,$B5,$B7,$B9,$BB,$BD,
      $BF,$C1,$C4,$C6,$C8,$4A,$4B,$4C,
      $4D,$4E,$CF,$D2,$D5,$D8,$DB,$5E,
      $5F,$60,$61,$62,$64,$66,$68,$69,
      $6A,$6B,$6C,$6D,$6F,$73,$00,$00);
      KIGOU:string=' !"#$%&''()=`|-^\~{@[+*};:]<>?_,./';
      KKIGOU:string
                   ='@Ihfijeb|OPom{p'+
                    'GFnHQABECD^[uv';
   ZEN:array[$21..$76] of byte=
     (1,11,2,12,3,13,4,14,5,15,                       {}
      16,16+56,17,17+56,18,18+56,19,19+56,20,20+56,   {}
      21,21+56,22,22+56,23,23+56,24,24+56,25,25+56,   {}
      26,26+56,27,27+56,9,28,28+56,29,29+56,30,30+56, {}
      31,32,33,34,35,                                 {}
      36,36+56,36+112,37,37+56,37+112,38,38+56,38+112,{}
      39,39+56,39+112,40,40+56,40+112,
      41,42,43,44,45,6,46,7,47,8,48,49,50,51,52,53,   {܂}
      54,54,12,14,15,55,13+56,16,19);                 {}
{**************************************************************************}


{ ----- String^ 񑀍 {ꉻCu ----------------------- }
function  jCopy(const jS: String; const jIndex, jCount: Integer): String;
procedure jDelete(var jS: String; const jIndex, jCount: Integer);
procedure jInsert(const jSource: String; var jS: String; const jIndex: Integer);
function  jLength(const jS: String): Integer;
function  jLowerCase(const jS: String): String;
function  jPos(const jSubstr, jS: String): Integer;
function  jTrim(const jS: String): String;
function  jTrimLeft(const jS: String): String;
function  jTrimRight(const jS: String): String;
function  jUpperCase(const jS: String): String;

{**************************************************************************}
{ 1999-03-06 BXA03027@nifty.ne.jp ΍i                                 }
function  jLowerCaseHan(const jS: String): String;
function  jLowerCaseHanZen(const jS: String): String;
function  jUpperCaseHan(const jS: String): String;
function  jUpperCaseHanZen(const jS: String): String;
{**************************************************************************}

{**************************************************************************}
{ 1999-06-06 BXA03027@nifty.ne.jp ΍i                                 }
function JisToSJis(N:word):word;        {ihrVtgihr}
function JisToKuten(N:word):word;       {ihr_}
function JisToEUC(N:word):word;         {ihrdtb}
function SJisToJis(N:word):word;        {Vtgihrihr}
function SJisToKuten(N:word):word;      {Vtgihr_}
function SJisToEUC(N:word):word;        {Vtgihrdtb}
function KutenToJis(N:word):word;       {_ihr}
function KutenToSJis(N:word):word;      {_Vtgihr}
function KutenToEUC(N:word):word;       {_dtb}
function EUCToJis(N:word):word;         {dtbihr}
function EUCToSJis(N:word):word;        {dtbVtgihr}
function EUCToKuten(N:word):word;       {dtb_}
function WordToChar(N:word):string;     {l𕶎}
function CharToWord(S:string):word;     {𐔒l}
function HankToZen(S:string):string;    {pSp}
function ZenToHank(S:string):string;    {Sp𔼊p}
function AlpToJis(c:char):word;         {At@xbgihr}
function AlpToSJis(c:char):word;        {At@xbgVtgihr}
function KigouToJis(c:char):word;       {Lihr}
function KigouToSJis(c:char):word;      {LVtgihr}
function KanaToZen(S:string):string;    {JiL(#$A0`#DF)݂̂Sp}
function IsDBCSLeadChar(c:char):Boolean;{IsDBCSLeadByte̕(char)ŔAPI}
{**************************************************************************}

{**************************************************************************}
{ 1999-07-16 BXA03027@nifty.ne.jp ΍i                                 }
procedure jGetTabIndexPos(const src: String;
                          var TabLength: Integer;
                          var DrawIndex: Integer;
                          var LineIndex: Integer);
{**************************************************************************}


{ ----- String^ VK񑀍색Cu -------------------------------- }
function  AscB(const S: String): Byte;
function  jAsc(const jS: String): Word;
function  ChrB(const Code: Byte): String;
function  jChr(const jCode: Word): String;
function  LeftB(const S: String; const Count: Integer): String;
function  MidB(const S: String; const Index, Count: Integer): String;
function  RightB(const S: String; const Count: Integer): String;
function  jLeft(const jS: String; const jCount: Integer): String;
function  jMid(const jS: String; const jIndex, jCount: Integer): String;
function  jRight(const jS: String; const jCount: Integer): String;
function  jPosByte(const jSubstr, jS: String): Integer;
function  TrimMid(const S: String): String;
function  jTrimMid(const jS: String): String;
function  jToken(var jS: String; delimita: String): String;
function  Cating(const jS: String; const Count: Integer): String;
function  CharPos(const Source, ChkChar: String): String;
function  ReText(const Source, ChkStr, ReStr: String): String;


{ ----- PChar^ 񑀍 {ꉻCu ------------------------ }
function  jStrLen(const jStr: PChar): Cardinal;
function  jStrLower(const jStr: PChar; const Jis: Boolean): PChar;
function  jStrUpper(const jStr: PChar; const Jis: Boolean): PChar;


{ ----- PChar^ VK񑀍색Cu --------------------------------- }
function  StrAsc(const pC: PChar): Word;
function  StrChr(const pC: PChar; const AscCode: Word): PChar;
function  StrGetWord(const pData: PChar): Word;
function  StrSetWord(const pData: PChar; const IntData: Word): PChar;
function  MtoB(const jStr: PChar; const MaxLen: Integer): Cardinal;
function  BtoM(const jStr: PChar; const MaxByte: Integer): Cardinal;
function  StrCating(const Dest, Source: PChar; const Count: Integer): PChar;
function  StrTrim(const Str: PChar; const Param: Byte; const JisChk: Boolean): PChar;
function  StrCharPos(const Source, ChkChar: PChar): PChar;
function  StrReText(const Dest, Source, ChkStr, ReStr: PChar; const MaxByte: Cardinal): PChar;
function  IsStrDBCS(const Str: PChar): Boolean;


{ ----- ̑ VK񑀍색Cu -------------------------------- }
function  AtoI(const S: String): Integer;
function  AtoF(const S: String): Extended;
function  ByCode(const S: String): String;
function  Kanma(const Index: Integer; const MaxLen: Byte): String;
function  IEEEtoDBL(const pIEEE: Pointer): Double;
procedure DBLtoIEEE(const pIEEE: Pointer; const dIndex: Double);
function  FileEnabled(const FileName: String): String;
function  DosFileEnabled(const FileName: String): String;


implementation


uses
  SysUtils, Windows;


{ ----- Private Function ------------------------------------------------- }


function IsDBCS(const pC: PChar): Boolean;
{ pC & (pC+1) QoCgZbg(DBCS Sp̂) Ȃΐ^Ԃ }
begin
  if pC[0] = #0 then
    Result := False
  else
    Result := IsDBCSLeadByte(Byte(pC[0]))and(pC[1] <> #0);
end;


function GetDBCS(const pC: PChar): Word;
{ pC & (pC+1) QoCgZbg(DBCS Sp̂) Ȃ΃VtgihrR[hԂ }
{ PoCgȂ΃AXL[R[hԂ. DBCS ̏ꍇ́AԂl 256 ȏɂȂ }
var
  bUpr: Byte;
begin
  if pC[0] = #0 then
    Result := 0
  else begin
    bUpr := Byte(pC[0]);
    if IsDBCSLeadByte(bUpr)and(pC[1] <> #0) then
      Result := bUpr * $0100 + Byte(pC[1])
    else
      Result := bUpr;
  end;
end;


function IsTRIM(const pC: PChar; const JisChk: Boolean): Boolean;
{ Trim֘ÃR}hŋ󔒂̎ʂsA󔒂Ȃΐ^Ԃ }
{ JisChk = True : pC Sp/pXy[XARg[R[h̏ꍇɐ^ }
{ JisChk = False: pC pXy[XARg[R[h̏ꍇɐ^ }
var
  wAsc: Word;
begin
  wAsc := GetDBCS(pC);
  if (wASc = $00) then
    Result := TRUE
  else if ((JisChk = True) and (wAsc = $8140)) or
      (wAsc = $20) or
     ((wAsc > $00) and ($1F >= wAsc)) or
      (wAsc = $7F) then
  begin
    Result := TRUE;
  end
  else
  begin
    Result := FALSE;
  end;
end;


function StrByteInc(var pC: PChar): Byte;
{ pC ASp/p/kʂ pC 𑝉AԂ }
{ SpȂ pC Q. pȂ pC P. kȂ pC ͑Ȃ }
{ [Ԃl] pC ̃|C^. O,P,Q ̂ꂩ }
begin
  if pC[0] = #0 then
    Result := 0
  else begin
    if IsDBCS(pC) then
      Result := 2
    else
      Result := 1;
    Inc(pC, Result);
  end;
end;


function StrByteCopy(var Dest, Source: PChar; const JisChk: Boolean): Byte;
{ Source  Dest ɕ]ASource, Dest 𑝉AԂ }
{ JisChk = True : SpmFďꍇɂQoCg]s }
{ JisChk = False: SpmFȂőSĔpƂĈ. PȃRs[ɗL }
{ [Ԃl]  Source, Dest ̃|C^. O,P,Q ̂ꂩ }
{ [ӓ_]  Source k̏ꍇARs[|C^̑ȂłOԂ }
begin
  if Source[0] = #0 then
    Result := 0
  else begin
    if JisChk and IsDBCS(Source) then begin
      Result := 2;
      Dest[0] := Source[0];
      Dest[1] := Source[1];
    end else begin
      Result := 1;
      Dest[0] := Source[0];
    end;
    Inc(Source, Result);
    Inc(Dest, Result);
  end;
end;


function StrByteComp(var pC1, pC2: PChar; const UpLow, JisON: Boolean): Integer;
{ pC1  pC2 rAvĂ΃|C^ꂼꑝĂ猋ʂԂ }
{ UpLow = True : JisON ̏ŉp̑啶/ʂȂ }
{ UpLow = False: p̑啶/ʂ }
{ JisON = True : SppʂȂ }
{ JisON = False: Spp͋ʂ }
{ [Ԃl] (pC1<pC2)=O菬 / (pC1=pC2)=O(߲) / (pC1>pC2)=O傫 }
var
  cChr1, cChr2: array[0..3]of Char;
begin
  if (pC1[0] <> #0)and(pC2[0] <> #0) then begin
    cChr1[0] := pC1[0];
    cChr2[0] := pC2[0];
    if IsDBCS(pC1) and IsDBCS(pC2) then begin
      cChr1[1] := pC1[1];
      cChr1[2] := #0;
      cChr2[1] := pC2[1];
      cChr2[2] := #0;
      if UpLow and JisON then
        Result := LStrCmpI(@cChr1[0], @cChr2[0])
      else
        Result := LStrCmp(@cChr1[0], @cChr2[0]);
      if Result = 0 then begin
        Inc(pC1, 2);
        Inc(pC2, 2);
      end;
    end else begin
      cChr1[1] := #0;
      cChr2[1] := #0;
      if UpLow then
        Result := LStrCmpI(@cChr1[0], @cChr2[0])
      else
        Result := LStrCmp(@cChr1[0], @cChr2[0]);
      if Result = 0 then begin
        Inc(pC1);
        Inc(pC2);
      end;
    end;
  end else
    Result := Byte(pC1) - Byte(pC2);
end;


function StrTextComp(const Source, CompText: PChar): PChar;
{ Source  CompText ̃kO܂łrAvĂ Source̐擪|C^Ԃ }
{ p̑啶/͋ʂȂŒPȔrɗL. Source  CompText ݂邩mF }
{ [Ԃl] CompText ̃kO܂ł Source ƓȂ Source 擪|C^. Ⴆ Nil Ԃ }
{ [ӓ_] Source  CompText ̐擪k̏ꍇłvƂɂȂ }
var
  rChk: Boolean;
  pSrc, pCmp: PChar;
begin
  if Source[0] = CompText[0] then begin
    pSrc := Source;
    pCmp := CompText;
    rChk := True;
    While (pSrc^ <> #0)and(pCmp^ <> #0)and(rChk = True) do begin
      rChk := (StrByteComp(pSrc, pCmp, False, False) = 0);
    end;
    if (pCmp^ = #0)and(rChk = True) then
      Result := Source
    else
      Result := Nil;
  end else
    Result := Nil;
end;


function StrByteUpLow(var pC: PChar; const UpLow, JisON: Boolean): Byte;
{ pC1  UpLow ɏ] p 啶 ϊ pC 𑝉Ԃ }
{ UpLow = True : JisON ̏őSđ啶Ƃ }
{ UpLow = False: JisON ̏őSďƂ }
{ JisON = True : Sppϊ }
{ JisON = False: Spp͕ϊȂ }
{ [Ԃl]  pC ̃|C^. O,P,Q ̂ꂩ }
{ [ӓ_]  pC k̏ꍇA|C^̑ȂłOԂ }
var
  cChr: array[0..3]of Char;
  pChr: PChar;
begin
  if pC[0] = #0 then
    Result := 0
  else begin
    if IsDBCS(pC) then begin
      Result := 2;
      if JisON then begin
        cChr[0] := pC[0];
        cChr[1] := pC[1];
        cChr[2] := #0;
        if UpLow then
          pChr := CharUpper(@cChr[0])
        else
          pChr := CharLower(@cChr[0]);
        pC[0] := pChr[0];
        pC[1] := pChr[1];
      end;
    end else begin
      Result := 1;
      cChr[0] := pC[0];
      cChr[1] := #0;
      if UpLow then
        pChr := CharUpper(@cChr[0])
      else
        pChr := CharLower(@cChr[0]);
      pC[0] := pChr[0];
    end;
    Inc(pC, Result);
  end;
end;


function MtoMB(var ByteLen: Cardinal; const Str: PChar; const MaxLen: Cardinal): Cardinal;
{ Str ̐擪 MaxLen (Sp=P)܂ł̎ۂ̕(Sp=P)Ԃ }
{ MaxLen  0 ꂽꍇAԂl Str |C^kO܂ł̑ƂȂ }
{ [Ԃl] Str  >= MaxLen Ȃ Ԃl MaxLen Ɠ }
{          Str  < MaxLen Ȃ Ԃl̓kO܂ł̕ƂȂ }
{ [ߕϐ] ByteLen ɂ́AԂl̕ɑ΂oCg(Sp=2޲)Ԃ }
var
  pIndex: PChar;
begin
  Result := 0;
  ByteLen := 0;
  if Str^ <> #0 then begin
    pIndex := Str;
    if MaxLen = 0 then begin
      Repeat
        Inc(ByteLen, StrByteInc(pIndex));
        Inc(Result);
      Until (pIndex^ = #0);
    end else begin
      Repeat
        Inc(ByteLen, StrByteInc(pIndex));
        Inc(Result);
      Until (pIndex^ = #0)or(Result >= MaxLen);
    end;
  end;
end;




{ ----- Public Function in String ---------------------------------------- }


function jCopy(const jS: String; const jIndex, jCount: Integer): String;
{ Copy{: jS  jIndex(Sp͂P) jCount (Sp͂P)̕Ԃ܂ }
{ jIndex  jS ̒蒷ꍇCjCopy ͋̕Ԃ܂ }
var
  nByte, ni: Cardinal;
  pSrc, pDes, pCount: PChar;
begin
  Result := '';
  if jS <> '' then begin
    pSrc := @jS[1];
    if (jIndex >= 0)and(jCount > 0) then begin
      if jIndex = 0 then ni := 0 else ni := jIndex - 1;
      nByte := 0;
      if (ni = 0)or(MtoMB(nByte, pSrc, ni) = ni) then begin
        Inc(pSrc, nByte);
        if pSrc^ <> #0 then begin
          MtoMB(nByte, pSrc, jCount);
          if nByte > 0 then begin
            pDes := StrAlloc(nByte + 1);
            pCount := pDes;
            for ni := 1 to nByte do begin
              pCount^ := pSrc^;
              Inc(pSrc);
              Inc(pCount);
            end;
            pCount^ := #0;
            Result := String(pDes);
            StrDispose(pDes);
          end;
        end;
      end;
    end;
  end;
end;


procedure jDelete(var jS: String; const jIndex, jCount: Integer);
{ Delete{: jS  jIndex(Sp͂P) n܂ jCount (Sp͂P)̕폜܂ }
{ jIndex  jS ̒蒷ꍇ́C폜܂ }
var
  nByte, ni: Cardinal;
  pSrc, pDes, pIndex: PChar;
begin
  if jS <> '' then begin
    pSrc := PChar(jS);
    if (jIndex > 0)and(jCount > 0) then begin
      ni := jIndex - 1;
      pIndex := pSrc;
      nByte := 0;
      if (ni = 0)or(MtoMB(nByte, pIndex, ni) = ni) then begin
        Inc(pIndex, nByte);
        if pIndex^ <> #0 then begin
          MtoMB(nByte, pIndex, jCount);
          if nByte > 0 then begin
            pDes := pIndex + nByte;
            While (pDes^ <> #0) do begin
              StrByteCopy(pIndex, pDes, False);
            end;
          end;
          pIndex^ := #0;
        end;
      end;
    end;
    jS := String(pSrc);
  end;
end;


procedure jInsert(const jSource: String; var jS: String; const jIndex: Integer);
{ Insert{: 𕶎Ɏw̒n_}[W܂ }
{  jS  jIndex (Sp͂P) jSource }Ďc jS Ōɕt܂ }
var
  sRet: String;
begin
  if jIndex > 1 then
    sRet := jCopy(jS, 1, jIndex - 1) + jSource + jCopy(jS, jIndex, jLength(jS) - jIndex + 1)
  else
    sRet := jSource + jS;
  jS := sRet;
end;


function jLength(const jS: String): Integer;
{ Length{: jS ŎۂɎgĂ镶̐(Sp͂P)Ԃ܂ }
begin
  if jS = '' then Result := 0 else Result := jStrLen(@jS[1]);
end;


function jLowerCase(const jS: String): String;
{ LowerCase{: jS  A  Z ܂ł̔pp݂̂ɕϊĕԂ }
var
  pLower: PChar;
begin
  if jS = '' then
    Result := ''
  else begin
    pLower := PChar(jS);
    Result := String(jStrLower(pLower, False));
  end;
end;


function jPos(const jSubstr, jS: String): Integer;
{ Pos{: ̒ŕ܂ }
{  jS ̒ jSubstr CjSubstr (Sp͂P)n܂邩Ԃ܂ }
{ jSubstr ȂꍇCjPos  0 Ԃ܂ }
var
  nCount: Cardinal;
  pIndex, pChk: PChar;
begin
  Result := 0;
  if (jS <> '')and(jSubstr <> '') then begin
    nCount := 0;
    pIndex := @jS[1];
    pChk := Nil;
    While (pIndex^ <> #0)and(pChk = Nil) do begin
      Inc(nCount);
      pChk := StrTextComp(pIndex, @jSubstr[1]);
      StrByteInc(pIndex);
    end;
    if pChk <> Nil then Result := nCount;
  end;
end;


function jTrim(const jS: String): String;
{ Trim{: jS 񂩂擪і̋(pyёSp)Ɛ䕶菜܂ }
var
  pTrim: PChar;
begin
  if jS = '' then
    Result := ''
  else begin
    pTrim := PChar(jS);
    Result := String(StrTrim(pTrim, trSideTrim, True));
  end;
end;


function jTrimLeft(const jS: String): String;
{ Trim{: jS 񂩂擪̋(pyёSp)Ɛ䕶菜܂ }
var
  pTrim: PChar;
begin
  if jS = '' then
    Result := ''
  else begin
    pTrim := PChar(jS);
    Result := String(StrTrim(pTrim, trLeftTrim, True));
  end;
end;


function jTrimRight(const jS: String): String;
{ Trim{: jS 񂩂疖̋(pyёSp)Ɛ䕶菜܂ }
var
  pTrim: PChar;
begin
  if jS = '' then
    Result := ''
  else begin
    pTrim := PChar(jS);
    Result := String(StrTrim(pTrim, trRightTrim, True));
  end;
end;


function jUpperCase(const jS: String): String;
{ UpperCase{: jS  A  Z ܂ł̔pp݂̂啶ɕϊĕԂ }
var
  pUpper: PChar;
begin
  if jS = '' then
    Result := ''
  else begin
    pUpper := PChar(jS);
    Result := String(jStrUpper(pUpper, False));
  end;
end;


{**************************************************************************}
{ 1999-03-06 BXA03027@nifty.ne.jp ΍i                                 }
function jLowerCaseHan(const jS: String): String;
{ UpperCase{: jS  A  Z ܂ł̔p̉pɕϊĕԂ }
var
  pLower: PChar;
begin
  if jS = '' then
    Result := ''
  else begin
    pLower := PChar(jS);
    Result := String(jStrLower(pLower, False));
  end;
end;


function jLowerCaseHanZen(const jS: String): String;
{ UpperCase{: jS  A  Z ܂ł̔pƑSp̉pɕϊĕԂ }
var
  pLower: PChar;
begin
  if jS = '' then
    Result := ''
  else begin
    pLower := PChar(jS);
    Result := String(jStrLower(pLower, TRUE));
  end;
end;


function jUpperCaseHan(const jS: String): String;
{ UpperCase{: jS  A  Z ܂ł̔p̉p啶ɕϊĕԂ }
var
  pUpper: PChar;
begin
  if jS = '' then
    Result := ''
  else begin
    pUpper := PChar(jS);
    Result := String(jStrUpper(pUpper, False));
  end;
end;


function jUpperCaseHanZen(const jS: String): String;
{ UpperCase{: jS  A  Z ܂ł̔pƑSp̉p啶ɕϊĕԂ }
var
  pUpper: PChar;
begin
  if jS = '' then
    Result := ''
  else begin
    pUpper := PChar(jS);
    Result := String(jStrUpper(pUpper, TRUE));
  end;
end;
{**************************************************************************}


{**************************************************************************}
{ 1999-06-06 BXA03027@nifty.ne.jp ΍i                                 }
function JisToSJis(N:WORD):WORD; assembler;
asm
    add  ax,0a17eh ; shr  ah,1      ; jb  @1
    cmp  al,0deh   ; sbb  al,5eh
@1: xor  ah,0e0h
end;

function SJisToJis(N:WORD):WORD; assembler;
asm
    shl  ah,1      ; sub  al,1fh    ; js   @1
    cmp  al,61h    ; adc  al,0deh
@1: add  ax,1fa1h  ; and  ax,7f7fh
end;

function JisToKuten(N:WORD):WORD; assembler;
asm
    sub ax,2020h
end;

function KutenToJis(N:WORD):WORD; assembler;
asm
    add ax,2020h
end;

function EUCToJis(N:word):word; assembler;
asm
    and ax,7f7fh
end;

function JisToEUC(N:word):word; assembler;
asm
    or ax,8080h
end;

function EUCToKuten(N:word):word; assembler;
asm
   and ax,7f7fh
   sub ax,2020h
end;

function KutenToEUC(N:word):word;
asm
   add ax,2020h
   or  ax,8080h
end;

function SJisToEUC(N:word):word;
begin
  Result:=SJisToJis(N) or $8080
end;

function EUCToSJis(N:word):word;
begin
  Result:=JisToSJis( n and $7f7f)
end;

function SJisToKuten(N:WORD):WORD;
begin
  Result:=JisToKuten(SJisToJis(N))
end;

function KutenToSJis(N:WORD):WORD;
begin
  RESULT:=JisToSJis(KutenToJis(N))
end;

function WordToChar(N:WORD):String;
begin
  Result:=char(Hi(N))+char(Lo(N))
end;

function CharToWord(s:string):word;
begin
  Result:=(ord(s[1]) shl 8) + ord(s[2])
end;

function HankToZen(s:string):string;
var w:word;
begin
  Result:='';
  while Length(s)>0 do begin
    if IsDBCSLeadChar(s[1]) then begin
      Result:=Result+Copy(s,1,2); Delete(s,1,2)
    end else if s[1] in [#$a6..#$af,#$b1..#$df] then begin
      if kana[s[1]]=0 then begin
         Result:=Result+s[1]; Delete(s,1,1)
      end else begin
         w:=$2500+(kana[s[1]] and $7f);
         if (kana[s[1]] and $80)=0 then begin
           Result:=Result+WordToChar(JisToSJis(w));
           if (Length(s)>1) and (s[2]in [#$de,#$df]) then begin
             Result:=Result+WordToChar(JisToSJis($204d+Ord(s[2])));
             Delete(s,2,1)
           end;
           Delete(s,1,1)
         end else begin
           if (Length(s)>1) and (s[2] in [#$de,#$df]) then begin
             w:=w+1+(Ord(s[2]) and 1);
             Delete(s,2,1)
           end;
           Result:=Result+WordToChar(JisToSJis(w));
           Delete(s,1,1)
         end
      end
    end else begin
      if s[1] in ['0'..'9','A'..'Z','a'..'z'] then begin
        Result:=Result+WordToChar(JisToSJis($2300+Ord(s[1])));
        Delete(s,1,1)
      end else
        if Pos(s[1],kigou)>0 then begin
          Result:=Result+WordToChar(KigouToSJis(s[1]));
          delete(s,1,1)
        end else begin
          Result:=Result+s[1]; Delete(s,1,1)
        end
    end
  end
end;

function ZenToHank(s:string):string;
var w:word;
begin
   Result:='';
   while Length(s)>0 do begin
     if s[1] in [#$81..#$9f,#$e0..#$fc] then begin
       w:=CharToWord(s+'@');
       if Hi(SJisToJis(w)) in [$24,$25] then begin
         if Lo(SJisToJis(w)) in [$21..$76] then begin
           w:=zen[Lo(SJisToJis(w))];
           Result:=Result+char((w mod 56)+$a6);
           case w div 56 of
           1:Result:=Result+'';
           2:Result:=Result+'';
           end;
           Delete(s,1,2)
         end else begin
           Result:=Result+s[1];
           Delete(s,1,1)
         end
       end else if Pos(Copy(s,1,2),kkigou)>0 then begin
         Result:=Result+kigou[Pos(copy(s,1,2),kkigou)div 2+1];
         Delete(s,1,2)
       end else if Hi(SJisToJis(w))=$23 then begin
         Result:=Result+char(lo(SJisToJis(w)));
         Delete(s,1,2)
       end else begin
         Result:=Result+Copy(s,1,2);
         Delete(s,1,2)
       end;
     end else begin
       Result:=Result+s[1];
       Delete(s,1,1)
     end;
   end;
end;

function AlpToJis(c:char):word;
begin
  if c in ['0'..'9','A'..'Z','a'..'z'] then Result:=$2300+ord(c)
  else Result:=Ord(c){ ɁA̕ϊu }
end;

function AlptoSjis(c:char):word;
begin
  result:=JisToSJis(AlpToJis(c))
end;

function KigouToJis(c:char):word;
begin
 result:=SJisToJis(KigouToSJis(c))
end;

function KigouToSJis(c:char):word;
var v:integer;
begin
  v:=Pos(c,kigou);
  if v>0 then Result:=Ord(kkigou[v*2-1]) shl 8 + Ord(kkigou[v*2])
         else Result:=Ord(c)
end;

function KanaToZen(S:string):string;
begin
  Result:='';
  while Length(s)>0 do begin
    if IsDBCSLeadChar(s[1]) then begin
      Result:=Result+Copy(s,1,2);
      Delete(s,1,2)
    end else begin
      if s[1] in [#$A0..#$DF] then begin
        if Copy(s+' ',2,1)[1] in ['',''] then begin
          Result:=Result+HankToZen(Copy(s,1,2));
          Delete(s,1,2)
        end else begin
          Result:=Result+HankToZen(s[1]);
          Delete(s,1,1)
        end
      end else begin
        Result:=Result+s[1];
        Delete(s,1,1)
      end
    end
  end
end;

function IsDBCSLeadChar(c:char):boolean;
begin
  Result:=c in [#$81..#$9f,#$E0..#$fc]
end;
{**************************************************************************}


{**************************************************************************}
{ 1999-07-16 BXA03027@nifty.ne.jp ΍i                                 }
procedure jGetTabIndexPos(const src: String;
                          var TabLength: Integer;
                          var DrawIndex: Integer;
                          var LineIndex: Integer);
var
  pSrc: PChar;
  wSrc: Word;
  i: Integer;
  j: Integer;
begin
  {擪̎͂̂܂ܐݒlԂ}
  if DrawIndex = 0 then
  begin
    LineIndex := DrawIndex;
  end;

  {|C^ɒu}
  pSrc := @src[1];
  {}
  i := 0;
  j := 0;
  LineIndex := -1;
  {Ō܂Ŏs}
  while (pSrc^ <> #0) do
  begin
    { ܂ 傫Ȃ ̗p}
    if (j >= DrawIndex) and (LineIndex = -1) then
    begin
      LineIndex := i;
      Break;
    end;

    {Sp̔}
    wSrc := StrAsc(pSrc);
    {SpȂQi߂}
    if wSrc > $FF then
    begin
      i := i+2;
      j := j+2;
      Inc(pSrc, 2);
    end
    {SpłȂȂPi߂}
    else
    begin
      {^u̎͋󔒂⊮鐔Z}
      if wSrc = $9 then
      begin
        i := i+1;
        j := ((j div TabLength) + 1) * TabLength;
      end
      {^ułȂ͂Pi߂}
      else
      begin
        i := i+1;
        j := j+1;
      end;
      Inc(pSrc, 1);
    end;
  end;

  {łȂ͐ݒlԂ}
  if LineIndex = -1 then
  begin
    LineIndex := DrawIndex;
  end;
end;
{**************************************************************************}


{ ----- Public Function in New String ------------------------------------ }


function AscB(const S: String): Byte;
{ S Ŏ̎n߂̃̕AXL[R[hԂ }
begin
  if S = '' then Result := 0 else Result := Byte(S[1]);
end;


function jAsc(const jS: String): Word;
{ jS Ŏ̎n߂̕SpȂJISނApȂ籽ނԂ }
begin
  if jS = '' then Result := 0 else Result := StrAsc(@jS[1]);
end;


function ChrB(const Code: Byte): String;
{ Code Ŏ 0`255 ܂ł̃AXL[R[h String^ɂĕԂ }
begin
  if Code = 0 then Result := '' else Result := String(Char(Code and $FF));
end;


function jChr(const jCode: Word): String;
{ jCode JISނȂ2޲ĂAނȂ1޲ĕ String^ɂĕԂ }
var
  cRet: array[0..3]of Char;
begin
  if jCode = 0 then
    Result := ''
  else begin
    cRet[1] := #0;
    StrChr(@cRet[0], jCode);
    if cRet[1] = #0 then
      Result := String(cRet[0])
    else
      Result := String(cRet[0]) + String(cRet[1]);
  end;
end;


function LeftB(const S: String; const Count: Integer): String;
{ S ̍ Count ޲ĕ(Sp͂Q޲ĂƂȂ)Ԃ }
{ Count  S ̕ȂꍇAp߰Ōɒǉ΂ Count Ԃ }
begin
  if Count > 0 then begin
    Result := Copy(S, 1, Count);
    Result := Result + Cating(' ', Count - Length(Result));
  end else
    Result := '';
end;


function MidB(const S: String; const Index, Count: Integer): String;
{ S  Index ޲(1ȏ)ڂ Count ޲ĕ(Sp͂Q޲ĂƂȂ)Ԃ }
{ Count  S ̕ȂꍇAp߰Ōɒǉ΂ Count Ԃ }
begin
  if (Index > 0)and(Count > 0) then begin
    Result := Copy(S, Index, Count);
    Result := Result + Cating(' ', Count - Length(Result));
  end else
    Result := '';
end;


function RightB(const S: String; const Count: Integer): String;
{ S ̉E Count ޲ĕ(Sp͂Q޲ĂƂȂ)Ԃ }
{ Count  S ̕ȂꍇAp߰ɒǉ΂ Count Ԃ }
var
  nLen: Integer;
begin
  if Count > 0 then begin
    nLen := Length(S);
    if nLen > Count then
      Result := Copy(S, nLen - Count + 1, Count)
    else
      Result := Cating(' ', Count - nLen) + S;
  end else
    Result := '';
end;


function jLeft(const jS: String; const jCount: Integer): String;
{ jS ̍ jCount (Sp͂PƂȂ)Ԃ }
{ jCount  jS ̕ȂꍇAp߰Ōɒǉ΂ jCount Ԃ }
begin
  if jCount > 0 then begin
    Result := jCopy(jS, 1, jCount);
    Result := Result + Cating(' ', jCount - jLength(Result));
  end else
    Result := '';
end;


function jMid(const jS: String; const jIndex, jCount: Integer): String;
{ jS  jIndex (1ȏ)(Sp͂PƂȂ) jCount (Sp͂PƂȂ)Ԃ }
{ jCount  jS ̕ȂꍇAp߰Ōɒǉ΂ jCount Ԃ }
begin
  if (jIndex > 0)and(jCount > 0) then begin
    Result := jCopy(jS, jIndex, jCount);
    Result := Result + Cating(' ', jCount - jLength(Result));
  end else
    Result := '';
end;


function jRight(const jS: String; const jCount: Integer): String;
{ jS ̉E jCount (Sp͂PƂȂ)Ԃ }
{ jCount  jS ̕ȂꍇAp߰Ōɒǉ΂ jCount Ԃ }
var
  nLen: Integer;
begin
  if jCount > 0 then begin
    nLen := jLength(jS);
    if nLen > jCount then
      Result := jCopy(jS, nLen - jCount + 1, jCount)
    else
      Result := Cating(' ', jCount - nLen) + jS;
  end else
    Result := '';
end;


function jPosByte(const jSubstr, jS: String): Integer;
{ ̒ŕ܂ }
{  jS ̒ jSubstr CjSubstr ޲Ė(Sp͂Q޲)n܂邩Ԃ܂ }
{ jSubstr ȂꍇCjPosByte  0 Ԃ܂ }
var
  nCount: Cardinal;
  pIndex, pChk: PChar;
begin
  Result := 0;
  if (jS <> '')and(jSubstr <> '') then begin
    nCount := 0;
    pIndex := @jS[1];
    pChk := Nil;
    While (pIndex^ <> #0)and(pChk = Nil) do begin
      pChk := StrTextComp(pIndex, @jSubstr[1]);
      Inc(nCount, StrByteInc(pIndex));
    end;
    if pChk <> Nil then Result := nCount;
  end;
end;


function TrimMid(const S: String): String;
{  S ɑ݂SĂ̔p󔒂Ɛ䕶菜܂ }
var
  pTrim: PChar;
begin
  if S = '' then
    Result := ''
  else begin
    pTrim := PChar(S);
    Result := String(StrTrim(pTrim, trMidTrim, False));
  end;
end;


function jTrimMid(const jS: String): String;
{  jS ɑ݂SĂ̋(pyёSp)Ɛ䕶菜܂ }
var
  pTrim: PChar;
begin
  if jS = '' then
    Result := ''
  else begin
    pTrim := PChar(jS);
    Result := String(StrTrim(pTrim, trMidTrim, True));
  end;
end;


function jToken(var jS: String; delimita: String): String;
{  jS ɑ݂ delimita 񒼑O܂ł̍Ԃ }
{ jS ɂ́AcꂽÊ݂̕ƂȂ }
{ Adelimita ݂Ȃ΁A߂lɑSĂ̕񂪓AjS ͋ɂȂ }
var
  nCount, nLen: Integer;
  pIndex: PChar;
  sBuf: String;
begin
  if (jS <> '')and(delimita <> '') then begin
    nLen := Length(delimita);
    pIndex := @jS[1];
    nCount := 0;
    While (pIndex^ <> #0) do begin
      if StrTextComp(pIndex, @delimita[1]) = pIndex then begin
        if nCount > 0 then
          Result := Copy(jS, 1, nCount)
        else
          Result := '';
        Inc(pIndex, nLen);
        sBuf := String(pIndex);
        nCount := -1;
        break;
      end else
        Inc(nCount, StrByteInc(pIndex));
    end;
    if nCount >= 0 then begin
      Result := jS;
      jS := '';
    end else
      jS := sBuf;
  end else begin
    Result := jS;
    jS := '';
  end;
end;


function Cating(const jS: String; const Count: Integer): String;
{  jS  Count񕪂ȂԂ }
var
  pStr, pSrc: PChar;
begin
  if (jS <> '')and(Count > 0) then begin
    pStr := StrAlloc(Length(jS) * Count + 1);
    pStr^ := #0;
    pSrc := @jS[1];
    Result := String(StrCating(pStr, pSrc, Count));
    StrDispose(pStr);
  end else
    Result := '';
end;


function CharPos(const Source, ChkChar: String): String;
{ Source  ChkChar Ŏ݂邩`FbN }
{ ChkChar ɂ́A'\/:*' ̂悤ɕ̕𓯎Ɍ邱Ƃł }
{ Sp/pƂ Source, ChkChar Ɋ܂߂邱Ƃ\(Pʂ͏ɂP̌ƂȂ) }
{ [Ԃl] ꂩ݂̑Ԃ. ΃kԂ }
var
  pBuf: PChar;
begin
  if (Source <> '')and(ChkChar <> '') then begin
    pBuf := StrCharPos(@Source[1], @ChkChar[1]);
    if pBuf = Nil then begin
      Result := '';
    end else begin
      Result := jChr(StrAsc(pBuf));
    end;
  end else
    Result := '';
end;


function ReText(const Source, ChkStr, ReStr: String): String;
{ Source  ChkStr Ŏ񂪑݂ ReStr ɒuAuꂽԂ }
{ Source, ChkStr, ReStr ɕƂȂASĂSp/pɑΉ }
{ [Ԃl] Source u }
var
  nMax, nChk, nRes: Cardinal;
  pDes: PChar;
begin
  nChk := Length(ChkStr);
  if (nChk > 0)and(Source <> '') then begin
    nRes := Length(ReStr);
    if nChk >= nRes then
      nMax := Length(Source) + 1
    else
      nMax := (Cardinal(Length(Source)) div nChk) * nRes + 3;
    pDes := StrAlloc(nMax);
    Result := String(StrReText(pDes, @Source[1], @ChkStr[1], @ReStr[1], nMax));
    StrDispose(pDes);
  end else
    Result := Source;
end;




{ ----- Public Function in PChar ----------------------------------------- }


function jStrLen(const jStr: PChar): Cardinal;
{ StrLen{: jStr ̃k^[~l[^(Sp͂P)Ԃ }
{ [Ԃl] jStr ̕(Sp͂P) }
var
  pAdr: PChar;
begin
  Result := 0;
  pAdr := jStr;
  While (pAdr^ <> #0) do begin
    StrByteInc(pAdr);
     Inc(Result);
  end;
end;


function jStrLower(const jStr: PChar; const Jis: Boolean): PChar;
{ StrLower{(): jStr SpmFȂ珬ɕϊāAjStr Ԃ }
{ Jis = True : Sp/p̉pAɂ }
{ Jis = False: p̉p̂݁Aɂ. Sp͕ϊȂ. (StrLowerftHg) }
{ [Ԃl] jStr ̐擪|C^ }
var
  pIndex: PChar;
begin
  pIndex := jStr;
  While (pIndex^ <> #0) do begin
    StrByteUpLow(pIndex, False, Jis);
  end;
  Result := jStr;
end;


function jStrUpper(const jStr: PChar; const Jis: Boolean): PChar;
{ StrUpper{(): jStr SpmFȂ啶ɕϊāAjStr Ԃ }
{ Jis = True : Sp/p̉pA啶ɂ }
{ Jis = False: p̉p̂݁A啶ɂ. Sp͕ϊȂ. (StrUpperftHg) }
{ [Ԃl] jStr ̐擪|C^ }
var
  pIndex: PChar;
begin
  pIndex := jStr;
  While (pIndex^ <> #0) do begin
    StrByteUpLow(pIndex, True, Jis);
  end;
  Result := jStr;
end;




{ ----- Public New Function in PChar ------------------------------------- }


function StrAsc(const pC: PChar): Word;
{ pC 񂪑SpȂVtgihrR[hApȂASCIIR[hԂ }
{ [Ԃl] $00`$FF:ASCIIR[h  $8140ȍ~:VtgihrR[h }
begin
  Result := GetDBCS(pC);
end;


function StrChr(const pC: PChar; const AscCode: Word): PChar;
{ AscCode ASCIIR[hȂPoCgAȊOȂQoCg }
{ [Ԃl] pC 𑝉|C^l }
begin
  if 255 >= AscCode then begin
    pC[0] := Char(AscCode and $00FF);
    Result := pC + 1;
  end else begin
    pC[0] := Char(AscCode div $0100);
    pC[1] := Char(AscCode and $00FF);
    Result := pC + 2;
  end;
end;


function StrGetWord(const pData: PChar): Word;
{ pData() pData+1() 16ޯĐlƂēǎ }
{ [Ԃl] $0000`$FFFF(Word^) ̐l }
begin
  Result := Byte(pData[1]) * 256 + Byte(pData[0]);
end;


function StrSetWord(const pData: PChar; const IntData: Word): PChar;
{ IntData 16ޯĐl pData ̂QoCgփoCif[^Ƃď }
{ [Ԃl] pData Q|C^l }
begin
  pData[0] := Char(IntData and $00FF);
  pData[1] := Char(IntData div $0100);
  Result := pData + 2;
end;


function MtoB(const jStr: PChar; const MaxLen: Integer): Cardinal;
{ jStr  MaxLen (SpP)܂ł̃oCgԂ }
{ [Ԃl] MaxLen > 0 ... w̕(SpP)܂ރoCg }
{          MaxLen = 0 ... jStr ̃kO܂ł̑oCg }
{          MaxLen < 0 ... ɂO }
begin
  if MaxLen >= 0 then begin
    MtoMB(Result, jStr, MaxLen);
  end else
    Result := 0;
end;


function BtoM(const jStr: PChar; const MaxByte: Integer): Cardinal;
{ jStr  MaxByte oCg܂ł̕(SpP)Ԃ }
{ [Ԃl] MaxByte > 0 ... w̃oCg܂ޕ(SpP) }
{          MaxByte = 0 ... jStr ̃kO܂ł̑( jStrLen  ) }
{          MaxByte < 0 ... ɂO }
var
  nCount: Integer;
  pIndex: PChar;
begin
  if MaxByte > 0 then begin
    Result := 0;
    nCount := MaxByte;
    pIndex := jStr;
    While (pIndex^ <> #0)and(nCount > 0) do begin
      Dec(nCount, StrByteInc(pIndex));
      Inc(Result);
    end;
  end else if MaxByte = 0 then begin
    Result := jStrLen(jStr);
  end else
    Result := 0;
end;


function StrCating(const Dest, Source: PChar; const Count: Integer): PChar;
{ Source  Dest ̍Ōォ Count񕪒ǉAꂽԂ }
{ Dest ɂ́A\ߒǉ镶i[ł郁pӂĂKv }
{ Dest ̍Ōɂ́Akt̂ŕƂĈƂ\ }
{ [Ԃl] Dest ̃|C^l }
var
  ni: Integer;
  pSrc, pDes: PChar;
begin
  pDes := Dest;
  While (pDes^ <> #0) do begin
    Inc(pDes);
  end;
  if Count > 0 then begin
    for ni := 1 to Count do begin
      pSrc := Source;
      While (pSrc^ <> #0) do begin
        StrByteCopy(pDes, pSrc, False);
      end;
    end;
  end;
  pDes^ := #0;
  Result := Dest;
end;


function StrTrim(const Str: PChar; const Param: Byte; const JisChk: Boolean): PChar;
{ Str  Param Ŏ@ŋ/۰ٺނ폜ɕϊĕԂ }
{ Param = trSideTrim(0), trLeftTrim(1), trRightTrim(2), trMidTrim(3) ̂ꂩw }
{ JisChk = True : SpXy[X/pXy[X/Rg[R[h폜 }
{ JisChk = False: pXy[X/Rg[R[ĥ݂폜 }
{ [Ԃl] Str ̃|C^l }
var
  rLeft, rRight: Boolean;
  pSrc, pDes, pRight: PChar;
begin
  pDes := Str;
  if (Str^ <> #0) then begin
    pSrc := Str;
    pRight := Str;
    rLeft := (Param <> trRightTrim);
    rRight := False;
    While (pSrc^ <> #0) do begin
      if IsTRIM(pSrc, JisChk) then begin
        case Param of
          trSideTrim :  begin
                          if rLeft then
                            StrByteInc(pSrc)
                          else begin
                            if NOT rRight then pRight := pDes;
                            rRight := True;
                            StrByteCopy(pDes, pSrc, True);
                          end;
                        end;
          trLeftTrim :  if rLeft then StrByteInc(pSrc) else StrByteCopy(pDes, pSrc, True);
          trRightTrim:  begin
                          if NOT rRight then pRight := pDes;
                          rRight := True;
                          StrByteCopy(pDes, pSrc, True);
                        end;
          trMidTrim  :  StrByteInc(pSrc);
        end;
      end else begin
        rLeft := False;
        rRight := False;
        StrByteCopy(pDes, pSrc, True);
      end;
    end;
    if rRight then pDes := pRight;
  end;
  pDes^ := #0;
  Result := Str;
end;


function StrCharPos(const Source, ChkChar: PChar): PChar;
{ Source  ChkChar Ŏ݂邩`FbN }
{ ChkChar ɂ́A'\/:*' ̂悤ɕ̕𓯎Ɍ邱Ƃł }
{ Sp/pƂ Source, ChkChar Ɋ܂߂邱Ƃ\(Pʂ͏ɂP̌ƂȂ) }
{ [Ԃl] ꂩ݂̕ n߂ɑ݂|C^ԂA Nil Ԃ }
var
  rChk: Boolean;
  pSrc, pChk: PChar;
  wSrc, wChk: Word;
begin
  Result := Nil;
  pSrc := Source;
  rChk := False;
  While (pSrc^ <> #0)and(rChk = False) do begin
    wSrc := StrAsc(pSrc);
    pChk := ChkChar;
    While (pChk^ <> #0)and(rChk = False) do begin
      wChk := StrAsc(pChk);
      StrByteInc(pChk);
      rChk := (wSrc = wChk);
    end;
    if rChk then begin
      Result := pSrc;
      break;
    end;
    StrByteInc(pSrc);
  end;
end;


function StrReText(const Dest, Source, ChkStr, ReStr: PChar; const MaxByte: Cardinal): PChar;
{ Source  ChkStr Ŏ񂪑݂ ReStr ɒu Dest ɃRs[ }
{ ChkStr, ReStr ɕƂȂAS̃|C^SĂSp/pɑΉ }
{ [Ԃl] Source uRs[ Dest ̐擪|C^ }
{ [] Dest ɂ́A\ߒuꂽۊǂł郁mۂAMaxByte Ɏw肷Kv }
{        MaxByte ɂ́Ak܂ރoCgw肵Ȃ΂ȂȂ }
var
  nAdd: Cardinal;
  nCount: Integer;
  pSrc, pDes, pRen: PChar;
begin
  pSrc := Source;
  pDes := Dest;
  nCount := MaxByte - 1;
  if ChkStr^ = #0 then begin
    While (pSrc^ <> #0)and(nCount > 0) do begin
      Dec(nCount, StrByteCopy(pDes, pSrc, False));
    end;
  end else begin
    nAdd := StrLen(ChkStr);
    While (pSrc^ <> #0)and(nCount > 0) do begin
      if StrTextComp(pSrc, ChkStr) = pSrc then begin
        pRen := ReStr;
        While (pRen^ <> #0)and(nCount > 0) do begin
          Dec(nCount, StrByteCopy(pDes, pRen, False));
        end;
        Inc(pSrc, nAdd);
      end else
        Dec(nCount, StrByteCopy(pDes, pSrc, True));
    end;
  end;
  pDes^ := #0;
  Result := Dest;
end;


function IsStrDBCS(const Str: PChar): Boolean;
{ Str ɑSp(DBCS)邩 }
var
  pIndex: PChar;
begin
  pIndex := Str;
  Result := False;
  While (pIndex^ <> #0) do begin
    if IsDBCS(pIndex) then begin
      Result := True;
      break;
    end;
    Inc(pIndex);
  end;
end;




{ ----- Public New Function in Etc --------------------------------------- }


function AtoI(const S: String): Integer;
{ Iɐlɕϊ. (_ȉ͐؂̂) lłȂ̏ꍇA0 ƂȂ }
var
  eBuf: Extended;
begin
  if S = '' then begin
    eBuf := 0;
  end else if S[1] = '$' then begin
    eBuf := StrToIntDef(S, 0)
  end else begin
    if NOT TextToFloat(PChar(S), eBuf, fvExtended) then eBuf := 0;
  end;
  try
    Result := Trunc(eBuf);
  except
    Result := 0;
  end;
end;


function AtoF(const S: String): Extended;
{ IɎlɕϊ. lłȂ̏ꍇA0 ƂȂ }
begin
  if S = '' then begin
    Result := 0;
  end else if S[1] = '$' then begin
    Result := StrToIntDef(S, 0)
  end else begin
    if NOT TextToFloat(PChar(S), Result, fvExtended) then Result := 0;
  end;
end;


function ByCode(const S: String): String;
{ R[hʗpƂĈɑO󔒍폜Ƒ啶s }
begin
  Result := AnsiUpperCase(jTrim(S));
end;


function Kanma(const Index: Integer; const MaxLen: Byte): String;
{ IndexlRP^ƂɃJ}(,)tɂ }
{ MaxLen > 0 : Ԃl̕̕w萔Ƃ. J}PƂ }
{              ȂꍇAɋ󔒂 }
{ MaxLen = 0 : Index Ŏw肷鐔l̕Ƃ }
var
  nKanma, ni: Byte;
  pSrc, pDes, pIndex: PChar;
  nSrcMax, nDesMax: Cardinal;
  sSrc: String;
begin
  sSrc := IntToStr(Index);
  nSrcMax := Length(sSrc);
  nDesMax := nSrcMax + (nSrcMax div 3);
  pSrc := @sSrc[nSrcMax];
  pDes := StrAlloc(nDesMax + 1);
  pIndex := pDes + nDesMax;
  nKanma := 0;
  pIndex^ := #0;
  Dec(pIndex);
  for ni := 1 to nSrcMax do
  begin
    pIndex^ := pSrc^;
    Dec(pSrc);
    Dec(pIndex);
    Inc(nKanma);
    if (nKanma >= 3)and(nSrcMax > ni) then begin
      if pSrc^ <> '-' then begin
        pIndex^ := ',';
        Dec(pIndex);
        nKanma := 0;
      end;
    end;
  end;
  Inc(pIndex);
  Result := String(pIndex);
  StrDispose(pDes);
  if MaxLen > 0 then Result := RightB(Result, MaxLen);
end;


function IEEEtoDBL(const pIEEE: Pointer): Double;
{ pIEEE Ŏ|C^WoCgIEEEtH[}bgf[^ Double^ɕϊ }
var
  ni: Integer;
  dBuf: Double;
  pSrc, pDes: PChar;
begin
  dBuf := 0;
  pSrc := pIEEE;
  pDes := @dBuf;
  for ni := 1 to 8 do begin
    pDes^ := pSrc^;
    Inc(pSrc);
    Inc(pDes);
  end;
  try
    Result := dBuf;
  except
    Result := 0;
  end;
end;


procedure DBLtoIEEE(const pIEEE: Pointer; const dIndex: Double);
{ pIEEE Ŏ|C^WoCg dIndex  Double^f[^ IEEEtH[}bgŏ }
var
  ni: Integer;
  pSrc, pDes: PChar;
begin
  pSrc := @dIndex;
  pDes := pIEEE;
  for ni := 1 to 8 do begin
    pDes^ := pSrc^;
    Inc(pSrc);
    Inc(pDes);
  end;
end;


function FileEnabled(const FileName: String): String;
{ w̃t@C(fBNg) Windows95 ŗL(HPFŞٌ`)`FbN }
{ [Ԃl] Lȏꍇ́At@CƂĈ悤ɕϊAԂ. ̓k }
var
  sName: String;
begin
  sName := Trim(FileName);
  Result := '';
  if (sName <> '') then begin
    if (sName[1] <> '.')and(232 >= Length(sName))and(CharPos(sName, '\/:*?"<>|') = '') then
      Result := sName;
  end;
end;


function DosFileEnabled(const FileName: String): String;
{ w̃t@C(fBNg) MS-DOS ŗL(FAŢ 8.3`)`FbN }
{ [Ԃl] Lȏꍇ́At@CƂĈ悤ɕϊAԂ. ̓k }
var
  rChk: Boolean;
  sName, sSub: String;
begin
  Result := '';
  if FileName <> '' then begin
    sSub := FileName;
    sName := ByCode(jToken(sSub, '.'));
    sSub := ByCode(sSub);
    rChk := (sName <> '')and(8 >= Length(sName))and(3 >= Length(sSub));
    if rChk then begin
      rChk := (sName <> 'CON')and(sName <> 'AUX')and(sName <> 'PRN')and(sName <> 'NUL')
              and(sName <> 'COM1')and(sName <> 'COM2')and(sName <> 'COM3')and(sName <> 'COM4')
              and(sName <> 'LPT1')and(sName <> 'LPT2')and(sName <> 'LPT3')
              and(CharPos(sName, '.\/:;*?"[]|=,' ) = '')and(CharPos(sSub, '.\/:;*?"[]|=,' ) = '');
      if rChk then begin
        sName := ReText(sName, '[', '_');
        sName := ReText(sName, ']', '_');
        sSub := ReText(sSub, '[', '_');
        sSub := ReText(sSub, ']', '_');
      end;
      if rChk then begin
        if sSub = '' then
          Result := sName
        else
          Result := sName + '.' + sSub;
      end;
    end;
  end;
end;


end.
