unit Option;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons;

type
  TFormOption = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;

    Panel1: TPanel;

    BtnOK: TButton;
    BtnCancel: TButton;
    BtnBrowse1: TButton;
    BtnBrowse2: TButton;
    BtnBrowse3: TButton;
    BtnBrowse4: TButton;
    BtnFolderUpBookmark: TButton;
    BtnFolderDownBookmark: TButton;
    BtnFolderDeleteBookmark: TButton;
    BtnFindUpBookmark: TButton;
    BtnFindDownBookmark: TButton;
    BtnFindDeleteBookmark: TButton;
    BtnFolderMove: TButton;
    BtnFindMove: TButton;
    BtnFolderDeleteNormal: TButton;
    BtnFindDeleteNormal: TButton;

    Edit1: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit21: TEdit;
    Edit22: TEdit;
    Edit23: TEdit;
    Edit24: TEdit;
    Edit25: TEdit;
    Edit26: TEdit;
    Edit27: TEdit;
    Edit28: TEdit;
    Edit29: TEdit;
    Edit31: TEdit;
    Edit32: TEdit;
    Edit33: TEdit;
    Edit34: TEdit;
    Edit35: TEdit;
    Edit36: TEdit;
    Edit37: TEdit;
    Edit38: TEdit;
    Edit61: TEdit;
    Edit62: TEdit;
    Edit63: TEdit;

    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label41: TLabel;
    Label42: TLabel;

    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    OpenDialog3: TOpenDialog;
    OpenDialog4: TOpenDialog;

    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox21: TCheckBox;
    CheckBox22: TCheckBox;
    CheckBox23: TCheckBox;
    CheckBox24: TCheckBox;
    CheckBox25: TCheckBox;
    CheckBox26: TCheckBox;
    CheckBox27: TCheckBox;
    CheckBox28: TCheckBox;
    CheckBox29: TCheckBox;
    CheckBox31: TCheckBox;
    CheckBox61: TCheckBox;
    CheckBox62: TCheckBox;
    CheckBox63: TCheckBox;

    ListBox11: TListBox;
    ListBox12: TListBox;
    ListBox21: TListBox;
    ListBox22: TListBox;

    RadioGroup1: TRadioGroup;

    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);

    procedure BtnBrowse1Click(Sender: TObject);
    procedure BtnBrowse2Click(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure BtnFolderUpBookmarkClick(Sender: TObject);
    procedure BtnFolderDownBookmarkClick(Sender: TObject);
    procedure BtnFolderDeleteBookmarkClick(Sender: TObject);
    procedure BtnFindUpBookmarkClick(Sender: TObject);
    procedure BtnFindDownBookmarkClick(Sender: TObject);
    procedure BtnFindDeleteBookmarkClick(Sender: TObject);
    procedure BtnFindDeleteNormalClick(Sender: TObject);
    procedure BtnFolderDeleteNormalClick(Sender: TObject);
    procedure BtnFolderMoveClick(Sender: TObject);
    procedure BtnFindMoveClick(Sender: TObject);

    procedure LanguageChange(Sender: TObject);
    procedure ListBox11DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox12DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox21DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure ListBox22DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure BtnBrowse3Click(Sender: TObject);
    procedure BtnBrowse4Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  FormOption: TFormOption;

implementation

uses Main;

{$R *.dfm}

procedure TFormOption.LanguageChange(Sender: TObject);
begin
  //{
  if FormMain.MenuJapaneseSet.Checked = TRUE then
  begin
    Tabsheet1.Caption  := 'ިݒ';
    Tabsheet2.Caption  := 'ݒ';
    Tabsheet3.Caption  := '̧وꗗݒ';
    Tabsheet4.Caption  := '̫ްޯϰݒ';
    Tabsheet5.Caption  := 'ޯϰݒ';
    BtnBrowse1.Caption := 'Q(&B)';
    BtnBrowse2.Caption := 'Q(&A)';
    BtnBrowse3.Caption := 'Q(&M)';
    BtnBrowse4.Caption := 'Q(&N)';
    Label1.Caption     := 'Ώۊgq(&Z):';
    Label2.Caption     := 'Ώ̧ٖ(&T):';
    Label3.Caption     := '`҂(&W):';
    Label11.Caption    := 'ި1(&E):';
    Label12.Caption    := '߼1(&F):';
    Label13.Caption    := 'ި2(&G):';
    Label14.Caption    := '߼2(&H):';
    Label15.Caption    := 'ި3(&I):';
    Label16.Caption    := '߼3(&J):';
    Label17.Caption    := 'ި4(&K):';
    Label18.Caption    := '߼4(&L):';
    Label31.Caption    := 'ʏ';
    Label32.Caption    := 'ޯϰ';
    Label41.Caption    := 'ʏ';
    Label42.Caption    := 'ޯϰ';
    CheckBox1.Caption  := '啶ʂ(&A)';
    CheckBox2.Caption  := 'PPʂŒT(&W)';
    CheckBox3.Caption  := 'SppʂȂ(&Z)';
    CheckBox4.Caption  := 's𖳎(&L)';
    CheckBox5.Caption  := 'Xy[X𖳎(&P)';
    CheckBox31.Caption := '̫ތ(&U)';
    RadioGroup1.Caption          :='̧ٿ(&S)';
    RadioGroup1.Items.Strings[0] := 'None';
    RadioGroup1.Items.Strings[1] := 'AtoZ';
    RadioGroup1.Items.Strings[2] := 'ZtoA';
    CheckBox11.Caption := 'L';
    CheckBox12.Caption := 'L';
    CheckBox13.Caption := 'L';
    CheckBox21.Caption := 'L';
    CheckBox22.Caption := 'L';
    CheckBox23.Caption := 'L';
    CheckBox24.Caption := 'L';
    CheckBox25.Caption := 'L';
    CheckBox26.Caption := 'L';
    CheckBox27.Caption := 'L';
    CheckBox28.Caption := 'L';
    CheckBox29.Caption := 'L';
    CheckBox61.Caption := '';
    CheckBox62.Caption := '';
    CheckBox63.Caption := '';
  end
  //p
  else
  begin
    Tabsheet1.Caption  := 'EditorSetting';
    Tabsheet2.Caption  := 'SearchOptions';
    Tabsheet3.Caption  := 'FileListSetting';
    Tabsheet4.Caption  := 'FolderBookMarkSetting';
    Tabsheet5.Caption  := 'FindBookMarkSetting';
    BtnBrowse1.Caption := 'Browse(&B)';
    BtnBrowse2.Caption := 'Browse(&A)';
    BtnBrowse3.Caption := 'Browse(&M)';
    BtnBrowse4.Caption := 'Browse(&N)';
    Label1.Caption     := 'TargetFileExt(&Z):';
    Label2.Caption     := 'TargetFileName(&T):';
    Label3.Caption     := 'DrawWaitTime(&W):';
    Label11.Caption    := 'Editor1(&E):';
    Label12.Caption    := 'Option1(&F):';
    Label13.Caption    := 'Editor2(&G):';
    Label14.Caption    := 'Option2(&H):';
    Label15.Caption    := 'Editor3(&I):';
    Label16.Caption    := 'Option3(&J):';
    Label17.Caption    := 'Editor4(&K):';
    Label18.Caption    := 'Option4(&L):';
    Label31.Caption    := 'Normal';
    Label32.Caption    := 'BookMark';
    Label41.Caption    := 'Normal';
    Label42.Caption    := 'BookMark';
    CheckBox1.Caption  := 'MatchCase(&A)';
    CheckBox2.Caption  := 'WholeWord(&W)';
    CheckBox3.Caption  := 'NoMatchZenkaku(&Z)';
    CheckBox4.Caption  := 'IncludeCrLf(&L)';
    CheckBox5.Caption  := 'IncludeSpace(&P)';
    CheckBox31.Caption := 'FindSubFolder(&U)';
    RadioGroup1.Caption          :='FileSort(&S)';
    RadioGroup1.Items.Strings[0] := 'None';
    RadioGroup1.Items.Strings[1] := 'AtoZ';
    RadioGroup1.Items.Strings[2] := 'ZtoA';
    CheckBox11.Caption := 'Enabled';
    CheckBox12.Caption := 'Enabled';
    CheckBox13.Caption := 'Enabled';
    CheckBox21.Caption := 'Enabled';
    CheckBox22.Caption := 'Enabled';
    CheckBox23.Caption := 'Enabled';
    CheckBox24.Caption := 'Enabled';
    CheckBox25.Caption := 'Enabled';
    CheckBox26.Caption := 'Enabled';
    CheckBox27.Caption := 'Enabled';
    CheckBox28.Caption := 'Enabled';
    CheckBox29.Caption := 'Enabled';
    CheckBox61.Caption := 'Desabled';
    CheckBox62.Caption := 'Desabled';
    CheckBox63.Caption := 'Desabled';
  end;
end;

procedure TFormOption.FormCreate(Sender: TObject);
begin
  //ݒ
  PageControl1.TabStop := FALSE;
  //ݒ
  FormOption.KeyPreview := TRUE;
  //ݒ
  ListBox11.Style :=lbOwnerDrawFixed;
  ListBox12.Style :=lbOwnerDrawFixed;
  ListBox21.Style :=lbOwnerDrawFixed;
  ListBox22.Style :=lbOwnerDrawFixed;
  //ݒ
  Edit1.MaxLength := 4;
  //͎gpȂ
  Label3.Visible := FALSE;
  Label4.Visible := FALSE;
  Label5.Visible := FALSE;
  Edit1.Visible := FALSE;
end;

procedure TFormOption.FormShow(Sender: TObject);
var
  iIndex: Integer;
begin
  //f
  Edit31.Text        := FormMain.sEditorFileName[0];
  Edit32.Text        := FormMain.sEditorOption  [0];
  Edit33.Text        := FormMain.sEditorFileName[1];
  Edit34.Text        := FormMain.sEditorOption  [1];
  Edit35.Text        := FormMain.sEditorFileName[2];
  Edit36.Text        := FormMain.sEditorOption  [2];
  Edit37.Text        := FormMain.sEditorFileName[3];
  Edit38.Text        := FormMain.sEditorOption  [3];
  //f
  Edit61.Text        := FormMain.saTargetFileNameNot[0];
  Edit62.Text        := FormMain.saTargetFileNameNot[1];
  Edit63.Text        := FormMain.saTargetFileNameNot[2];
  //f
  Edit11.Text        := FormMain.saTargetFileName[0];
  Edit12.Text        := FormMain.saTargetFileName[1];
  Edit13.Text        := FormMain.saTargetFileName[2];
  //f
  Edit21.Text        := FormMain.saTargetFileExt[0];
  Edit22.Text        := FormMain.saTargetFileExt[1];
  Edit23.Text        := FormMain.saTargetFileExt[2];
  Edit24.Text        := FormMain.saTargetFileExt[3];
  Edit25.Text        := FormMain.saTargetFileExt[4];
  Edit26.Text        := FormMain.saTargetFileExt[5];
  Edit27.Text        := FormMain.saTargetFileExt[6];
  Edit28.Text        := FormMain.saTargetFileExt[7];
  Edit29.Text        := FormMain.saTargetFileExt[8];
  //f
  CheckBox1.Checked  := FormMain.bsfrMatchCase;
  CheckBox2.Checked  := FormMain.bsfrWholeWord;
  CheckBox3.Checked  := FormMain.bsfrNoMatchZenkaku;
  CheckBox4.Checked  := FormMain.bsfrIncludeCRLF;
  CheckBox5.Checked  := FormMain.bsfrIncludeSpace;
  //f
  CheckBox61.Checked := FormMain.baTargetFileNameNot[0];
  CheckBox62.Checked := FormMain.baTargetFileNameNot[1];
  CheckBox63.Checked := FormMain.baTargetFileNameNot[2];
  //f
  CheckBox11.Checked := FormMain.baTargetFileName[0];
  CheckBox12.Checked := FormMain.baTargetFileName[1];
  CheckBox13.Checked := FormMain.baTargetFileName[2];
  //f
  CheckBox21.Checked := FormMain.baTargetFileExt[0];
  CheckBox22.Checked := FormMain.baTargetFileExt[1];
  CheckBox23.Checked := FormMain.baTargetFileExt[2];
  CheckBox24.Checked := FormMain.baTargetFileExt[3];
  CheckBox25.Checked := FormMain.baTargetFileExt[4];
  CheckBox26.Checked := FormMain.baTargetFileExt[5];
  CheckBox27.Checked := FormMain.baTargetFileExt[6];
  CheckBox28.Checked := FormMain.baTargetFileExt[7];
  CheckBox29.Checked := FormMain.baTargetFileExt[8];
  //f
  RadioGroup1.ItemIndex := FormMain.iFileSortType;
  //f
  CheckBox31.Checked := FormMain.bFindSubFolder;
  //ݒ
  OpenDialog1.InitialDir := ExtractFileDir (FormMain.sEditorFileName[0]);
  OpenDialog1.FileName   :=                 FormMain.sEditorFileName[0];
  OpenDialog2.InitialDir := ExtractFileDir (FormMain.sEditorFileName[1]);
  OpenDialog2.FileName   :=                 FormMain.sEditorFileName[1];
  OpenDialog3.InitialDir := ExtractFileDir (FormMain.sEditorFileName[2]);
  OpenDialog3.FileName   :=                 FormMain.sEditorFileName[2];
  OpenDialog4.InitialDir := ExtractFileDir (FormMain.sEditorFileName[3]);
  OpenDialog4.FileName   :=                 FormMain.sEditorFileName[3];
  //ݒ
  LanguageChange(Sender);
  //f
  Listbox11.Items.Clear;
  for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    ListBox11.Items.Add(FormMain.saHistoryFolderNormal[iIndex]);
  end;
  ListBox11.ItemIndex := 0;
  //f
  Listbox12.Items.Clear;
  for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    ListBox12.Items.Add(FormMain.saHistoryFolderBookmark[iIndex]);
  end;
  ListBox12.ItemIndex := 0;
  //f
  Listbox21.Items.Clear;
  for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    ListBox21.Items.Add(FormMain.saHistoryFindNormal[iIndex]);
  end;
  ListBox21.ItemIndex := 0;
  //f
  Listbox22.Items.Clear;
  for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    ListBox22.Items.Add(FormMain.saHistoryFindBookmark[iIndex]);
  end;
  ListBox22.ItemIndex := 0;
  //f
  Edit1.Text := FormMain.sDrawWaitTime;

  //tH[JXݒ
  if TabSheet1.TabVisible = TRUe then
  begin
    BtnBrowse1.SetFocus;
  end;
  if TabSheet2.TabVisible = TRUe then
  begin
    CheckBox1.SetFocus;
  end;
  if TabSheet3.TabVisible = TRUe then
  begin
    CheckBox21.SetFocus;
  end;
  if TabSheet4.TabVisible = TRUe then
  begin
    ListBox12.SetFocus;
  end;
  if TabSheet5.TabVisible = TRUe then
  begin
    ListBox22.SetFocus;
  end;
end;

procedure TFormOption.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESCAPE
  if (key = VK_ESCAPE) then
  begin
    Close;
  end
  //̑
  else
  begin
    ;
  end;
end;

procedure TFormOption.BtnOKClick(Sender: TObject);
var
  iIndex: Integer;
begin
  //͈͊mF
  if (StrToInt(Edit1.Text) > DRAW_WAITE_TIME_MAX) or
     (StrToInt(Edit1.Text) < DRAW_WAITE_TIME_MIN) then
  begin
    FormMain.MsgDrawWaitTimeIsOutOfRange(Self);
    Edit1.SetFocus;
    Exit;
  end;
  //f
  FormMain.sEditorFileName[0]  := Edit31.Text;
  FormMain.sEditorOption  [0]  := Edit32.Text;
  FormMain.sEditorFileName[1]  := Edit33.Text;
  FormMain.sEditorOption  [1]  := Edit34.Text;
  FormMain.sEditorFileName[2]  := Edit35.Text;
  FormMain.sEditorOption  [2]  := Edit36.Text;
  FormMain.sEditorFileName[3]  := Edit37.Text;
  FormMain.sEditorOption  [3]  := Edit38.Text;
  //f
  FormMain.saTargetFileNameNot[0] := Edit61.Text;
  FormMain.saTargetFileNameNot[1] := Edit62.Text;
  FormMain.saTargetFileNameNot[2] := Edit63.Text;
  //f
  FormMain.saTargetFileName[0] := Edit11.Text;
  FormMain.saTargetFileName[1] := Edit12.Text;
  FormMain.saTargetFileName[2] := Edit13.Text;
  //f
  FormMain.saTargetFileExt [0] := Edit21.Text;
  FormMain.saTargetFileExt [1] := Edit22.Text;
  FormMain.saTargetFileExt [2] := Edit23.Text;
  FormMain.saTargetFileExt [3] := Edit24.Text;
  FormMain.saTargetFileExt [4] := Edit25.Text;
  FormMain.saTargetFileExt [5] := Edit26.Text;
  FormMain.saTargetFileExt [6] := Edit27.Text;
  FormMain.saTargetFileExt [7] := Edit28.Text;
  FormMain.saTargetFileExt [8] := Edit29.Text;
  //f
  FormMain.bsfrMatchCase       := CheckBox1.Checked;
  FormMain.bsfrWholeWord       := CheckBox2.Checked;
  FormMain.bsfrNoMatchZenkaku  := CheckBox3.Checked;
  FormMain.bsfrIncludeCRLF     := CheckBox4.Checked;
  FormMain.bsfrIncludeSpace    := CheckBox5.Checked;
  //f
  FormMain.baTargetFileNameNot[0] := CheckBox61.Checked;
  FormMain.baTargetFileNameNot[1] := CheckBox62.Checked;
  FormMain.baTargetFileNameNot[2] := CheckBox63.Checked;
  //f
  FormMain.baTargetFileName[0] := CheckBox11.Checked;
  FormMain.baTargetFileName[1] := CheckBox12.Checked;
  FormMain.baTargetFileName[2] := CheckBox13.Checked;
  //f
  FormMain.baTargetFileExt[0]  := CheckBox21.Checked;
  FormMain.baTargetFileExt[1]  := CheckBox22.Checked;
  FormMain.baTargetFileExt[2]  := CheckBox23.Checked;
  FormMain.baTargetFileExt[3]  := CheckBox24.Checked;
  FormMain.baTargetFileExt[4]  := CheckBox25.Checked;
  FormMain.baTargetFileExt[5]  := CheckBox26.Checked;
  FormMain.baTargetFileExt[6]  := CheckBox27.Checked;
  FormMain.baTargetFileExt[7]  := CheckBox28.Checked;
  FormMain.baTargetFileExt[8]  := CheckBox29.Checked;
  //f
  FormMain.iFileSortType := RadioGroup1.ItemIndex;
  //f
  FormMain.bFindSubFolder      := CheckBox31.Checked;
  //f
  for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    FormMain.saHistoryFolderNormal[iIndex] := ListBox11.Items.Strings[iIndex];
  end;
  //f
  for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    FormMain.saHistoryFolderBookmark[iIndex] := ListBox12.Items.Strings[iIndex];
  end;
  //f
  for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    FormMain.saHistoryFindNormal[iIndex] := ListBox21.Items.Strings[iIndex];
  end;
  //f
  for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    FormMain.saHistoryFindBookmark[iIndex] := ListBox22.Items.Strings[iIndex];
  end;
  //f
  FormMain.sDrawWaitTime := Edit1.Text;

  //I
  Close;
end;

procedure TFormOption.BtnCancelClick(Sender: TObject);
begin
  //I
  Close;
end;

procedure TFormOption.BtnBrowse1Click(Sender: TObject);
begin
  //ݒ
  if OpenDialog1.Execute = TRUE then
  begin
    Edit31.Text := OpenDialog1.FileName;
  end;
end;

procedure TFormOption.BtnBrowse2Click(Sender: TObject);
begin
  //ݒ
  if OpenDialog2.Execute = TRUE then
  begin
    Edit33.Text := OpenDialog2.FileName;
  end;
end;

procedure TFormOption.BtnBrowse3Click(Sender: TObject);
begin
  //ݒ
  if OpenDialog3.Execute = TRUE then
  begin
    Edit35.Text := OpenDialog3.FileName;
  end;
end;

procedure TFormOption.BtnBrowse4Click(Sender: TObject);
begin
  //ݒ
  if OpenDialog4.Execute = TRUE then
  begin
    Edit37.Text := OpenDialog4.FileName;
  end;
end;

procedure TFormOption.BtnFolderDeleteNormalClick(Sender: TObject);
var
  IndexNow: Integer;
  ListBox: TListBox;
begin
  //ݒ
  ListBox := ListBox11;
  //݂
  if ListBox.Items.Strings[ListBox.ItemIndex  ] = '' then
  begin
    Exit;
  end;
  //݈ʒuLāA폜āAŌɋ󔒂ǉāA݈ʒuێ
  IndexNow := ListBox.ItemIndex;
  ListBox.Items.Delete(ListBox.ItemIndex);
  ListBox.Items.Add('');
  ListBox.ItemIndex := IndexNow;
end;

procedure TFormOption.BtnFolderUpBookmarkClick(Sender: TObject);
var
  IndexNow: Integer;
  ListBox: TListBox;
begin
  //ݒ
  ListBox := ListBox12;
  //Y
  if ListBox.ItemIndex = 0 then
  begin
    Exit;
  end;
  //󔒂̐ݒ
  if ListBox.Items.Strings[ListBox.ItemIndex] = '' then
  begin
    Exit;
  end;
  //݈ʒuLāAւāA݈ʒuɈړ
  IndexNow := ListBox.ItemIndex;
  ListBox.Items.Move(ListBox.ItemIndex, ListBox.ItemIndex-1);
  ListBox.ItemIndex := IndexNow-1;
end;

procedure TFormOption.BtnFolderDownBookmarkClick(Sender: TObject);
var
  IndexNow: Integer;
  ListBox: TListBox;
begin
  //ݒ
  ListBox := ListBox12;
  //Y
  if ListBox.ItemIndex = ListBox.Count-1 then
  begin
    Exit;
  end;
  //݂
  if ListBox.Items.Strings[ListBox.ItemIndex  ] = '' then
  begin
    Exit;
  end;
  //
  if ListBox.Items.Strings[ListBox.ItemIndex+1] = '' then
  begin
    Exit;
  end;
  //݈ʒuLāAւāA݈ʒuɈړ
  IndexNow := ListBox.ItemIndex;
  ListBox.Items.Move(ListBox.ItemIndex, ListBox.ItemIndex+1);
  ListBox.ItemIndex := IndexNow+1;
end;

procedure TFormOption.BtnFindDeleteNormalClick(Sender: TObject);
var
  IndexNow: Integer;
  ListBox: TListBox;
begin
  //ݒ
  ListBox := ListBox21;
  //݂
  if ListBox.Items.Strings[ListBox.ItemIndex  ] = '' then
  begin
    Exit;
  end;
  //݈ʒuLāA폜āAŌɋ󔒂ǉāA݈ʒuێ
  IndexNow := ListBox.ItemIndex;
  ListBox.Items.Delete(ListBox.ItemIndex);
  ListBox.Items.Add('');
  ListBox.ItemIndex := IndexNow;
end;

procedure TFormOption.BtnFolderDeleteBookmarkClick(Sender: TObject);
var
  IndexNow: Integer;
  ListBox: TListBox;
begin
  //ݒ
  ListBox := ListBox12;
  //݂
  if ListBox.Items.Strings[ListBox.ItemIndex  ] = '' then
  begin
    Exit;
  end;
  //݈ʒuLāA폜āAŌɋ󔒂ǉāA݈ʒuێ
  IndexNow := ListBox.ItemIndex;
  ListBox.Items.Delete(ListBox.ItemIndex);
  ListBox.Items.Add('');
  ListBox.ItemIndex := IndexNow;
end;

procedure TFormOption.BtnFindUpBookmarkClick(Sender: TObject);
var
  IndexNow: Integer;
  ListBox: TListBox;
begin
  //ݒ
  ListBox := ListBox22;
  //Y
  if ListBox.ItemIndex = 0 then
  begin
    Exit;
  end;
  //݂
  if ListBox.Items.Strings[ListBox.ItemIndex] = '' then
  begin
    Exit;
  end;
  //݈ʒuLāAւāA݈ʒuɈړ
  IndexNow := ListBox.ItemIndex;
  ListBox.Items.Move(ListBox.ItemIndex, ListBox.ItemIndex-1);
  ListBox.ItemIndex := IndexNow-1;
end;

procedure TFormOption.BtnFindDownBookmarkClick(Sender: TObject);
var
  IndexNow: Integer;
  ListBox: TListBox;
begin
  //ݒ
  ListBox := ListBox22;
  //Y
  if ListBox.ItemIndex = ListBox.Count-1 then
  begin
    Exit;
  end;
  //݂
  if ListBox.Items.Strings[ListBox.ItemIndex  ] = '' then
  begin
    Exit;
  end;
  //
  if ListBox.Items.Strings[ListBox.ItemIndex+1] = '' then
  begin
    Exit;
  end;
  //݈ʒuLāAւāA݈ʒuɈړ
  IndexNow := ListBox.ItemIndex;
  ListBox.Items.Move(ListBox.ItemIndex, ListBox.ItemIndex+1);
  ListBox.ItemIndex := IndexNow+1;
end;

procedure TFormOption.BtnFindDeleteBookmarkClick(Sender: TObject);
var
  IndexNow: Integer;
  ListBox: TListBox;
begin
  //ݒ
  ListBox := ListBox22;
  //݂
  if ListBox.Items.Strings[ListBox.ItemIndex  ] = '' then
  begin
    Exit;
  end;
  //݈ʒuLāA폜āAŌɋ󔒂ǉāA݈ʒuێ
  IndexNow := ListBox.ItemIndex;
  ListBox.Items.Delete(ListBox.ItemIndex);
  ListBox.Items.Add('');
  ListBox.ItemIndex := IndexNow;
end;

procedure TFormOption.BtnFolderMoveClick(Sender: TObject);
begin
  //݂
  if ListBox11.Items.Strings[ListBox11.ItemIndex  ] = '' then
  begin
    Exit;
  end;
  //Ōオ
  if ListBox12.Items.Strings[ListBox12.Count-1] <> '' then
  begin
    Exit;
  end;
  //擪폜āA擪ɒǉ
  ListBox12.Items.Delete(ListBox12.Count-1);
  ListBox12.Items.Insert(0, ListBox11.Items.Strings[ListBox11.ItemIndex]);
  ListBox12.ItemIndex := 0;
end;

procedure TFormOption.BtnFindMoveClick(Sender: TObject);
begin
  //݂
  if ListBox21.Items.Strings[ListBox21.ItemIndex  ] = '' then
  begin
    Exit;
  end;
  //Ōオ
  if ListBox22.Items.Strings[ListBox22.Count-1] <> '' then
  begin
    Exit;
  end;
  //擪폜āA擪ɒǉ
  ListBox22.Items.Delete(ListBox22.Count-1);
  ListBox22.Items.Insert(0, ListBox21.Items.Strings[ListBox21.ItemIndex]);
  ListBox22.ItemIndex := 0;
end;

procedure TFormOption.ListBox11DrawItem(Control: TWinControl;  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  ListBox: TListBox;
begin
  //ݒ
  ListBox := ListBox11;
  //tH[JX
  if Listbox.Focused = TRUE then
  begin
    //I
    if odSelected in State then
    begin
      Listbox.Canvas.Brush.Color := clSkyBlue;
      Listbox.Canvas.Font.Color := clWindowText;
    end;
  end
  //tH[JXȂ
  else
  begin
    //I
    if odSelected in State then
    begin
      Listbox.Canvas.Brush.Color := clLtGray;
      Listbox.Canvas.Font.Color := clWindowText;
    end;
  end;
  //\
  Listbox.Canvas.FillRect(Rect);
  Listbox.Canvas.TextOut(Rect.Left, Rect.Top, Listbox.Items[Index]);
end;

procedure TFormOption.ListBox12DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  ListBox: TListBox;
begin
  //ݒ
  ListBox := ListBox12;
  //tH[JX
  if Listbox.Focused = TRUE then
  begin
    //I
    if odSelected in State then
    begin
      Listbox.Canvas.Brush.Color := clSkyBlue;
      Listbox.Canvas.Font.Color := clWindowText;
    end;
  end
  //tH[JXȂ
  else
  begin
    //I
    if odSelected in State then
    begin
      Listbox.Canvas.Brush.Color := clLtGray;
      Listbox.Canvas.Font.Color := clWindowText;
    end;
  end;
  //\
  Listbox.Canvas.FillRect(Rect);
  Listbox.Canvas.TextOut(Rect.Left, Rect.Top, Listbox.Items[Index]);
end;

procedure TFormOption.ListBox21DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  ListBox: TListBox;
begin
  //ݒ
  ListBox := ListBox21;
  //tH[JX
  if Listbox.Focused = TRUE then
  begin
    //I
    if odSelected in State then
    begin
      Listbox.Canvas.Brush.Color := clSkyBlue;
      Listbox.Canvas.Font.Color := clWindowText;
    end;
  end
  //tH[JXȂ
  else
  begin
    //I
    if odSelected in State then
    begin
      Listbox.Canvas.Brush.Color := clLtGray;
      Listbox.Canvas.Font.Color := clWindowText;
    end;
  end;
  //\
  Listbox.Canvas.FillRect(Rect);
  Listbox.Canvas.TextOut(Rect.Left, Rect.Top, Listbox.Items[Index]);
end;

procedure TFormOption.ListBox22DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  ListBox: TListBox;
begin
  //ݒ
  ListBox := ListBox22;
  //tH[JX
  if Listbox.Focused = TRUE then
  begin
    //I
    if odSelected in State then
    begin
      Listbox.Canvas.Brush.Color := clSkyBlue;
      Listbox.Canvas.Font.Color := clWindowText;
    end;
  end
  //tH[JXȂ
  else
  begin
    //I
    if odSelected in State then
    begin
      Listbox.Canvas.Brush.Color := clLtGray;
      Listbox.Canvas.Font.Color := clWindowText;
    end;
  end;
  //\
  Listbox.Canvas.FillRect(Rect);
  Listbox.Canvas.TextOut(Rect.Left, Rect.Top, Listbox.Items[Index]);
end;

procedure TFormOption.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if (Pos(Key, '0123456789') = 0) and (Ord(Key) <> VK_BACK) then
  begin
    Key := #0;
  end;
end;

end.
