unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, HEditor, HtSearch,
  IniFiles, SHBFFEX, MyUtil, Shellapi, Grids, Menus, StrUtils, Jstring, Jpeg,
  ComCtrls;

  const
  //xɁA{^EnabledύXƁAh߂̑Ή
  //y[Wł̓JEgȂy[WŃJEĝ 2 ɐݒ
  FIND_WORD_CONTROL_COUNT = 2;
  //\uŏI点Ȃׂɐݒ msP
  SLEEP_TIME1 = 300;
  //EnterL[̉摜\ŃL[̖Ԃݒ msP
  WAIT_TIME_MIN =  300;
  WAIT_TIME_MAX = 1000;

  FORM_CAPTION = 'BONZO(Main)';
  RESERVED_SET = 'RESERVED_SET.TXT';
  RESERVED_HIS = 'RESERVED_HIS.TXT';
  FILE_INDEX   = 'FILE_INDEX.TXT';
  SEPARATE_MARKER = '====================';
  FOLDER_COMBO_BOX_ITEM_NUMBER = 30;
  FIND_COMBO_BOX_ITEM_NUMBER   = 30;
  FORM_MAIN_WIDTH_SET  =  970;
  FORM_MAIN_HEIGHT_SET =  740;
  LISTBOX_WIDTH_SET    =  140;
  GRID_WIDTH           =  128;
  BTN_INIT         = 0;
  BTN_HELP         = 1;
  BTN_FILELIST     = 2;
  BTN_RESERVED     = 3;
  BTN_INDEX        = 4;
  PREV_WORD        = 0;
  NEXT_WORD        = 1;
  INIT_MODE        = 0;
  TEXT_MODE        = 1;
  GRID_MODE        = 2;
  STRETCH_MODE     = 3;
  ORIGINAL_MODE    = 4;
  DRAW_TYPE_FIT    = -1;
  DRAW_TYPE_AUTO   = 0;
  SCANALLY_SIZE    = 16384;
  DRAW_WAITE_TIME_MAX   = 3000;
  DRAW_WAITE_TIME_MIN   =   10;
  DRAW_WAITE_SIZE_CONST1 = 0.000254; // y=ax+b a=(800-300)ms / (2,154,000-189,000)byte
  DRAW_WAITE_SIZE_CONST2 = 252;      // y=ax+b b=800-(a*2,154,000)

type
  TRGBStr =  packed record
    B, G, R: Byte;  //oCg̕ѕ B > G > R Ȃ̂
  end;
  TRGBArray = array [0..SCANALLY_SIZE] of TRGBStr;
  PRGBArray = ^TRGBArray;

type
  TFormMain = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;

    BtnPrevFile: TButton;
    BtnNextFile: TButton;
    BtnPageUp: TButton;
    BtnPageDown: TButton;
    BtnBrowse: TButton;
    BtnReLoad: TButton;
    BtnPrevWord: TButton;
    BtnNextWord: TButton;
    BtnFileSave: TButton;
    BtnFileList: TButton;
    BtnReserved: TButton;
    BtnReservedSave: TButton;
    BtnReadIndex: TButton;
    BtnMakeIndex: TButton;
    BtnSaveIndex: TButton;
    BtnHelp: TButton;
    BtnPrevView: TButton;
    BtnNextView: TButton;
    BtnStopListFile: TButton;
    BtnStopSearchWord: TButton;

    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label7: TLabel;

    ColorDialog1: TColorDialog;
    ColorDialog2: TColorDialog;
    ColorDialog3: TColorDialog;

    Editor1: TEditor;
    Editor2: TEditor;
    Editor4: TEditor;
    Editor3: TEditor;
    Editor5: TEditor;
    Editor10: TEditor;

    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;

    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox21: TCheckBox;
    CheckBox22: TCheckBox;
    CheckBox23: TCheckBox;
    CheckBox24: TCheckBox;
    Image11: TImage;
    Image12: TImage;

    SaveDialog1: TSaveDialog;
    SHBrowseForFolderEx1: TSHBrowseForFolderEx;
    StringGrid1: TStringGrid;
    ListBox1: TListBox;
    Edit1: TEdit;
    Splitter1: TSplitter;
    ScrollBox1: TScrollBox;

    Timer1: TTimer;
    Timer2: TTimer;

    MainMenu: TMainMenu;
    MenuFile: TMenuItem;
    MenuQuit: TMenuItem;
    MenuSearch: TMenuItem;
    MenuJapaneseSet: TMenuItem;
    MenuSetEditor: TMenuItem;
    MenuEditor1Execute: TMenuItem;
    MenuEditor2Execute: TMenuItem;
    MenuFind: TMenuItem;
    MenuPrevWord: TMenuItem;
    MenuNextWord: TMenuItem;
    MenuFileSaveAs: TMenuItem;
    MenuEditorFontColor: TMenuItem;
    MenuViewerFontColor: TMenuItem;
    MenuReservedWordFontColor: TMenuItem;
    MenuGridMode: TMenuItem;
    MenuOptions: TMenuItem;
    MenuSeparetor1: TMenuItem;
    MenuSeparetor2: TMenuItem;
    MenuSeparetor3: TMenuItem;
    MenuSeparetor4: TMenuItem;
    MenuSearchOptions: TMenuItem;
    MenuSeparetor5: TMenuItem;
    MenuGridWidth: TMenuItem;
    MenuFileListSetting: TMenuItem;
    MenuEditMode: TMenuItem;
    MenuSeparetor6: TMenuItem;
    MenuSetFolderHistory: TMenuItem;
    MenuSetFindHitory: TMenuItem;
    MenuSeparetor8: TMenuItem;
    MenuSeparetor10: TMenuItem;
    MenuBmp256Color: TMenuItem;
    MenuEditor3Execute: TMenuItem;
    MenuEditor4Execute: TMenuItem;
    Label10: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    Label1: TLabel;
    Label9: TLabel;
    ScrollBox2: TScrollBox;
    Image1: TImage;
    Image2: TImage;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ReadIniFileValue(Sender: TObject);
    procedure WriteIniFileValue(Sender: TObject);

    procedure BtnBrowseClick(Sender: TObject);
    procedure BtnPrevFileClick(Sender: TObject);
    procedure BtnNextFileClick(Sender: TObject);
    procedure BtnPageUpClick(Sender: TObject);
    procedure BtnPageDownClick(Sender: TObject);
    procedure BtnFileSaveClick(Sender: TObject);
    procedure BtnReLoadClick(Sender: TObject);
    procedure BtnHelpClick(Sender: TObject);
    procedure BtnFileListClick(Sender: TObject);
    procedure BtnReservedClick(Sender: TObject);
    procedure BtnReservedSaveClick(Sender: TObject);
    procedure BtnPrevWordClick(Sender: TObject);
    procedure BtnNextWordClick(Sender: TObject);
    procedure BtnReadIndexClick(Sender: TObject);
    procedure BtnMakeIndexClick(Sender: TObject);
    procedure BtnSaveIndexClick(Sender: TObject);
    procedure BtnStopListFileClick(Sender: TObject);
    procedure BtnPrevViewClick(Sender: TObject);
    procedure BtnNextViewClick(Sender: TObject);
    procedure BtnStopSearchWordClick(Sender: TObject);

    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);

    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox11Click(Sender: TObject);
    procedure CheckBox12Click(Sender: TObject);

    procedure ComboBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ComboBox1CloseUp(Sender: TObject);
    procedure ComboBox2KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure ComboBox2CloseUp(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);

    procedure Panel4Resize(Sender: TObject);
    procedure Panel7Resize(Sender: TObject);

    procedure Editor1Click(Sender: TObject);
    procedure Editor1Change(Sender: TObject);
    procedure Editor1CaretMoved(Sender: TObject);
    procedure Editor1SelectionChange(Sender: TObject; Selected: Boolean);
    procedure Editor1TopRowChange(Sender: TObject);
    procedure Editor5DblClick(Sender: TObject);

    procedure StringGrid1TopLeftChanged(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure StringGrid1RowMoved(Sender: TObject; FromIndex, ToIndex: Integer);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);

    procedure Image1Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Image12Click(Sender: TObject);
    procedure Image11Click(Sender: TObject);

    procedure CheckBoxGroupClick(Sender: TObject);
    procedure GetFileList(Sender: TObject; var sDirName: String);
    procedure GetFolderList(Sender: TObject; var sFileName: String);
    function  ConfirmDirectory(var sDirName: String): Boolean;
    procedure UpdateFolderComboBox(var sDirName: String);
    procedure UpdateFindComboBox(var sFindWord: String);
    procedure ReadFromFile(Sender: TObject);
    procedure SetSearchWord(Sender: TObject; Direction: Integer);
    function  SearchWord(Sender: TObject): Boolean;
    procedure AllBtnDisabled(Sender: TObject);
    procedure AllBtnEnabled(Sender: TObject);
    procedure SetFileExt (Checked: Boolean; Src: String; var Dst: String);
    procedure SetFileName(Checked: Boolean; Src: String; var Dst: String);
    procedure LanguageChange(Sender: TObject);
    procedure SetGridWidth(Sender: TObject);
    procedure DropFileOperation(sFileName: String);
    procedure SetImageRotate(ImageSrc: TImage; ImageDst: TImage; AngleType: Integer);
    procedure ExecuteProgram(sFileName: String; sOption: String);
    procedure FlipFitSizeOrAutoSize(Sender: TObject);
    function  SetRatio(ComboBox: TComboBox): Integer;
    procedure DrawBmpFile(sFileName: String; Bmp256Color: Boolean);
    procedure DrawBmpFileClear(Sender: TObject);
    procedure DrawImageRotate(Sender: TObject);
    procedure DrawImageSelect(Sender: TObject);
    function  DrawWait(Sender: TObject; var Key: Word): Boolean;

    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure WmMousewheel(var Msg: TMessage); message WM_MOUSEWHEEL;
    procedure WMDropFiles(var Msg: TWMDropFiles); message WM_DROPFILES;
    procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    function  SleepEx(const t: integer): Boolean;
    function  GetLongPathName(const sShortName: String): String;

    procedure MenuJapaneseSetClick(Sender: TObject);
    procedure MenuQuitClick(Sender: TObject);
    procedure MenuSetEditorClick(Sender: TObject);
    procedure MenuFindClick(Sender: TObject);
    procedure MenuNextWordClick(Sender: TObject);
    procedure MenuPrevWordClick(Sender: TObject);
    procedure MenuEditor1ExecuteClick(Sender: TObject);
    procedure MenuEditor2ExecuteClick(Sender: TObject);
    procedure MenuEditor3ExecuteClick(Sender: TObject);
    procedure MenuEditor4ExecuteClick(Sender: TObject);
    procedure MenuFileSaveAsClick(Sender: TObject);
    procedure MenuEditorFontColorClick(Sender: TObject);
    procedure MenuViewerFontColorClick(Sender: TObject);
    procedure MenuReservedWordFontColorClick(Sender: TObject);
    procedure MenuGridModeClick(Sender: TObject);
    procedure MenuSearchOptionsClick(Sender: TObject);
    procedure MenuGridWidthClick(Sender: TObject);
    procedure MenuEditModeClick(Sender: TObject);
    procedure MenuFileListSettingClick(Sender: TObject);
    procedure MenuSetFolderHistoryClick(Sender: TObject);
    procedure MenuSetFindHitoryClick(Sender: TObject);
    procedure MenuBmp256ColorClick(Sender: TObject);

    procedure MsgNoFolderFileForSearch(Sender: TObject);
    procedure MsgNoFolderForSearch(Sender: TObject);
    procedure MsgNoFileForSearch(Sender: TObject);
    procedure MsgNoFileForSave(Sender: TObject);
    procedure MsgNoFileForView(Sender: TObject);
    procedure MsgNoFileForEdit(Sender: TObject);
    function  MsgSaveThisFile(Sender: TObject): Integer;
    function  MsgOverWriteThisFile(Sender: TObject): Integer;
    function  MsgReserverWordIsModified_SaveFile(Sender: TObject): Integer;
    function  MsgHistoryOfReservedIsModified_SaveFile(Sender: TObject): Integer;
    procedure MsgCanNotFindWord(Sender: TObject);
    procedure MsgFindWordIsNotSet(Sender: TObject);
    function  MsgSearchTargetIsRootOfDrive(Sender: TObject): Integer;
    function  MsgIndexFileIsModified_DoYouExit(Sender: TObject): Integer;
    procedure MsgNoFileForMakingIndexFile(Sender: TObject);
    procedure MsgCanNotFindExecuteFile(Sender: TObject);
    procedure MsgCanNotFindOptionFaileName(Sender: TObject);
    procedure MsgFailedExecuteEditor(Sender: TObject);
    function  MsgEscapeKey(Sender: TObject): Integer;
    procedure MsgListFilesStop(Sender: TObject);
    procedure MsgSearchWordStop(Sender: TObject);
    procedure MsgFileTypeIsGraphic(Sender: TObject);
    procedure MsgDrawFileSizeIsLarge(Sender: TObject);
    procedure MsgDrawWaitTimeIsOutOfRange(Sender: TObject);
    function  MessageDlgEX(Msg: String; MsgDlgType:TMsgDlgType; Buttons:TMsgDlgButtons; iBtn: Integer): Integer;
    procedure ScrollBox1Click(Sender: TObject);
    procedure ScrollBox2Click(Sender: TObject);
    procedure Editor2DblClick(Sender: TObject);

  private
    { Private 錾 }
    StrListFile: TStringList;
    StrListFolder: TStringList;
    StrListTmp: TStringList;
    StrListReservedWord: TStringList;
    CsvList: TStringList;
    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;

    iBtnSelect: Integer;
    iStopSearchWordCounter: Integer;
    iFileListCount: Integer;
    iDisplayMode: Integer;
    iaGridWidth: array[0..512] of Integer;

    fSearchOptions: TSearchOptions;

    sSearchValue: String;
    sLatestFileName: String;

    bFlipTimer: Boolean;
    bTimerStop: Boolean;
    bStopListFiles: Boolean;
    bStopSearchWord: Boolean;
    bFocusSet: Boolean;
    bSearching: Boolean;
    bWaitBreak : Boolean;
    bNeedDraw : Boolean;

    tKeyTimeout: TDateTime;

  public
    { Public 錾 }
    sEditorFileName:  array[0..3] of String;
    sEditorOption:    array[0..3] of String;
    baTargetFileExt:  array[0..8] of Boolean;
    saTargetFileExt:  array[0..8] of String;
    baTargetFileName: array[0..2] of Boolean;
    saTargetFileName: array[0..2] of String;
    baTargetFileNameNot: array[0..2] of Boolean;
    saTargetFileNameNot: array[0..2] of String;
    saMessage:   array[0..1] of String;
    saButtonMsg: array[0..2] of String;
    saButtonSet: array[0..2] of TMsgDlgBtn;
    saButtonRet: array[0..2] of TModalResult;
    saHistoryFolderNormal:   array[0..FOLDER_COMBO_BOX_ITEM_NUMBER-1] of String;
    saHistoryFolderBookmark: array[0..FOLDER_COMBO_BOX_ITEM_NUMBER-1] of String;
    saHistoryFindNormal:     array[0..FIND_COMBO_BOX_ITEM_NUMBER  -1] of String;
    saHistoryFindBookmark:   array[0..FIND_COMBO_BOX_ITEM_NUMBER  -1] of String;

    sDrawWaitTime: String;

    bsfrMatchCase: Boolean;      // ONő啶
    bsfrWholeWord: Boolean;      // ONŒPPʂŒT
    bsfrNoMatchZenkaku: Boolean; // ONőSppʂȂ
    bsfrIncludeCRLF: Boolean;    // ONŉs𖳎
    bsfrIncludeSpace: Boolean;   // ONŃXy[X𖳎
    bFindSubFolder: Boolean;

    iFileSortType: Integer;
    iButtonIndex: Integer;
  end;


//Zt@C𒷂t@CɕϊKernel32.dll̊֐
//Delphi5.6.7ł͗pӂĂȂ̂Œ`Ďgp
function GetLongPathNameA(ShortPathName: PChar;
                          LongPathName: PChar;
                          cchBuffer: Integer): Integer; stdcall; external 'kernel32.dll';

var
  FormMain: TFormMain;

implementation

uses Option, MsgDlgEx;

{$R *.dfm}

procedure TFormMain.LanguageChange(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    BtnPrevView.Caption          := 'O\(&H)';
    BtnNextView.Caption          := '\(&L)';
    BtnPrevFile.Caption          := 'O̧(&J)';
    BtnNextFile.Caption          := '̧(&K)';
    BtnPageUp.Caption            := 'O߰(&I)';
    BtnPageDown.Caption          := '߰(&M)';
    BtnBrowse.Caption            := 'Q(&B)';
    BtnReLoad.Caption            := 'ēǍ(&R)';
    BtnPrevWord.Caption          := 'O(&P)';
    BtnNextWord.Caption          := '(&N)';
    BtnFileSave.Caption          := '㏑ۑ(&W)';
    BtnReservedSave.Caption      := '\ۑ(&W)';
    BtnMakeIndex.Caption         := 'ڎ쐬(&O)';
    BtnSaveIndex.Caption         := 'ڎۑ(&W)';
    BtnStopListFile.Caption      := 'ؽĒ~(&P)';
    BtnStopSearchWord.Caption    := '~(&P)';

    MenuFile.Caption             := '̧(&F)';
    MenuEditor1Execute.Caption   := 'ޮ1N(&E)';
    MenuEditor2Execute.Caption   := 'ޮ2N(&R)';
    MenuEditor3Execute.Caption   := 'ޮ3N(&G)';
    MenuEditor4Execute.Caption   := 'ޮ4N(&H)';
    MenuFileSaveAs.Caption       := 'ʖۑ(&A)...';
    MenuQuit.Caption             := 'I(&Q)';

    MenuSearch.Caption           := '(&S)';
    MenuFind.Caption             := '(&D)';
    MenuPrevWord.Caption         := 'O(&P)';
    MenuNextWord.Caption         := '(&N)';
    MenuSearchOptions.Caption    := 'ݒ(&O)...';

    MenuOptions.Caption          := '߼(&O)';
    MenuJapaneseSet.Caption      := 'Japanese(&L)';
    MenuGridMode.Caption         := 'دӰ(&G)';
    MenuGridWidth.Caption        := 'دޕݒ(&W)';
    MenuEditMode.Caption         := 'ҏWӰ(&T)';
    MenuFileListSetting.Caption  := '̧ؽĐݒ(&I)...';
    MenuSetEditor.Caption        := 'ިݒ(&O)...';
    MenuSetFolderHistory.Caption := '̫ްޯϰݒ(&D)...';
    MenuSetFindHitory.Caption    := 'ޯϰݒ(&F)...';
    MenuBmp256Color.Caption      := 'Bmp256F\(&B)';
    MenuEditorFontColor.Caption       := 'ި̫ĐFݒ(&C)...';
    MenuViewerFontColor.Caption       := 'ޭ̫ܰĐFݒ(&V)...';
    MenuReservedWordFontColor.Caption := '\̫ĐFݒ(&R)...';

    Label4.Caption  := '̫ޗ(&Q):';
    Label3.Caption  := '(&Y):';
    Label2.Caption  := '(&D):';
    Label5.Caption  := '摜(&Z):';

    CheckBox1.Caption  := 'ҏWӰ(&T)';
    CheckBox2.Caption  := 'دӰ(&G)';
    CheckBox11.Caption := 'ޯϰ';
    CheckBox12.Caption := 'ޯϰ';

    //ύX
    if Editor1.Modified = TRUE then
    begin
      Label7.Caption := '==ύX==';
    end
    else
    begin
      Label7.Caption := '=ύX=';
    end;

    //pl
    if iBtnSelect      = BTN_INIT then
    begin
      BtnHelp.Caption          := '(&C)';
      BtnFileList.Caption      := '̧ؽ(&A)';
      BtnReserved.Caption      := '\(&V)';
      BtnReadIndex.Caption     := 'ڎǍ(&X)';
    end
    //pl
    else if iBtnSelect = BTN_HELP then
    begin
      BtnHelp.Caption          := '(&C)';
    end
    //pl
    else if iBtnSelect = BTN_FILELIST then
    begin
      BtnFileList.Caption      := '̧ؽ(&A)';
    end
    //pl
    else if iBtnSelect = BTN_RESERVED then
    begin
      BtnReserved.Caption      := '\(&V)';
    end
    //pl
    else if iBtnSelect = BTN_INDEX then
    begin
      BtnReadIndex.Caption     := 'ڎǍ(&X)';
    end
    else
    begin
    end;
  end
  //p
  else
  begin
    BtnPrevView.Caption          := 'PrevView(&H)';
    BtnNextView.Caption          := 'NextView(&L)';
    BtnPrevFile.Caption          := 'PrevFile(&J)';
    BtnNextFile.Caption          := 'NextFile(&K)';
    BtnPageUp.Caption            := 'PageUp(&I)';
    BtnPageDown.Caption          := 'PageDown(&M)';
    BtnBrowse.Caption            := 'Browse(&B)';
    BtnReLoad.Caption            := 'ReLoad(&R)';
    BtnPrevWord.Caption          := 'PrevWord(&P)';
    BtnNextWord.Caption          := 'NextWord(&N)';
    BtnFileSave.Caption          := 'SaveFile(&W)';
    BtnReservedSave.Caption      := 'SaveRsrv(&W)';
    BtnMakeIndex.Caption         := 'MakeIndex(&O)';
    BtnSaveIndex.Caption         := 'SaveIndex(&W)';
    BtnStopListFile.Caption      := 'StopList(&P)';
    BtnStopSearchWord.Caption    := 'StopSearch(&P)';

    MenuFile.Caption             := 'File(&F)';
    MenuEditor1Execute.Caption   := 'ExecuteEditor1(&E)';
    MenuEditor2Execute.Caption   := 'ExecuteEditor2(&R)';
    MenuEditor3Execute.Caption   := 'ExecuteEditor3(&G)';
    MenuEditor4Execute.Caption   := 'ExecuteEditor4(&H)';
    MenuFileSaveAs.Caption       := 'FileSaveAs(&A)...';
    MenuQuit.Caption             := 'Quit(&Q)';

    MenuSearch.Caption           := 'Search(&S)';
    MenuFind.Caption             := 'Find(&D)';
    MenuPrevWord.Caption         := 'PrevWord(&P)';
    MenuNextWord.Caption         := 'NextWoed(&N)';
    MenuSearchOptions.Caption    := 'SearchOptions(&O)...';

    MenuOptions.Caption          := 'Options(&O)';
    MenuJapaneseSet.Caption      := 'Japanese(&L)';
    MenuGridMode.Caption         := 'GridMode(&G)';
    MenuGridWidth.Caption        := 'GridWidthAuto(&W)';
    MenuEditMode.Caption         := 'EditMode(&T)';
    MenuFileListSetting.Caption  := 'FileListSetting(&I)...';
    MenuSetEditor.Caption        := 'SetEditorApplicatio(&O)...';
    MenuSetFolderHistory.Caption := 'SetFolderHistory(&D)...';
    MenuSetFindHitory.Caption    := 'SetFindHitory(&F)...';
    MenuBmp256Color.Caption      := 'Bmp256Color(&B)';
    MenuEditorFontColor.Caption       := 'SetEditorFontColor(&C)...';
    MenuViewerFontColor.Caption       := 'SetViewerFontColor(&V)...';
    MenuReservedWordFontColor.Caption := 'SetReservedWordFontColor(&R)...';

    Label4.Caption  := 'FolderHstry(&Q):';
    Label3.Caption  := 'FindHstry(&Y):';
    Label2.Caption  := 'FindWord(&D):';
    Label5.Caption  := 'DrawSize(&Z):';

    CheckBox1.Caption  := 'EditMode(&T)';
    CheckBox2.Caption  := 'GridMode(&G)';
    CheckBox11.Caption := 'BookMark';
    CheckBox12.Caption := 'BookMark';

    //ύX
    if Editor1.Modified = TRUE then
    begin
      Label7.Caption := '=Modified=';
    end
    else
    begin
      Label7.Caption := 'NotModified';
    end;

    //pl
    if iBtnSelect      = BTN_INIT then
    begin
      BtnHelp.Caption          := 'Help(&C)';
      BtnFileList.Caption      := 'FileList(&A)';
      BtnReserved.Caption      := 'Reserved(&V)';
      BtnReadIndex.Caption     := 'ReadIndex(&X)';
    end
    //pl
    else if iBtnSelect = BTN_HELP then
    begin
      BtnHelp.Caption          := 'Help(&C)';
    end
    //pl
    else if iBtnSelect = BTN_FILELIST then
    begin
      BtnFileList.Caption      := 'FileList(&A)';
    end
    //pl
    else if iBtnSelect = BTN_RESERVED then
    begin
      BtnReserved.Caption      := 'Reserved(&V)';
    end
    //pl
    else if iBtnSelect = BTN_INDEX then
    begin
      BtnReadIndex.Caption     := 'ReadIndex(&X)';
    end
    else
    begin
    end;
  end;
end;

procedure TFormMain.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_MAIN_WIDTH_SET;
    y := FORM_MAIN_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormMain.FormCreate(Sender: TObject);
var
  sStr1: String;
begin
  //m
  StrListFile := TStringList.Create;
  StrListFolder := TStringList.Create;
  StrListTmp := TStringList.Create;
  StrListReservedWord := TStringList.Create;
  CsvList := TStringList.Create;
  //eݒ
  ListBox1.Style :=lbOwnerDrawFixed;
  //eݒ
  FormMain.KeyPreview := TRUE;
  FormMain.Position := poDesigned;
  //eݒ
  Editor1.Align := alClient;
  Editor1.ScrollBars := ssBoth;
  Editor1.View.Colors.Reserve.Color := clRed;
  Editor1.ReserveWordList.Assign(Editor3.Lines);
  //eݒ
  Editor2.ReadOnly := TRUE;
  Editor2.Align := alClient;
  Editor2.ScrollBars := ssBoth;
  //eݒ
  Editor3.Align := alLeft;
  Editor3.ScrollBars := ssBoth;
  //eݒ
  Editor4.Align := alClient;
  Editor4.ScrollBars := ssBoth;
  //eݒ
  Editor5.Align := alClient;
  Editor5.ScrollBars := ssBoth;
  Editor5.View.Colors.Reserve.Color := clRed;
  Editor5.ReserveWordList.Assign(Editor3.Lines);
  //eݒ
  Editor10.Align := alClient;
  Editor10.ScrollBars := ssBoth;
  Editor10.Visible := FALSE;
  //eݒ
  Panel5.Visible := TRUE;
  Panel5.Align := alClient;
  //eݒ
  Panel6.Visible := FALSE;
  Panel6.Align := alClient;
  //eݒ
  Panel7.Visible := FALSE;
  Panel7.Align := alClient;
  //eݒ
  Panel8.Visible := FALSE;
  Panel8.Align := alClient;
  //eݒ
  StringGrid1.Align := alClient;
  StringGrid1.Visible := FALSE;
  Stringgrid1.RowCount:= 2;
  Stringgrid1.ColCount:= 2;
  Stringgrid1.FixedRows := 1;
  Stringgrid1.FixedCols := 1;
  //eݒ
  Image1.Visible  := FALSE; //\̕Kv
  Image1.Stretch  := TRUE;  //k̂TRUE
  Image1.AutoSize := FALSE; //NCAg̘gɕ\̂FALSE
  //eݒ
  Image2.Visible  := FALSE; //؂ւ
  Image2.Stretch  := TRUE;  //k̂TRUE
  Image2.AutoSize := FALSE; //NCAg̘gɕ\̂FALSE
  //eݒ
  Image11.Visible  := FALSE; //\̕Kv
  Image11.Stretch  := TRUE;  //k̂TRUE
  Image11.AutoSize := FALSE; //NCAg̘gɕ\̂FALSE
  Image11.Top      := 0;     //w
  Image11.Left     := 0;
  //eݒ
  Image12.Visible  := FALSE; //؂ւ
  Image12.Stretch  := TRUE;  //k̂TRUE
  Image12.AutoSize := FALSE; //NCAg̘gɕ\̂FALSE
  Image12.Top      := 0;     //w
  Image12.Left     := 0;
  //eݒ
  ScrollBox1.Align := alClient;
  ScrollBox1.Visible := FALSE;
  ScrollBox1.AutoScroll := TRUE;
  ScrollBox1.HorzScrollBar.Tracking := TRUE;
  ScrollBox1.VertScrollBar.Tracking := TRUE;
  //eݒ
  ScrollBox2.Align := alClient;
  ScrollBox2.Visible := FALSE;
  ScrollBox2.AutoScroll := FALSE;

  //eݒ
  ComboBox1.Style := csDropDownList;
  ComboBox1.DropDownCount := FOLDER_COMBO_BOX_ITEM_NUMBER;
  //eݒ
  ComboBox2.Style := csDropDownList;
  ComboBox2.DropDownCount := FIND_COMBO_BOX_ITEM_NUMBER;
  //eݒ
  ComboBox3.Style := csDropDownList;
  ComboBox3.DropDownCount := Combobox3.Items.Count;;
  //eݒ
  Splitter1.MinSize := LISTBOX_WIDTH_SET;
  Splitter1.AutoSnap := FALSE;
  //eݒ
  Edit1.ReadOnly := FALSE;
  //eݒ
  BtnStopListFile.Top := BtnReLoad.Top;
  BtnStopListFile.Visible := FALSE;
  //eݒ
  BtnStopSearchWord.Top := BtnNextWord.Top;
  BtnStopSearchWord.Visible := FALSE;

  //eݒ
//  Label10.Visible := FALSE;
//  Label6.Visible  := FALSE;
//  Label8.Visible  := FALSE;
//  Label1.Visible  := FALSE;
//  Label9.Visible  := FALSE;

  //
  Edit1.Text := '';
  Editor1.Lines.Clear;
  Editor2.Lines.Clear;
  Editor3.Lines.Clear;
  Editor4.Lines.Clear;
  Editor5.Lines.Clear;
  Editor10.Lines.Clear;
  Label6.Caption  := 'File:00000/00000';
  Label10.Caption := 'List:000000';
  Label9.Caption  := '';
  iBtnSelect := 0;
  bFocusSet := FALSE;
  bFlipTimer := FALSE;
  bSearching := FALSE;
  sLatestFileName := '';
  Timer2.Enabled := FALSE;
  iDisplayMode := INIT_MODE;
  ComboBox3.ItemIndex := 0;
  CheckBox22.Checked := TRUE;
  bWaitBreak := FALSE;
  bNeedDraw := TRUE;
  tKeyTimeout := 0;

  //Iniݒ
  ReadIniFileValue(Sender);


  //\ݒ
  sStr1 := ExtractFilePath(Paramstr(0)) + RESERVED_SET;
  if FileExists(sStr1) = TRUE then
  begin
    Editor3.Lines.BeginUpdate;
    try
      Editor3.Lines.Clear;
      Editor3.Lines.LoadFromFile(sStr1);
    finally
      Editor3.Lines.EndUpdate;
    end;
  end;
  //\̗ݒ
  sStr1 := ExtractFilePath(Paramstr(0)) + RESERVED_HIS;
  if FileExists(sStr1) = TRUE then
  begin
    Editor4.Lines.BeginUpdate;
    try
      Editor4.Lines.Clear;
      Editor4.Lines.LoadFromFile(sStr1);
    finally
      Editor4.Lines.EndUpdate;
    end;
  end;
  //Editor/Viewerؑ
  CheckBox1Click(Sender);
  //Grid/Textؑ
  CheckBox2Click(Sender);
  //\ݒ
  Editor1.ReserveWordList.Assign(Editor3.Lines);
  //Fݒ
  Editor1.View.Colors.Reserve.Color := ColorDialog3.Color;
  //ݒ
  LanguageChange(Sender);
  //LvV\
  if ListBox1.Count > 0 then
  begin
    FormMain.Caption := FORM_CAPTION    + '  ' +
                        StrListFile.Strings[ListBox1.itemindex];
  end;

  //NbN̋@\𖳌ɂ
  CheckBox21.OnClick := CheckBoxGroupClick;
  CheckBox22.OnClick := CheckBoxGroupClick;
  CheckBox23.OnClick := CheckBoxGroupClick;
  CheckBox24.OnClick := CheckBoxGroupClick;


  //hbOݒ
  DragAcceptFiles(Handle, TRUE);
  Application.OnMessage := AppMessage;
end;

procedure TFormMain.FormDestroy(Sender: TObject);
begin
  //Iniݒ
  WriteIniFileValue(Sender);
  //j
  CsvList.Free;
  StrListReservedWord.Free;
  StrListTmp.Free;
  StrListFolder.Free;
  StrListFile.Free;
end;

procedure TFormMain.FormShow(Sender: TObject);
var
  sStr1: String;
begin
  //ʓɕ\łȂ ftHgŕ\
  if ((Screen.Width -10) < (FormPosWidth  + FormPosLeft)) or
     ((Screen.Height-10) < (FormPosHeight + FormPosTop )) or
      (FormPosLeft < 0) or
      (FormPosTop  < 0) then
  begin
    FormMain.SetBounds((Screen.Width  - FORM_MAIN_WIDTH_SET ) div 2,
                       (Screen.Height - FORM_MAIN_HEIGHT_SET) div 2,
                       FORM_MAIN_WIDTH_SET,
                       FORM_MAIN_HEIGHT_SET);
  end
  //\ł ȌԂŕ\
  else
  begin
    FormMain.SetBounds(FormPosLeft,
                       FormPosTop,
                       FormPosWidth,
                       FormPosHeight);
  end;
  //{^\
  AllBtnEnabled(Self);
  //tH[JXݒ
  BtnReLoad.SetFocus;

  //eݒ
  //FormCreate ł͎ŝŁAɈړ
  SendMessage(ListBox1.Handle, LB_SETHORIZONTALEXTENT, ListBox1.Width*10, 0);

  //ꍇ
  if (ParamCount >= 1) then
  begin
    //Ot@CɕύX
    sStr1 := GetLongPathName(Paramstr(1));
    DropFileOperation(sStr1);
  end;
end;

procedure TFormMain.FormResize(Sender: TObject);
begin
  //\ɑ傫ƁAE̕\łȂ
  if Panel3.Width - Panel4.Width - Splitter1.Width < LISTBOX_WIDTH_SET then
  begin
    Panel4.Width := Panel3.Width - Splitter1.Width - LISTBOX_WIDTH_SET;
  end
end;

procedure TFormMain.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //Shift+Space
  if (Shift = [ssShift]) and (key = VK_SPACE) then
  begin
    //tH[JXƏ֎~̔
    if (Editor1.ReadOnly = TRUE) then
    begin
      BtnPrevViewClick(Sender);
      Key := 0;
    end;
  end
  //Space
  else if (Shift = []) and (key = VK_SPACE)  then
  begin
    //tH[JXƏ֎~̔
    if (Editor1.ReadOnly = TRUE) then
    begin
      BtnNextViewClick(Sender);
      Key := 0;
    end;
  end
  //ALT+UP
  else if (Shift = [ssAlt]) and (key = VK_UP) then
  begin
    BtnPrevViewClick(Sender);
    Key := 0;
  end
  //ALT+DOWN
  else if (Shift = [ssAlt]) and (key = VK_DOWN) then
  begin
    BtnNextViewClick(Sender);
    Key := 0;
  end
  //ALT+LEFT
  else if (Shift = [ssAlt]) and (key = VK_LEFT) then
  begin
    BtnPrevFileClick(Sender);
    Key := 0;
  end
  //ALT+RIGHT
  else if (Shift = [ssAlt]) and (key = VK_RIGHT) then
  begin
    BtnNextFileClick(Sender);
    Key := 0;
  end
  //ALT+RETURN
  else if (Shift = [ssAlt]) and (key = VK_RETURN) then
  begin
    //tH[JX̔
    if (bFocusSet = FALSE) and (Editor1.Visible = TRUE) then
    begin
      bFocusSet := TRUE;
      Editor1.SetFocus;
      Key := 0;
    end
    else
    begin
      bFocusSet := FALSE;
      ListBox1.SetFocus;
      Key := 0;
    end;
  end
  //CTRL+RETURN
  else if (Shift = [ssCtrl]) and (key = VK_RETURN) then
  begin
    //ҏWԂ̕ύX
    if CheckBox1.Checked = FALSE then
    begin
      CheckBox1.Checked := TRUE;
      Key := 0;
    end
    else
    begin
      CheckBox1.Checked := FALSE;
      Key := 0;
    end;
  end
  //PageUp
  else if (Shift = []) and (key = VK_PRIOR) then
  begin
  end
  //PageDown
  else if (Shift = []) and (key = VK_NEXT) then
  begin
  end
  //CTRL+UP
  else if (Shift = [ssCtrl]) and (key = VK_UP) then
  begin
    //擪Ɉړ
    Editor1.Row := 0;
    Key := 0;
  end
  //CTRL+DOWN
  else if (Shift = [ssCtrl]) and (key = VK_DOWN) then
  begin
    //ŌɈړ
    Editor1.Row := Editor1.Lines.Count-1;
    Key := 0;
  end
  //ESCAPE
  else if (key = VK_ESCAPE) then
  begin
    //~{^Lȏꍇ
    if      BtnStopListFile.Visible = TRUE then
    begin
      ;
    end
    //~{^Lȏꍇ
    else if BtnStopSearchWord.Visible = TRUE then
    begin
      ;
    end
    //bZ[W\̏ꍇ
    else if FormMsgDlgEx.Showing = TRUE then
    begin
      ;
    end
    //IvV\̏ꍇ
    else if FormOption.Showing = TRUE then
    begin
      ;
    end
    //pl
    else if iBtnSelect <> BTN_INIT then
    begin
      ;
    end
    //LȊȌꍇ
    else
    begin
     //
     if MsgEscapeKey(Self) = mrYes then
     begin
       Close;
     end;
    end;
  end
  //̑
  else
  begin
    ;
  end;
end;

procedure  TFormMain.AppMessage(var Msg: TMsg; var Handled: Boolean);
begin
  //hbO&hbṽbZ[W
  if ((Msg.hwnd = Application.Handle)) and (Msg.message = WM_DROPFILES) then
  begin
    //$IFDEF WIN32
    SetForegroundWindow(Application.Handle);
    //$ELSE
    SetActiveWindow(Application.Handle);
    //$ENDIF
    //AvP[Vɓn郁bZ[W tH[ɓn
    Perform(WM_DROPFILES, Msg.wParam, Msg.LParam);
    //AvP[ṼCtH[ ̑傫ɕ
    Application.Restore;
    //Lɂ
    Handled := TRUE;
  end;
end;

procedure TFormMain.DropFileOperation(sFileName: String);
var
  sStr1: String;
begin
  //tH_̏ꍇ
  if DirectoryExists(sFileName) = TRUE then
  begin
    //tH_Xg擾
    GetFolderList(Self, sFileName);
  end
  else
  //tH_ȊȌꍇ
  begin
    //t@C̏ꍇ
    if FileExists(sFileName) = TRUE then
    begin
      //XV
      sStr1 := ExtractFilePath(sFileName);
      UpdateFolderComboBox(sStr1);
      //
      StrListFolder.Clear;
      StrListFile.Clear;
      //t@CP̂ݒ肷
      StrListFolder.Add(sFileName);
      StrListFile.Add(sFileName);
      //Xg\
      ListBox1.Items.Clear;
      ListBox1.Items.Add(ExtractFileName(StrListFolder.Strings[0]));
      ListBox1.ItemIndex := 0;
      //摜`ݒ
      bNeedDraw := TRUE;
      //ǂݍ
      ReadFromFile(Self);
      sLatestFileName := StrListFile[ListBox1.ItemIndex];
    end
    //Y
    else
    begin
      //
    end;
  end;
  //1傫ꍇ
  if ListBox1.Count > 1 then
  begin
    ListBox1.SetFocus;
  end;
  //1̏ꍇ
  if (ListBox1.Count = 1) and (iDisplayMode = TEXT_MODE) then
  begin
    Editor1.SetFocus;
  end;
  if (ListBox1.Count = 1) and (iDisplayMode = GRID_MODE) then
  begin
    StringGrid1.SetFocus;
  end;
end;

procedure  TFormMain.WmDropFiles(var Msg: TWmDropFiles);
var
  DropFileName: array [0..255] of Char;
  sStr1: String;
  iFileCount: Integer;
begin
  //hbv̏
  iFileCount := DragQueryFile(Msg.Drop, Cardinal(-1), nil, 0);
  //hbvΏۂ鎞
  if iFileCount >= 1 then
  begin
    //t@Cݒ  0=FirsrFile 1=SecondFile
    DragQueryFile(Msg.Drop, 0, DropFileName, SizeOf(DropFileName));
    sStr1 := StrPas(DropFileName);
    DropFileOperation(sStr1);
  end;
  //hbvI
  DragFinish(Msg.Drop);
end;

procedure TFormMain.WmMousewheel(var Msg: TMessage);
  //֐֐̊Jn
  function ActiveEditor: TEditor;
  var
    iCnt: Integer;
  begin
    //߂l
    Result := nil;
    //
    for iCnt := 0 to ComponentCount-1 do
    begin
      //YR|[lg
      if Components[iCnt] is TEditor then
      begin
        //tH[JXݒ肳Ă
        if TEditor(Components[iCnt]).Focused then
        begin
          Result := TEditor(Components[iCnt]);
          Exit;
        end;
      end;
    end;
  end;
  //֐֐̏I
begin
  //
  if (Msg.WParam > 0) then
  begin
    //YL{tH[JXL
    if (ActiveEditor <> nil) and (ActiveEditor.Focused = TRUE) then
    begin
      //zC[ɓ
      Sendmessage(ActiveEditor.Handle, WM_VSCROLL, SB_LINEUP, 0);
      //y[WXN[̏ꍇ
      // Sendmessage(Editor1.Handle, WM_VSCROLL, SB_PAGEUP, 0);
    end;
  end
  else
  begin
    //YL{tH[JXL
    if (ActiveEditor <> nil) and (ActiveEditor.Focused = TRUE) then
    begin
       //zC[Oɓ
      Sendmessage(ActiveEditor.Handle, WM_VSCROLL, SB_LINEDOWN, 0);
      //y[WXN[̏ꍇ
      // Sendmessage(Editor1.Handle, WM_VSCROLL, SB_PAGEDOWN, 0);
    end;
  end;
end;

procedure TFormMain.ReadIniFileValue(Sender: TObject);
var
  IniFile: TIniFile;
  iIndex: Integer;
  sStr1: String;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.INI'));
  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormMain', 'Left',   -1);
  FormPosTop    := IniFile.ReadInteger('FormMain', 'Top',    -1);
  FormPosWidth  := IniFile.ReadInteger('FormMain', 'Width',  FORM_MAIN_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormMain', 'Height', FORM_MAIN_HEIGHT_SET);
  //
  Panel4.Width := IniFile.ReadInteger('Panel4', 'Width', Panel4.Width);
  //ubN}[N
  CheckBox11.Checked := IniFile.ReadBool ('FolderNameBookmark', 'Checked', FALSE);
  //Ǎ
  for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    sStr1 := TrimRight(IniFile.ReadString ('FolderNameBookmark', IntToStr(iIndex), ''));
    saHistoryFolderBookmark[iIndex] := sStr1;
    sStr1 := TrimRight(IniFile.ReadString ('FolderNameNormal',   IntToStr(iIndex), ''));
    saHistoryFolderNormal  [iIndex] := sStr1;
  end;
  //𔽉f
  ComboBox1.Items.Clear;
  for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    if CheckBox11.Checked = TRUE then
    begin
      ComboBox1.Items.Add(saHistoryFolderBookmark[iIndex]);
    end
    else
    begin
      ComboBox1.Items.Add(saHistoryFolderNormal  [iIndex]);
    end;
  end;
  ComboBox1.ItemIndex := 0;
  //ubN}[N
  CheckBox12.Checked := IniFile.ReadBool ('FindWordBookmark', 'Checked', FALSE);
  //Ǎ
  for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    sStr1 := TrimRight(IniFile.ReadString ('FindWordBookmark', IntToStr(iIndex), ''));
    saHistoryFindBookmark[iIndex] := sStr1;;
    sStr1 := TrimRight(IniFile.ReadString ('FindWordNormal',   IntToStr(iIndex), ''));
    saHistoryFindNormal  [iIndex] := sStr1;;
  end;
  //𔽉f
  ComboBox2.Items.Clear;
  for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    if CheckBox12.Checked = TRUE then
    begin
      ComboBox2.Items.Add(saHistoryFindBookmark[iIndex]);
    end
    else
    begin
      ComboBox2.Items.Add(saHistoryFindNormal  [iIndex]);
    end;
  end;
  ComboBox2.ItemIndex := 0;
  //ҏWeɔf
  Edit1.Text := ComboBox2.Items[0];
  //ҏW
  CheckBox1.Checked := IniFile.ReadBool ('FileEdit', 'Enabled', FALSE);
  //Obh
  CheckBox2.Checked := IniFile.ReadBool ('GridMode', 'Enabled', FALSE);

  //摜TCY
  ComboBox3.ItemIndex := IniFile.ReadInteger ('DrawSize', 'Index', 0);
  //tB[\[g
  iFileSortType := IniFile.ReadInteger ('FileSort', 'Type', 1);
  //TutH_[
  bFindSubFolder := IniFile.ReadBool ('FindSubFolder', 'Enabled', TRUE);
  //t@C
  baTargetFileNameNot[0] := IniFile.ReadBool ('NotCheckName', '01', TRUE);
  baTargetFileNameNot[1] := IniFile.ReadBool ('NotCheckName', '02', TRUE);
  baTargetFileNameNot[2] := IniFile.ReadBool ('NotCheckName', '03', TRUE);
  //t@C
  baTargetFileName[0] := IniFile.ReadBool ('CheckName', '01', TRUE);
  baTargetFileName[1] := IniFile.ReadBool ('CheckName', '02', TRUE);
  baTargetFileName[2] := IniFile.ReadBool ('CheckName', '03', TRUE);
  //gq
  baTargetFileExt [0] := IniFile.ReadBool ('CheckExt',  '01', TRUE);
  baTargetFileExt [1] := IniFile.ReadBool ('CheckExt',  '02', TRUE);
  baTargetFileExt [2] := IniFile.ReadBool ('CheckExt',  '03', TRUE);
  baTargetFileExt [3] := IniFile.ReadBool ('CheckExt',  '04', TRUE);
  baTargetFileExt [4] := IniFile.ReadBool ('CheckExt',  '05', TRUE);
  baTargetFileExt [5] := IniFile.ReadBool ('CheckExt',  '06', TRUE);
  baTargetFileExt [6] := IniFile.ReadBool ('CheckExt',  '07', TRUE);
  baTargetFileExt [7] := IniFile.ReadBool ('CheckExt',  '08', TRUE);
  baTargetFileExt [8] := IniFile.ReadBool ('CheckExt',  '09', TRUE);
  //t@C
  sStr1 := TrimRight(IniFile.ReadString ('NotTargetName', '01', 'IO.SYS'));
  saTargetFileNameNot[0] := sStr1;
  sStr1 := TrimRight(IniFile.ReadString ('NotTargetName', '02', 'MSDOS.SYS'));
  saTargetFileNameNot[1] := sStr1;
  sStr1 := TrimRight(IniFile.ReadString ('NotTargetName', '03', 'HIBERFIL.SYS'));
  saTargetFileNameNot[2] := sStr1;
  //t@C
  sStr1 := TrimRight(IniFile.ReadString ('TargetName', '01', 'MAIN.PAS'));
  saTargetFileName[0] := sStr1;
  sStr1 := TrimRight(IniFile.ReadString ('TargetName', '02', 'AUTOEXEC.BAT'));
  saTargetFileName[1] := sStr1;
  sStr1 := TrimRight(IniFile.ReadString ('TargetName', '03', 'CONFIG.SYS'));
  saTargetFileName[2] := sStr1;
  //gq
  sStr1 := TrimRight(IniFile.ReadString ('TargetExt',  '01', 'TXT'));
  saTargetFileExt [0] := sStr1;
  sStr1 := TrimRight(IniFile.ReadString ('TargetExt',  '02', 'DOC'));
  saTargetFileExt [1] := sStr1;
  sStr1 := TrimRight(IniFile.ReadString ('TargetExt',  '03', 'PAS'));
  saTargetFileExt [2] := sStr1;
  sStr1 := TrimRight(IniFile.ReadString ('TargetExt',  '04', 'C'));
  saTargetFileExt [3] := sStr1;
  sStr1 := TrimRight(IniFile.ReadString ('TargetExt',  '05', 'BAS'));
  saTargetFileExt [4] := sStr1;
  sStr1 := TrimRight(IniFile.ReadString ('TargetExt',  '06', 'RTF'));
  saTargetFileExt [5] := sStr1;
  sStr1 := TrimRight(IniFile.ReadString ('TargetExt',  '07', 'JPG'));
  saTargetFileExt [6] := sStr1;
  sStr1 := TrimRight(IniFile.ReadString ('TargetExt',  '08', 'JPEG'));
  saTargetFileExt [7] := sStr1;
  sStr1 := TrimRight(IniFile.ReadString ('TargetExt',  '09', 'BMP'));
  saTargetFileExt [8] := sStr1;

  //FǍ
  ColorDialog1.Color := StringToColor(IniFile.ReadString('Editor',   'FontColor', ColorToString(clBlack)));
  ColorDialog2.Color := StringToColor(IniFile.ReadString('Viewer',   'FontColor', ColorToString(clBlue)));
  ColorDialog3.Color := StringToColor(IniFile.ReadString('Reserved', 'FontColor', ColorToString(clRed)));
  //
  MenuJapaneseSet.Checked := IniFile.ReadBool ('Language', 'Japanese', TRUE);
  //Obhݒ
  MenuGridWidth.Checked := IniFile.ReadBool ('GridWidth', 'Auto', TRUE);
  //BMPFݒ
  MenuBmp256Color.Checked := IniFile.ReadBool ('Bmp', '256Color', FALSE);

  //
  sEditorFileName[0] := IniFile.ReadString ('Editor1', 'FileName', 'C:\WINDOWS\NOTEPAD.EXE');
  sEditorOption  [0] := IniFile.ReadString ('Editor1', 'Option',   '%f');
  sEditorFileName[1] := IniFile.ReadString ('Editor2', 'FileName', 'C:\Program Files\Windows NT\Accessories\wordpad.exe');
  sEditorOption  [1] := IniFile.ReadString ('Editor2', 'Option',   '%f');
  sEditorFileName[2] := IniFile.ReadString ('Editor3', 'FileName', 'C:\windows\system32\mspaint.exe');
  sEditorOption  [2] := IniFile.ReadString ('Editor3', 'Option',   '%f');
  sEditorFileName[3] := IniFile.ReadString ('Editor4', 'FileName', '');
  sEditorOption  [3] := IniFile.ReadString ('Editor4', 'Option',   '%f');
  //IvV
  bsfrMatchCase      := IniFile.ReadBool ('CheckSearch', 'Case',    FALSE);
  bsfrWholeWord      := IniFile.ReadBool ('CheckSearch', 'Word',    FALSE);
  bsfrNoMatchZenkaku := IniFile.ReadBool ('CheckSearch', 'Zenkaku', TRUE );
  bsfrIncludeCRLF    := IniFile.ReadBool ('CheckSearch', 'CrLf',    FALSE);
  bsfrIncludeSpace   := IniFile.ReadBool ('CheckSearch', 'Space',   FALSE);

  //t@C
  sDrawWaitTime := IniFile.ReadString ('DrawWaitTime', '01', '350');

  //j
  IniFile.Free;
end;

procedure TFormMain.WriteIniFileValue(Sender: TObject);
var
  IniFile: TIniFile;
  iIndex: Integer;
  sStr1: String;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.INI'));
  //WԂ̎͏
  if WindowState = wsNormal then
  begin
    //ʓɕ\ĂȂ͂̂܂܂
      if ((Screen.Width -10) < (FormMain.Width  + FormMain.Left)) or
         ((Screen.Height-10) < (FormMain.Height + FormMain.Top )) or
         (FormMain.Left < 0) or
         (FormMain.Top  < 0) then
    begin
      ;
    end
    //ʓɕ\ĂΕۑ
    else
    begin
      IniFile.WriteInteger('FormMain', 'Left',   FormMain.Left);
      IniFile.WriteInteger('FormMain', 'Top',    FormMain.Top);
      IniFile.WriteInteger('FormMain', 'Width',  FormMain.Width);
      IniFile.WriteInteger('FormMain', 'Height', FormMain.Height);
     end;
  end;
  //
  IniFile.WriteInteger('Panel4', 'Width', Panel4.Width);
  //
  IniFile.WriteBool ('FolderNameBookmark', 'Checked', CheckBox11.Checked);
  for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    sStr1 := TrimRight(saHistoryFolderBookmark[iIndex]);
    IniFile.WriteString('FolderNameBookmark', IntToStr(iIndex), sStr1);
    sStr1 := TrimRight(saHistoryFolderNormal  [iIndex]);
    IniFile.WriteString('FolderNameNormal',   IntToStr(iIndex), sStr1);
  end;
  //
  IniFile.WriteBool ('FindWordBookmark', 'Checked', CheckBox12.Checked);
  for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    sStr1 := TrimRight(saHistoryFindBookmark[iIndex]);
    IniFile.WriteString('FindWordBookmark', IntToStr(iIndex), sStr1);
    sStr1 := TrimRight(saHistoryFindNormal  [iIndex]);
    IniFile.WriteString('FindWordNormal', IntToStr(iIndex), sStr1);
  end;
  //ҏW
  IniFile.WriteBool ('FileEdit', 'Enabled', CheckBox1.Checked);
  //Obh
  IniFile.WriteBool ('GridMode', 'Enabled', CheckBox2.Checked);

  //摜TCY
  IniFile.WriteInteger ('DrawSize', 'Index', ComboBox3.ItemIndex);
  //tB[\[g
  IniFile.WriteInteger ('FileSort', 'Type', iFileSortType);
  //TutH_[
  IniFile.WriteBool ('FindSubFolder', 'Enabled', bFindSubFolder);
  //t@C
  IniFile.WriteBool ('NotCheckName', '01', baTargetFileNameNot[0]);
  IniFile.WriteBool ('NotCheckName', '02', baTargetFileNameNot[1]);
  IniFile.WriteBool ('NotCheckName', '03', baTargetFileNameNot[2]);
  //t@C
  IniFile.WriteBool ('CheckName', '01', baTargetFileName[0]);
  IniFile.WriteBool ('CheckName', '02', baTargetFileName[1]);
  IniFile.WriteBool ('CheckName', '03', baTargetFileName[2]);
  //gq
  IniFile.WriteBool ('CheckExt',  '01', baTargetFileExt [0]);
  IniFile.WriteBool ('CheckExt',  '02', baTargetFileExt [1]);
  IniFile.WriteBool ('CheckExt',  '03', baTargetFileExt [2]);
  IniFile.WriteBool ('CheckExt',  '04', baTargetFileExt [3]);
  IniFile.WriteBool ('CheckExt',  '05', baTargetFileExt [4]);
  IniFile.WriteBool ('CheckExt',  '06', baTargetFileExt [5]);
  IniFile.WriteBool ('CheckExt',  '07', baTargetFileExt [6]);
  IniFile.WriteBool ('CheckExt',  '08', baTargetFileExt [7]);
  IniFile.WriteBool ('CheckExt',  '09', baTargetFileExt [8]);
  //t@C
  sStr1 := TrimRight(saTargetFileNameNot[0]);
  IniFile.WriteString('NotTargetName', '01', sStr1);
  sStr1 := TrimRight(saTargetFileNameNot[1]);
  IniFile.WriteString('NotTargetName', '02', sStr1);
  sStr1 := TrimRight(saTargetFileNameNot[2]);
  IniFile.WriteString('NotTargetName', '03', sStr1);
  //t@C
  sStr1 := TrimRight(saTargetFileName[0]);
  IniFile.WriteString('TargetName', '01', sStr1);
  sStr1 := TrimRight(saTargetFileName[1]);
  IniFile.WriteString('TargetName', '02', sStr1);
  sStr1 := TrimRight(saTargetFileName[2]);
  IniFile.WriteString('TargetName', '03', sStr1);
  //gq
  sStr1 := TrimRight(saTargetFileExt [0]);
  IniFile.WriteString('TargetExt', '01' , sStr1);
  sStr1 := TrimRight(saTargetFileExt [1]);
  IniFile.WriteString('TargetExt', '02' , sStr1);
  sStr1 := TrimRight(saTargetFileExt [2]);
  IniFile.WriteString('TargetExt', '03' , sStr1);
  sStr1 := TrimRight(saTargetFileExt [3]);
  IniFile.WriteString('TargetExt', '04' , sStr1);
  sStr1 := TrimRight(saTargetFileExt [4]);
  IniFile.WriteString('TargetExt', '05' , sStr1);
  sStr1 := TrimRight(saTargetFileExt [5]);
  IniFile.WriteString('TargetExt', '06' , sStr1);
  sStr1 := TrimRight(saTargetFileExt [6]);
  IniFile.WriteString('TargetExt', '07' , sStr1);
  sStr1 := TrimRight(saTargetFileExt [7]);
  IniFile.WriteString('TargetExt', '08' , sStr1);
  sStr1 := TrimRight(saTargetFileExt [8]);
  IniFile.WriteString('TargetExt', '09' , sStr1);

  //F
  IniFile.WriteString('Editor',   'FontColor', ColorToString(ColorDialog1.Color));
  IniFile.WriteString('Viewer',   'FontColor', ColorToString(ColorDialog2.Color));
  IniFile.WriteString('Reserved', 'FontColor', ColorToString(ColorDialog3.Color));
  //
  IniFile.WriteBool ('Language', 'Japanese', MenuJapaneseSet.Checked);
  //Obhݒ
  IniFile.WriteBool ('GridWidth', 'Auto', MenuGridWidth.Checked);
  //BMPFݒ
  IniFile.WriteBool ('Bmp', '256Color', MenuBmp256Color.Checked);

  //
  IniFile.WriteString ('Editor1', 'FileName', sEditorFileName[0]);
  IniFile.WriteString ('Editor1', 'Option',   sEditorOption  [0]);
  IniFile.WriteString ('Editor2', 'FileName', sEditorFileName[1]);
  IniFile.WriteString ('Editor2', 'Option',   sEditorOption  [1]);
  IniFile.WriteString ('Editor3', 'FileName', sEditorFileName[2]);
  IniFile.WriteString ('Editor3', 'Option',   sEditorOption  [2]);
  IniFile.WriteString ('Editor4', 'FileName', sEditorFileName[3]);
  IniFile.WriteString ('Editor4', 'Option',   sEditorOption  [3]);
  //IvV
  IniFile.WriteBool ('CheckSearch', 'Case',    bsfrMatchCase);
  IniFile.WriteBool ('CheckSearch', 'Word',    bsfrWholeWord);
  IniFile.WriteBool ('CheckSearch', 'Zenkaku', bsfrNoMatchZenkaku);
  IniFile.WriteBool ('CheckSearch', 'CrLf',    bsfrIncludeCRLF);
  IniFile.WriteBool ('CheckSearch', 'Space',   bsfrIncludeSpace);

  //t@C
  IniFile.WriteString ('DrawWaitTime', '01', sDrawWaitTime);

  //j
  IniFile.Free;
end;

procedure TFormMain.BtnBrowseClick(Sender: TObject);
var
  sStr1: String;
begin
  //tH_[I
  if SHBrowseForFolderEx1.Execute = TRUE then
  begin
    //Oݒ
    sStr1 := SHBrowseForFolderEx1.FolderName;
    //NA
    sLatestFileName := '';
    //tH_Xg擾
    GetFolderList(BtnBrowse, sStr1);
  end;
end;

procedure TFormMain.BtnPrevViewClick(Sender: TObject);
begin
  //擪t@CłȂAA擪sȂÕt@C̍ŌɈړ
  if (ListBox1.ItemIndex <> 0) and (Editor1.Row = 0) then
  begin
    BtnPrevFileClick(Sender);
    if Editor1.Lines.Count > 0 then
    begin
      Editor1.Row := Editor1.Lines.Count-1;
      Editor1.TopRow := Editor1.Lines.Count-1;
    end;
  end
  //ʏ폈
  else
  begin
    BtnPageUpClick(Sender);
  end;
  //tH[JXړ
  if Sender = BtnPrevView then
  begin
    BtnPrevView.SetFocus;
  end;
end;

procedure TFormMain.BtnNextViewClick(Sender: TObject);
begin
  //ŏIt@CłȂAAŏIsȂ玟̃t@C̐擪Ɉړ
  //t@Ceꍇl
  if ((ListBox1.ItemIndex <> ListBox1.Count-1) and (Editor1.Lines.Count=0)) or
     ((ListBox1.ItemIndex <> ListBox1.Count-1) and (Editor1.Row = Editor1.Lines.Count-1)) then
  begin
    BtnNextFileClick(Sender);
    if Editor1.Lines.Count > 0 then
    begin
      Editor1.Row := 0;
      Editor1.TopRow := 0;
    end;
  end
  else
  //ʏ폈
  begin
    BtnPageDownClick(Sender);
  end;
  //tH[JXړ
  if Sender = BtnNextView then
  begin
    BtnNextView.SetFocus;
  end;
end;

procedure TFormMain.BtnPrevFileClick(Sender: TObject);
//var
//  key: Word;
begin
  //Õt@C
  //Xg̐擪傫
  if ListBox1.ItemIndex > 0 then
  begin
    //ݒ肵ĕ\
    ListBox1.ItemIndex := ListBox1.ItemIndex-1;
//    摜͕\Ȃɂ
//    //\҂
//    if DrawWait(Self, Key) then
//    begin
//      Exit;
//    end;
//    //摜`ݒ
//    bNeedDraw := TRUE;
    //\
    ReadFromFile(Sender);
    sLatestFileName := StrListFile[ListBox1.ItemIndex];
    //tH[JXړ
    if Sender = BtnPrevFile then
    begin
      BtnPrevFile.SetFocus;
    end;
  end;
end;

procedure TFormMain.BtnNextFileClick(Sender: TObject);
//var
//  key: Word;
begin
  //Xg̍Ō菬
  if ListBox1.ItemIndex < ListBox1.Count-1 then
  begin
    //ݒ肵ĕ\
    ListBox1.ItemIndex := ListBox1.ItemIndex+1;
//    摜͕\Ȃɂ
//    //\҂
//    if DrawWait(Self, Key) then
//    begin
//      Exit;
//    end;
//    //摜`ݒ
//    bNeedDraw := TRUE;
    //\
    ReadFromFile(Sender);
    sLatestFileName := StrListFile[ListBox1.ItemIndex];
    //tH[JXړ
    if Sender = BtnNextFile then
    begin
      BtnNextFile.SetFocus;
    end;
  end;
end;

procedure TFormMain.BtnFileSaveClick(Sender: TObject);
begin
  //ǂݍݔ
  if ListBox1.Count = 0 then
  begin
    //bZ[W\
    MsgNoFileForSave(Sender);
    Exit;
  end;
  //eLXg
  if (iDisplayMode = STRETCH_MODE) or (iDisplayMode = ORIGINAL_MODE) then
  begin
    //bZ[W\
    MsgFileTypeIsGraphic(Sender);
    Exit;
  end;
  //t@Cۑ
  if MsgSaveThisFile(Sender) = mrYes then
  begin
    //ۑ
    Editor1.Lines.SaveToFile(StrListFile.Strings[ListBox1.ItemIndex]);
    Editor1.Modified := FALSE;
    bTimerStop := TRUE;
  end;
end;

procedure TFormMain.BtnPageUpClick(Sender: TObject);
var
 iRow: Integer;
begin
  //y[WAbv
  //1ʕZ
  iRow := Editor1.TopRow - Editor1.RowCount;
  //擪s𒴂Ȃ
  if iRow >= 0 then
  begin
    Editor1.Row := iRow;
  end
  //擪s𒴂
  else
  begin
    Editor1.Row := 0;
  end;
  //\Jns̐ݒ
  Editor1.TopRow := Editor1.Row;
end;

procedure TFormMain.BtnPageDownClick(Sender: TObject);
var
 iRow: Integer;
begin
  //y[W_E
  //1ʕZ
  iRow := Editor1.TopRow + Editor1.RowCount;
  //ŏIs𒴂Ȃ
  if iRow <= Editor1.Lines.Count-1 then
  begin
    Editor1.Row := iRow;
  end
  //ŏIs𒴂
  else
  begin
    Editor1.Row := Editor1.Lines.Count-1;
  end;
  //\Jns̐ݒ
  Editor1.TopRow := Editor1.Row;
end;

procedure TFormMain.BtnReLoadClick(Sender: TObject);
var
  sStr1: String;
begin
  //XV
  sStr1 := ComboBox1.Text;
  UpdateFolderComboBox(sStr1);
  //tH_Xg擾
  GetFolderList(BtnReLoad, sStr1);
end;

procedure TFormMain.BtnHelpClick(Sender: TObject);
var
  sStr1: String;
begin
  //pl
  if iBtnSelect = BTN_INIT then
  begin
    //ݒ
    iBtnSelect := BTN_HELP;
    //ݒ
    sStr1 := ExtractFilePath(Paramstr(0)) + 'BONZO.TXT';
    if FileExists(sStr1) = TRUE then
    begin
      //ݒ
      Editor2.Marks.Underline.Visible := FALSE;
      //ݒ
      Editor2.Lines.BeginUpdate;
      try
        Editor2.Lines.Clear;
        Editor2.Lines.LoadFromFile(sStr1);
      finally
        Editor2.Lines.EndUpdate;
      end;
    end;
    //ړ
    Editor2.TopRow := 0;
    Editor2.TopCol := 0;
    Editor2.Row := 0;
    Editor2.Col := 0;
    //\ؑ
    Panel6.Visible := TRUE;
    Panel5.Visible := FALSE;
    Editor2.SetFocus;
    //ύX
    AllBtnDisabled(Self);
    TButton(Sender).Enabled := TRUE;
  end
  else
  begin
    //pl
    if iBtnSelect = BTN_HELP then
    begin
      //ݒ
      iBtnSelect := BTN_INIT;
      //\ؑ
      Panel5.Visible := TRUE;
      Panel6.Visible := FALSE;
      //ύX
      AllBtnEnabled(Self);
      TButton(Sender).Enabled := TRUE;
    end;
  end;
  //ݒ
  LanguageChange(Sender);
end;

procedure TFormMain.BtnFileListClick(Sender: TObject);
begin
  //ǂݍݔ
  if ListBox1.Count = 0 then
  begin
    //bZ[W\
    MsgNoFileForView(Sender);
    Exit;
  end;
  //pl
  if iBtnSelect = BTN_INIT then
  begin
    //ݒ
    iBtnSelect := BTN_FILELIST;
    //ݒ
    Editor2.Marks.Underline.Visible := TRUE;
    //ݒ
    Editor2.Lines.BeginUpdate;
    try
      Editor2.Lines.Clear;
      Editor2.Lines.Assign(StrListFile);
    finally
      Editor2.Lines.EndUpdate;
    end;
    //ړ
    Editor2.TopRow := ListBox1.ItemIndex;
    Editor2.TopCol := 0;
    Editor2.Row := ListBox1.ItemIndex;
    Editor2.Col := 0;
    //\ؑ
    Panel6.Visible := TRUE;
    Panel5.Visible := FALSE;
    Editor2.SetFocus;
    //ύX
    AllBtnDisabled(Self);
    TButton(Sender).Enabled := TRUE;
  end
  else
  begin
    //pl
    if iBtnSelect = BTN_FILELIST then
    begin
      //ݒ
      iBtnSelect := BTN_INIT;
      //\ؑ
      Panel5.Visible := TRUE;
      Panel6.Visible := FALSE;
      //ύX
      AllBtnEnabled(Self);
      TButton(Sender).Enabled := TRUE;
    end;
  end;
  //ݒ
  LanguageChange(Sender);
end;

procedure TFormMain.BtnReservedClick(Sender: TObject);
var
  sStr1: String;
begin
  //pl
  if iBtnSelect = BTN_INIT then
  begin
    //ݒ
    iBtnSelect := BTN_RESERVED;
    //\ؑ
    Panel7.Visible := TRUE;
    Panel5.Visible := FALSE;
    Editor3.SetFocus;
    //ύX
    AllBtnDisabled(Self);
    TButton(Sender).Enabled := TRUE;
    BtnReservedSave.Enabled := TRUE;
    //ݒ
    sStr1 := ExtractFilePath(Paramstr(0)) + RESERVED_SET;
    if FileExists(sStr1) = TRUE then
    begin
      Editor3.Lines.BeginUpdate;
      try
        Editor3.Lines.Clear;
        Editor3.Lines.LoadFromFile(sStr1);
        Editor3.Modified := FALSE;
      finally
        Editor3.Lines.EndUpdate;
      end;
    end;
    //ݒ
    sStr1 := ExtractFilePath(Paramstr(0)) + RESERVED_HIS;
    if FileExists(sStr1) = TRUE then
    begin
      Editor4.Lines.BeginUpdate;
      try
        Editor4.Lines.Clear;
        Editor4.Lines.LoadFromFile(sStr1);
        Editor4.Modified := FALSE;
      finally
        Editor4.Lines.EndUpdate;
      end;
    end;
  end
  else
  begin
    //pl
    if iBtnSelect = BTN_RESERVED then
    begin
      //ύXmF
      if Editor3.Modified = TRUE then
      begin
        //mF
        if MsgReserverWordIsModified_SaveFile(Sender) = mrYes then
        begin
          Exit;
        end
        else
        begin
          ;
        end;
      end;
      //ύXmF
      if Editor4.Modified = TRUE then
      begin
        //mF
        if MsgHistoryOfReservedIsModified_SaveFile(Sender) = mrYes then
        begin
          Exit;
        end
        else
        begin
          ;
        end;
      end;
      //ݒ
      iBtnSelect := BTN_INIT;
      //\ؑ
      Panel5.Visible := TRUE;
      Panel7.Visible := FALSE;
      //ύX
      AllBtnEnabled(Self);
      TButton(Sender).Enabled := TRUE;
      BtnReservedSave.Enabled := FALSE;
    end;
  end;
  //ݒ
  LanguageChange(Sender);
end;

procedure TFormMain.BtnReservedSaveClick(Sender: TObject);
var
  sStr1: String;
begin
  //ۑ
  sStr1 := ExtractFilePath(Paramstr(0)) + RESERVED_SET;
  Editor3.Lines.SaveToFile(sStr1);
  Editor3.Modified := FALSE;
  //ۑ
  sStr1 := ExtractFilePath(Paramstr(0)) + RESERVED_HIS;
  Editor4.Lines.SaveToFile(sStr1);
  Editor4.Modified := FALSE;
  //ݒ
  Editor1.ReserveWordList.Assign(Editor3.Lines);
end;

procedure TFormMain.BtnPrevWordClick(Sender: TObject);
begin
  SetSearchWord(Sender, PREV_WORD);
end;

procedure TFormMain.BtnNextWordClick(Sender: TObject);
begin
  SetSearchWord(Sender, NEXT_WORD);
end;

procedure TFormMain.SetSearchWord(Sender: TObject; Direction: Integer);
var
  bFind: Boolean;
  sStr1: String;
begin
  //
  if Edit1.Text <> '' then
  begin
    //STOPL rŒ~\ɂ
    bStopSearchWord := FALSE;
    iStopSearchWordCounter := 0;
    //̃tOŁA摜ǂݍ݂̐ɎgpĂ
    bSearching := TRUE;

    //XV
    sStr1 := Edit1.Text;
    UpdateFindComboBox(sStr1);

    //ݒ
    if bsfrMatchCase = TRUE then
    begin
      Include(fSearchOptions, sfrMatchCase);
    end
    else
    begin
      Exclude(fSearchOptions, sfrMatchCase);
    end;
    //ݒ
    if bsfrWholeWord = TRUE then
    begin
      Include(fSearchOptions, sfrWholeWord);
    end
    else
    begin
      Exclude(fSearchOptions, sfrWholeWord);
    end;
    //ݒ
    if  bsfrNoMatchZenkaku = TRUE then
    begin
      Include(fSearchOptions, sfrNoMatchZenkaku);
    end
    else
    begin
      Exclude(fSearchOptions, sfrNoMatchZenkaku);
    end;
    //ݒ
    if  bsfrIncludeCRLF = TRUE then
    begin
      Include(fSearchOptions, sfrIncludeCRLF);
    end
    else
    begin
      Exclude(fSearchOptions, sfrIncludeCRLF);
    end;
    //ݒ
    if  bsfrIncludeSpace = TRUE then
    begin
      Include(fSearchOptions, sfrIncludeSpace);
    end
    else
    begin
      Exclude(fSearchOptions, sfrIncludeSpace);
    end;
    //ݒ
    if Direction = PREV_WORD then
    begin
      Exclude(fSearchOptions, sfrDown);
    end
    else
    begin
      Include(fSearchOptions, sfrDown);
    end;
//    啶
//    if ChkMatchCase.Checked then
//    begin
//      Include(fSearchOptions, sfrMatchCase);
//    end;
//    PPʂŒT@
//    if ChkWholeWord.Checked then
//    begin
//      Include(fSearchOptions, sfrWholeWord);
//    end;
//    SppʂȂ
//    if ChkSameZenkakuHankaku.Checked then
//    begin
//      Include(fSearchOptions, sfrNoMatchZenkaku);
//    end;
//    sAXy[X𖳎
//    if ChkSkipCrLf.Checked then
//    begin
//      Include(fSearchOptions, sfrIncludeCRLF);
//      Include(fSearchOptions, sfrIncludeSpace);
//    end;
//    O
//    if RadioGroupDirection.ItemIndex = 1 then
//    begin
//      Include(fSearchOptions, sfrDown);
//    end;
//    ůmF
//    if ChkConfirmReplace.Checked then
//    begin
//      Include(fSearchOptions, sfrReplaceConfirm);
//    end;

    //ݒ
    sSearchValue := Edit1.Text;
    //Cʂ̎͏IɃ{^Đݒ肷
    if (Panel5.Visible = TRUE) then
    begin
      //Yt@CȖꍇ͌Ȃ
      if ListBox1.Count = 0 then
      begin
        Exit;
      end;
      //܂Ō
      bFind := FALSE;
      while bFind = FALSE do
      begin
        //\̃`cL̖h~
        iStopSearchWordCounter := iStopSearchWordCounter+1;
        if iStopSearchWordCounter = FIND_WORD_CONTROL_COUNT then
        begin
          //{^\
          AllBtnDisabled(Self);
          BtnStopSearchWord.Enabled := TRUE;
          BtnStopSearchWord.Visible := TRUE;
          BtnStopSearchWord.SetFocus;
          //ԑ҂
          SleepEx(SLEEP_TIME1);
        end;
        //JE^[̃I[ot[h~
        if iStopSearchWordCounter > FIND_WORD_CONTROL_COUNT then
        begin
          iStopSearchWordCounter := FIND_WORD_CONTROL_COUNT+1;
        end;
        //񌟍̃[`͂ł
        bFind := SearchWord(Self);
      end;
      //̃tOŁA摜ǂݍ݂̐ɎgpĂ
      bSearching := FALSE;
      //{^\
      AllBtnEnabled(Self);
    end;
    //CfbNXʂ̎̓{^͂̂܂
    if Panel8.Visible = TRUE then
    begin
      //
      if Editor5.Search(sSearchValue, fSearchOptions) = FALSE then
      begin
        //bZ[W\
        MsgCanNotFindWord(Self);
      end;
    end;
    //{^\
    BtnStopSearchWord.Visible := FALSE;
    //tH[JX߂
    if Sender = BtnPrevWord then
    begin
      BtnPrevWord.SetFocus;
    end;
    if Sender = BtnNextWord then
    begin
      BtnNextWord.SetFocus;
    end;
  end
  //񂪖ݒ
  else
  begin
    //bZ[W\
    MsgFindWordIsNotSet(Self);
  end;
end;

function TFormMain.SearchWord(Sender: TObject): Boolean;
begin
  //ݒ͑Ώۂ
  Result := FALSE;
  //
  if Editor1.Search(sSearchValue, fSearchOptions) then
  begin
    //ΏۂL
    Result := TRUE;
  end
  //Ȃ
  else
  begin
    //STOPL rŒ~\ɂ
    Application.ProcessMessages;
    if bStopSearchWord = TRUE then
    begin
      //bZ[W\
      MsgSearchWordStop(Self);
      //fĂI邽߂ɗLԂ
      Result := TRUE;
      Exit;
    end;

    //Ώۂꍇ
    if ListBox1.ItemIndex = -1 then
    begin
      //bZ[W\
      MsgNoFileForSearch(Sender);
      //Ώۂ̂ŁAI邽߂ɗLԂ
      Result := TRUE;
    end
    //擪t@C
    else if ListBox1.ItemIndex = 0 then
    begin
      //
      if sfrDown in fSearchOptions = TRUE then
      begin
        //1ꍇ́AIɂ
        if ListBox1.Count = 1 then
        begin
          //bZ[W\
          MsgCanNotFindWord(Sender);
          //I͈͂
          Editor1.SelLength := 0;
          //Ă̂ŁAI邽߂ɗLԂ
          Result := TRUE;
        end
        else
        begin
          //t@C
          BtnNextFileClick(Self);
          //J[\ŏɈړ
          Editor1.Lines.BeginUpdate;
          try
            Editor1.Row := 0;
            Editor1.Col := 0;
          finally
            Editor1.Lines.EndUpdate;
          end;
        end;
      end
      //O
      else
      begin
        //bZ[W\
        MsgCanNotFindWord(Sender);
        //I͈͂
        Editor1.SelLength := 0;
        //擪܂ŌĂ̂ŁAI邽߂ɗLԂ
        Result := TRUE;
      end;
    end
    //ŏIt@C
    else if ListBox1.ItemIndex = ListBox1.Count-1 then
    begin

      //
      if sfrDown in fSearchOptions = TRUE then
      begin
        //bZ[W\
        MsgCanNotFindWord(Sender);
        //I͈͂
        Editor1.SelLength := 0;
        //Ō܂ŌĂ̂ŁAI邽߂ɗLԂ
        Result := TRUE;
      end
      //O
      else
      begin
        //Ot@C
        BtnPrevFileClick(Self);
        //J[\ŌɈړ
        Editor1.Lines.BeginUpdate;
        try
          Editor1.Row := Editor1.Lines.Count-1;
          Editor1.Col := Editor1.ColCount-1;;
        finally
          Editor1.Lines.EndUpdate;
        end;
      end;
    end
    //Ԃ̃t@C
    else
    begin
      //
      if sfrDown in fSearchOptions = TRUE then
      begin
        //t@C
        BtnNextFileClick(Self);
        //J[\ŏɈړ
        Editor1.Lines.BeginUpdate;
        try
          Editor1.Row := 0;
          Editor1.Col := 0;
        finally
          Editor1.Lines.EndUpdate;
        end;
      end
      //O
      else
      begin
        //Ot@C
        BtnPrevFileClick(Self);
        //J[\ŌɈړ
        Editor1.Lines.BeginUpdate;
        try
          Editor1.Row := Editor1.Lines.Count-1;
          Editor1.Col := Editor1.ColCount-1;;
        finally
          Editor1.Lines.EndUpdate;
        end;
      end;
    end;
  end;
end;

procedure TFormMain.Panel4Resize(Sender: TObject);
begin
  //ĕ`
  ListBox1.Refresh;
end;

procedure TFormMain.Panel7Resize(Sender: TObject);
begin
  //ݒ
  Editor3.Width := Panel7.Width div 2;
end;

procedure TFormMain.CheckBox1Click(Sender: TObject);
begin
  //ҏWݒ
  if CheckBox1.Checked = TRUE then
  begin
    Editor1.ReadOnly := FALSE;
  end
  else
  begin
    Editor1.ReadOnly := TRUE;
  end;
  //Fݒ
  if CheckBox1.Checked = TRUE then
  begin
    Editor1.Font.Color := ColorDialog1.Color;
    //Fݒ
    CheckBox1.Font.Color := clRed;
  end
  else
  begin
    Editor1.Font.Color := ColorDialog2.Color;
    //Fݒ
    CheckBox1.Font.Color := clBlack;
  end;
end;

procedure TFormMain.ComboBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  sStr1: String;
begin
  //ENTERŌ{
  if key = VK_RETURN then
  begin
    //󔒂̏ꍇ́AXV̂
    if ComboBox1.Text = '' then
    begin
      //XV
      sStr1 := ComboBox1.Text;
      UpdateFolderComboBox(sStr1);
      //tH[JXړ
      ComboBox1.SetFocus;
      //
      key := 0;
    end
    //󔒂łȂꍇ́AXVČ
    else
    begin
      //NA
      sLatestFileName := '';
      //XV
      sStr1 := ComboBox1.Text;
      UpdateFolderComboBox(sStr1);
      //ēǂݍ
      BtnReLoadClick(Sender);
      //
      key := 0;
    end;
  end;
end;

procedure TFormMain.ComboBox1CloseUp(Sender: TObject);
var
  sStr1: String;
begin
  //󔒂̏ꍇ́AXV̂
  if ComboBox1.Text = '' then
  begin
    //XV
    sStr1 := ComboBox1.Text;
    UpdateFolderComboBox(sStr1);
    //tH[JXړ
    ComboBox1.SetFocus;
  end
  //󔒂łȂꍇ́AXVČ
  else
  begin
    //NA
    sLatestFileName := '';
    //XV
    sStr1 := ComboBox1.Text;
    UpdateFolderComboBox(sStr1);
    //ēǂݍ
    BtnReLoadClick(Sender);
  end;
end;

function  TFormMain.ConfirmDirectory(var sDirName: String): Boolean;
begin
  //tH_[̊mF
  Result := FALSE;
  if DirectoryExists(sDirName) = TRUE then
  begin
    //Ōオ \ Ȃ炻̂܂
    if LastDelimiter('\', sDirName) = Length(sDirName) then
    begin
      ;
    end
    //Ōオ \ łȂ \ ǉ
    else
    begin
      sDirName := sDirName + '\';
    end;
    Result := TRUE;
  end;
end;

procedure TFormMain.CheckBox11Click(Sender: TObject);
var
  iIndex: Integer;
begin
  //`FbN
  if CheckBox11.Checked = TRUE then
  begin
    //̐ݒۑ
    for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
    begin
      saHistoryFolderNormal[iIndex] := ComboBox1.Items.Strings[iIndex];
    end;
    //Vݒ𔽉f
    ComboBox1.Items.Clear;
    for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
    begin
      ComboBox1.Items.Add(saHistoryFolderBookmark[iIndex]);
    end;
    ComboBox1.ItemIndex := 0;
    //Fݒ
    CheckBox11.Font.Color := clRed;
  end
  //`FbN
  else
  begin
    //̐ݒۑ
    for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
    begin
      saHistoryFolderBookmark[iIndex] := ComboBox1.Items.Strings[iIndex];
    end;
    //Vݒ𔽉f
    ComboBox1.Items.Clear;
    for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
    begin
      ComboBox1.Items.Add(saHistoryFolderNormal  [iIndex]);
    end;
    ComboBox1.ItemIndex := 0;
    //Fݒ
    CheckBox11.Font.Color := clBlack;
  end;
end;

procedure TFormMain.CheckBox12Click(Sender: TObject);
var
  iIndex: Integer;
begin
  //`FbN
  if CheckBox12.Checked = TRUE then
  begin
    //̐ݒۑ
    for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
    begin
      saHistoryFindNormal[iIndex] := ComboBox2.Items.Strings[iIndex];
    end;
    //Vݒ𔽉f
    ComboBox2.Items.Clear;
    for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
    begin
      ComboBox2.Items.Add(saHistoryFindBookmark[iIndex]);
    end;
    ComboBox2.ItemIndex := 0;
    //Fݒ
    CheckBox12.Font.Color := clRed;
  end
  //`FbN
  else
  begin
    //̐ݒۑ
    for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
    begin
      saHistoryFindBookmark[iIndex] := ComboBox2.Items.Strings[iIndex];
    end;
    //Vݒ𔽉f
    ComboBox2.Items.Clear;
    for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
    begin
      ComboBox2.Items.Add(saHistoryFindNormal  [iIndex]);
    end;
    ComboBox2.ItemIndex := 0;
    //Fݒ
    CheckBox12.Font.Color := clBlack;
  end;
end;

procedure TFormMain.SetFileExt(Checked: Boolean; Src: String; var Dst: String);
begin
  //gqݒ ŏ.Ŏn߂
  if Checked = FALSE then
  begin
    Dst := '.***';
  end
  else if (Src = '') then
  begin
    Dst := '.***';
  end
  else
  begin
    if (Pos('.', Src) <> 1) then
    begin
      Dst := '.' + UpperCase(Src);
    end
    else
    begin
      Dst :=       UpperCase(Src);
    end;
  end;
end;

procedure TFormMain.SetFileName(Checked: Boolean; Src: String; var Dst: String);
begin
  //ݒ
  if Checked = FALSE then
  begin
    Dst := '********.***';
  end
  else if (Src = '') then
  begin
    Dst := '********.***';
  end
  else
  begin
    Dst := UpperCase(Src);
  end;
end;

procedure TFormMain.GetFileList(Sender: TObject; var sDirName: String);
var
  iIndex: Integer;
  DirName: String;
  sTargetExt1: String;
  sTargetExt2: String;
  sTargetExt3: String;
  sTargetExt4: String;
  sTargetExt5: String;
  sTargetExt6: String;
  sTargetExt7: String;
  sTargetExt8: String;
  sTargetExt9: String;
  sTargetFile1: String;
  sTargetFile2: String;
  sTargetFile3: String;
  sTargetFileNot1: String;
  sTargetFileNot2: String;
  sTargetFileNot3: String;
  Attr: Word;          //faReadOnly, faHidden, faSysFile, faVolumeID, faDirectory, faArchive, faAnyfile
  AddnoAttr: Boolean;  //TRUE: Ȃt@C  FALSE: Ȃt@CȂ
  ClrFlag: Boolean;    //TRUE: VK  FALSE: ǉ
  TheList: TStringList;//ۑ郊Xg
  Gosubdir: Boolean;   //TRUE:TufBNgΏ
  AddYen: Boolean;     //TRUE: fBNgȂ \ ǉ  FALSE: fBNgł \ ǉȂ
  Noreadonly: Boolean; //TRUE: ReadOnly/Hidden   FALSE: ReadOnly/Hidden Ȃ
begin
  //
  Editor1.Lines.BeginUpdate;
  try
    Editor1.Lines.Clear;
  finally
    Editor1.Lines.EndUpdate;
  end;
  //
  ListBox1.Items.BeginUpdate;
  try
    ListBox1.Clear;
  finally
    ListBox1.Items.EndUpdate;
  end;
  //
  StrListFolder.Clear;
  StrListFile.Clear;

  //ݒ
  DirName := sDirName;
  Attr := faAnyFile;
  AddnoAttr := TRUE;
  ClrFlag := TRUE;
  TheList := StrListFolder;
  if bFindSubFolder = TRUE then
  begin
    Gosubdir := TRUE;
    AddYen := TRUE;
  end
  else
  begin
    Gosubdir := FALSE;
    AddYen := FALSE;
  end;
  Noreadonly := FALSE;
  //gqݒ ŏ.Ŏn߂
  SetFileExt(baTargetFileExt[0],   saTargetFileExt [0], sTargetExt1);
  SetFileExt(baTargetFileExt[1],   saTargetFileExt [1], sTargetExt2);
  SetFileExt(baTargetFileExt[2],   saTargetFileExt [2], sTargetExt3);
  SetFileExt(baTargetFileExt[3],   saTargetFileExt [3], sTargetExt4);
  SetFileExt(baTargetFileExt[4],   saTargetFileExt [4], sTargetExt5);
  SetFileExt(baTargetFileExt[5],   saTargetFileExt [5], sTargetExt6);
  SetFileExt(baTargetFileExt[6],   saTargetFileExt [6], sTargetExt7);
  SetFileExt(baTargetFileExt[7],   saTargetFileExt [7], sTargetExt8);
  SetFileExt(baTargetFileExt[8],   saTargetFileExt [8], sTargetExt9);
  //t@Cݒ
  SetFileName(baTargetFileName[0], saTargetFileName[0], sTargetFile1);
  SetFileName(baTargetFileName[1], saTargetFileName[1], sTargetFile2);
  SetFileName(baTargetFileName[2], saTargetFileName[2], sTargetFile3);
  //t@Cݒ
  SetFileName(baTargetFileNameNot[0], saTargetFileNameNot[0], sTargetFileNot1);
  SetFileName(baTargetFileNameNot[1], saTargetFileNameNot[1], sTargetFileNot2);
  SetFileName(baTargetFileNameNot[2], saTargetFileNameNot[2], sTargetFileNot3);
  //tH_[mF
  if ConfirmDirectory(DirName) = TRUE then
  begin
    //t@C̕\NA
    iFileListCount := 0;
    Label6.Caption := 'File:00000/00000';
    Label6.Update;
    Label10.Caption := 'List:000000';
    Label10.Update;
    //{^\
    AllBtnDisabled(Self);
    BtnStopListFile.Enabled := TRUE;
    BtnStopListFile.Visible := TRUE;
    BtnStopListFile.SetFocus;
    //ԑ҂
    SleepEx(SLEEP_TIME1);
    //STOPL rŒ~\ɂ
    bStopListFiles := FALSE;

    //\[gݒ
    if (iFileSortType = 1) or (iFileSortType = 2) then
    begin
      StrListFolder.Sorted := TRUE;
    end
    else
    begin
      StrListFolder.Sorted := FALSE;
    end;
    //t@Cꗗ̎擾 rŒ~̏s
    ListFiles (DirName, Attr, AddnoAttr, ClrFlag, TheList, Gosubdir, AddYen, Noreadonly,
               bStopListFiles, iFileListCount);
    if bStopListFiles = TRUE then
    begin
      //~̏
      //XgNAɂ鎖ŉȂꍇƓɂ
      StrListFolder.Clear;
      //bZ[W\
      //
    end;
    //Y
    if StrListFolder.Count > 0 then
    begin
      //Ygq̃t@Ĉݔo
      ListBox1.Items.BeginUpdate;
      try
        //\[gݒ
        if (iFileSortType = 0) or (iFileSortType = 1) then
        begin
          //AtoZ
          for iIndex := 0 to StrListFolder.Count-1 do
          begin
            //ΏۊÕt@Cr
            if (UpperCase(ExtractFileName(StrListFolder.Strings[iIndex])) = sTargetFileNot1) or
               (UpperCase(ExtractFileName(StrListFolder.Strings[iIndex])) = sTargetFileNot2) or
               (UpperCase(ExtractFileName(StrListFolder.Strings[iIndex])) = sTargetFileNot3) then
            begin
              ;
            end
            //gqr
            //t@Cr
            //t@Chbvꂽꍇ́AgqłȂt@CŒT
            else if (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt1 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt2 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt3 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt4 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt5 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt6 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt7 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt8 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt9 ) or
                    (UpperCase(ExtractFileName(StrListFolder.Strings[iIndex])) = sTargetFile1) or
                    (UpperCase(ExtractFileName(StrListFolder.Strings[iIndex])) = sTargetFile2) or
                    (UpperCase(ExtractFileName(StrListFolder.Strings[iIndex])) = sTargetFile3) or
                    (UpperCase(StrListFolder.Strings[iIndex])                  = UpperCase(sLatestFileName)) then
            begin
              //ꗗXgƃXg{bNXɐݒ
              StrListFile.Add(StrListFolder.Strings[iIndex]);
              ListBox1.Items.Add(ExtractFileName(StrListFolder.Strings[iIndex]));
            end
            else
            begin
              ;
            end;
          end;
        end
        else
        begin
          //ZtoA
          for iIndex := StrListFolder.Count-1 downto 0 do
          begin
            //ΏۊÕt@Cr
            if (UpperCase(ExtractFileName(StrListFolder.Strings[iIndex])) = sTargetFileNot1) or
               (UpperCase(ExtractFileName(StrListFolder.Strings[iIndex])) = sTargetFileNot2) or
               (UpperCase(ExtractFileName(StrListFolder.Strings[iIndex])) = sTargetFileNot3) then
            begin
              ;
            end
            //gqr
            //t@Cr
            //t@Chbvꂽꍇ́AgqłȂt@CŒT
            else if (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt1 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt2 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt3 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt4 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt5 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt6 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt7 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt8 ) or
                    (UpperCase(ExtractFileExt (StrListFolder.Strings[iIndex])) = sTargetExt9 ) or
                    (UpperCase(ExtractFileName(StrListFolder.Strings[iIndex])) = sTargetFile1) or
                    (UpperCase(ExtractFileName(StrListFolder.Strings[iIndex])) = sTargetFile2) or
                    (UpperCase(ExtractFileName(StrListFolder.Strings[iIndex])) = sTargetFile3) or
                    (UpperCase(StrListFolder.Strings[iIndex])                  = UpperCase(sLatestFileName)) then
            begin
              //ꗗXgƃXg{bNXɐݒ
              StrListFile.Add(StrListFolder.Strings[iIndex]);
              ListBox1.Items.Add(ExtractFileName(StrListFolder.Strings[iIndex]));
            end
            else
            begin
              ;
            end;
          end;
        end;
      finally
        ListBox1.Items.EndUpdate;
      end;

      //Y
      if ListBox1.Count > 0 then
      begin
        //
        ListBox1.Items.BeginUpdate;
        try
          ListBox1.ItemIndex := 0;
        finally
          ListBox1.Items.EndUpdate;
       end;
      end
      //YȂ
      else
      begin
        //
        Listbox1.ItemIndex := -1;
        //bZ[W\
        MsgNoFileForView(Self);
      end;
    end
    //YȂ
    else
    begin
      //
      Listbox1.ItemIndex := -1;
      //bZ[W\
      MsgNoFileForView(Self);
    end;
    //{^\
    BtnStopListFile.Visible := FALSE;
    AllBtnEnabled(Self);
    //tH[JXݒ
    if FormMain.Showing = TRUE then
    begin
      //Y
      if ListBox1.Count > 0 then
      begin
        Listbox1.SetFocus;
      end
      //YȂ
      else
      begin
        //
        Listbox1.ItemIndex := -1;
        //tH[JXړ
        if (Sender = BtnBrowse) then
        begin
          BtnBrowse.SetFocus;
        end;
        if (Sender = BtnReload) then
        begin
          BtnReload.SetFocus;
        end;
      end
    end;
  end
  else
  begin
    //
    Listbox1.ItemIndex := -1;
    //bZ[W\
    MsgNoFolderForSearch(Self);
    //tH[JXړ
    if (Sender = BtnBrowse) then
    begin
      BtnBrowse.SetFocus;
    end;
    if (Sender = BtnReload) then
    begin
      BtnReload.SetFocus;
    end;
  end;
end;

procedure TFormMain.ReadFromFile(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  iIndex: Integer;
  iColMax: Integer;
  iCol2: Integer;
  iRow1: Integer;
  iRow2: Integer;
  iCnt: Integer;
  iFontWidth: Integer;
  iGridWidth: Integer;
begin
  //
  iDisplayMode := INIT_MODE;
  //Y
  if ListBox1.Count > 0 then
  begin
    //\
    iIndex := ListBox1.ItemIndex;
    sStr1 := StrListFile.Strings[iIndex];
    Label9.Caption := Copy(sStr1, Length(ComboBox1.Text)+1, Length(sStr1));
    if FileExists(sStr1) = TRUE then
    begin
      //摜̏ꍇ
      if (UpperCase(ExtractFileExt(sStr1)) = '.JPG' ) or
         (UpperCase(ExtractFileExt(sStr1)) = '.JPEG') or
         (UpperCase(ExtractFileExt(sStr1)) = '.BMP' ) then
      begin
        //Fit / Auto ̐؂ւ
        FlipFitSizeOrAutoSize(Self);
        //NA
        Editor1.Lines.BeginUpdate;
        try
          Editor1.Lines.Clear;
          Editor1.TopRow := 0;
          Editor1.TopCol := 0;
          Editor1.Top := 0;
          Editor1.Col := 0;
        finally
          Editor1.Lines.EndUpdate;
        end;
        //ύXNA
        Editor1.Modified := FALSE;

        //łȂA摜\svłȂAꍇ͉ʂXV
        if (bSearching = FALSE) and (bNeedDraw = TRUE) then
        begin
          //摜̕\
          DrawBmpFile(sStr1, MenuBmp256Color.Checked);
          //摜`ݒ
          bNeedDraw := FALSE;
          //摜]
          DrawImageRotate(Sender);
          //摜I
          DrawImageSelect(Sender);
          //摜IȊO(Fit, Auto...)̏ꍇ
          if Sender <> ComboBox3 then
          begin
            ListBox1.SetFocus;
          end;
        end
        else
        begin
          DrawBmpFileClear(Self);
        end;
       //摜\珉
       tKeyTimeout := 0;
      end
      //摜ȊO
      else
      begin
        //eLXg\ݒ
        if CheckBox2.Checked = TRUE then
        begin
          iDisplayMode := GRID_MODE;
        end
        else
        begin
          iDisplayMode := TEXT_MODE;
        end;
        //Ǎ
        Editor1.Lines.BeginUpdate;
        try
          Editor1.Lines.LoadFromFile(sStr1);
          Editor1.TopRow := 0;
          Editor1.TopCol := 0;
          Editor1.Top := 0;
          Editor1.Col := 0;
        finally
          Editor1.Lines.EndUpdate;
        end;
        //ύXNA
        Editor1.Modified := FALSE;
        bTimerStop := TRUE;
      end
    end;
  end
  //YȂ
  else
  begin
    Label9.Caption := '';
  end;
  //\
  Label6.Caption  := 'File:' + Format('%.5d',[ListBox1.ItemIndex+1]) + '/' + Format('%.5d',[ListBox1.Count]);
  Label10.Caption := 'List:' + Format('%.6d',[iFileListCount]);


  //eNA
  for iRow2 := 0 to StringGrid1.RowCount-1 do
  begin
    for iCol2 := 0 to StringGrid1.ColCount-1 do
    begin
      StringGrid1.Cells[iCol2, iRow2] := '';
    end;
  end;

  //
  for iCnt := Low(iaGridWidth) to High(iaGridWidth) do
  begin
    iaGridWidth[iCnt] := 0;
  end;

  //t@Ce΃ObhɓWJ@
  if Editor1.Lines.Count > 0 then
  begin
    //ݒ
    StringGrid1.RowCount := Editor1.Lines.Count+1;
    StringGrid1.ColCount := 2;
    iColMax := StringGrid1.ColCount;
    iRow2 := 1;
    //1̕߂
    iFontWidth := StringGrid1.Canvas.TextWidth('W');
    //WJ
    for iRow1 := 0 to Editor1.Lines.Count-1 do
    begin
      //
      sStr2 := Editor1.Lines.Strings[iRow1];
      CsvList.Clear;
      StringToCsvList(sStr2, CsvList);
      //Obh̕߂
      for iCnt := 0 to CsvList.Count-1 do
      begin
        iGridWidth := iFontWidth * Length(CsvList.Strings[iCnt]);
        if iGridWidth > iaGridWidth[iCnt] then
        begin
          iaGridWidth[iCnt] := iGridWidth;
        end;
      end;
      //RύX  FixedCol ̂ +1 Ă
      if CsvList.Count+1 > iColMax then
      begin
        StringGrid1.ColCount := CsvList.Count+1;
        iColMax := StringGrid1.ColCount;
      end;
      //ݒ
      StringGrid1.Cells[0, iRow2] := Format('%6.6d',[iRow2]);
      for iCol2 := 0 to CsvList.Count-1 do
      begin
        StringGrid1.Cells[iCol2+1, iRow2] := CsvList.Strings[iCol2];
      end;
      iRow2 := iRow2 + 1;
    end;
    //Obh̕𔽉f
    SetGridWidth(Sender);
  end
  //t@Ce΃Obĥݐݒ
  else
  begin
    //ݒ
    StringGrid1.RowCount := 2;
    StringGrid1.ColCount := 2;
    StringGrid1.Row := 1;
    StringGrid1.Col := 1;
    //ݒ
    StringGrid1.ColWidths[1] := StringGrid1.ColWidths[0];
  end;

  //LvV\
  if ListBox1.Count > 0 then
  begin
    FormMain.Caption := FORM_CAPTION    + '  ' +
                        StrListFile.Strings[ListBox1.itemindex];
  end;

  //摜I
  DrawImageSelect(Sender);
  //Grid/Textؑ
  CheckBox2Click(Self);
end;

procedure TFormMain.UpdateFolderComboBox(var sDirName: String);
var
  iIndex: Integer;
begin
  //ubN}[N͍̎XVȂ
  if CheckBox11.Checked = TRUE then
  begin
    Exit;
  end;

  //
  StrListTmp.Clear;
  //擪ɍ̃tH_[ǉ
  StrListTmp.Add(sDirName);
  //݂̐ݒǉ
  for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    StrListTmp.Add(ComboBox1.Items.Strings[iIndex]);
  end;
  //擪Ɠe΍폜
  for iIndex := 0 to StrListTmp.Count-2 do
  begin
    if StrListTmp.Strings[iIndex+1] = StrListTmp.Strings[0] then
    begin
      StrListTmp.Delete(iIndex+1);
      Break;
    end;
  end;
  //󔒂͍ŌɈړ
  for iIndex := 0 to StrListTmp.Count-1 do
  begin
    if StrListTmp.Strings[iIndex] = '' then
    begin
      StrListTmp.Move(iIndex, StrListTmp.Count-1);
    end;
  end;
  //擪w萔̂݃Rs[̂ŁAeȂ΍Ōオ폜
  ComboBox1.Items.Clear;
  for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    ComboBox1.Items.Add(StrListTmp.Strings[iIndex]) ;
  end;
  //tH[JXݒ
  ListBox1.SetFocus;
  //擪I
  ComboBox1.ItemIndex :=0;

  //ɔf
  for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    if CheckBox11.Checked = TRUE then
    begin
      saHistoryFolderBookmark[iIndex] := ComboBox1.Items.Strings[iIndex];
    end
    else
    begin
      saHistoryFolderNormal[iIndex] := ComboBox1.Items.Strings[iIndex];
    end;
  end;
end;

procedure TFormMain.UpdateFindComboBox(var sFindWord: String);
var
  iIndex: Integer;
begin
  //ubN}[N͍̎XVȂ
  if CheckBox12.Checked = TRUE then
  begin
    Exit;
  end;

  //
  StrListTmp.Clear;
  //擪ɍ̃tH_[ǉ
  StrListTmp.Add(sFindWord);
  //݂̐ݒǉ
  for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    StrListTmp.Add(ComboBox2.Items.Strings[iIndex]);
  end;
  //擪Ɠe΍폜
  for iIndex := 0 to StrListTmp.Count-2 do
  begin
    if StrListTmp.Strings[iIndex+1] = StrListTmp.Strings[0] then
    begin
      StrListTmp.Delete(iIndex+1);
      Break;
    end;
  end;
  //󔒂͍ŌɈړ
  for iIndex := 0 to StrListTmp.Count-1 do
  begin
    if StrListTmp.Strings[iIndex] = '' then
    begin
      StrListTmp.Move(iIndex, StrListTmp.Count-1);
    end;
  end;
  //擪w萔̂݃Rs[̂ŁAeȂ΍Ōオ폜
  ComboBox2.Items.Clear;
  for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    ComboBox2.Items.Add(StrListTmp.Strings[iIndex]) ;
  end;
  //擪I
  ComboBox2.ItemIndex :=0;

  //ɔf
  for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    if CheckBox12.Checked = TRUE then
    begin
      saHistoryFindBookmark[iIndex] := ComboBox2.Items.Strings[iIndex];
    end
    else
    begin
      saHistoryFindNormal[iIndex]   := ComboBox2.Items.Strings[iIndex];
    end;
  end;
end;

procedure TFormMain.Editor1Change(Sender: TObject);
begin
  //ݒ
  LanguageChange(Sender);
  //\XV
  Timer1.Enabled := TRUE;
  bTimerStop := FALSE;
end;

procedure TFormMain.ListBox1DrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  //tH[JX
  if Listbox1.Focused = TRUE then
  begin
    //I
    if odSelected in State then
    begin
      Listbox1.Canvas.Brush.Color := clSkyBlue;
      Listbox1.Canvas.Font.Color := clWindowText;
    end;
  end
  //tH[JXȂ
  else
  begin
    //I
    if odSelected in State then
    begin
      Listbox1.Canvas.Brush.Color := clLtGray;
      Listbox1.Canvas.Font.Color := clWindowText;
    end;
  end;
  //\
  Listbox1.Canvas.FillRect(Rect);
  Listbox1.Canvas.TextOut(Rect.Left, Rect.Top, Listbox1.Items[Index]);
end;

procedure TFormMain.Edit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ENTERŌ{
  if key = VK_RETURN then
  begin
     BtnNextWordClick(Sender);
     key := 0
  end;
end;

procedure TFormMain.GetFolderList(Sender: TObject; var sFileName: String);
var
  iCnt: Integer;
  sStr1: String;
  sStr2: String;
begin
  //mF
  ConfirmDirectory(sFileName);
  //[g̎͊mF
  if Length(sFileName) = 3 then
  begin
    if MsgSearchTargetIsRootOfDrive(Self) <> mrYes then
    begin
      if (Sender = BtnBrowse) then
      begin
        BtnBrowse.SetFocus;
      end;
      if (Sender = BtnReload) then
      begin
        BtnReload.SetFocus;
      end;
      Exit;
    end;
  end;
  //\XV
  FormMain.Caption := FORM_CAPTION;
  Label6.Caption  := 'File:00000/00000';
  Label10.Caption := 'List:000000';
  Label9.Caption  := '';
  //XV
  UpdateFolderComboBox(sFileName);
  //ꗗ̎擾{
  Timer2.Enabled := TRUE;
  GetFileList(Sender, sFileName);
  Timer2.Enabled := FALSE;
  //t@C
  if ListBox1.Count > 0 then
  begin
    for iCnt := 0 to ListBox1.Count-1 do
    begin
      sStr1 := UpperCase(StrListFile.Strings[iCnt]);
      sStr2 := UpperCase(sLatestFileName);
      if sStr1 = sStr2 then
      begin
        ListBox1.ItemIndex := iCnt;
        Break;
      end;
    end;
  end;
  //t@Cǂݍ
  if ListBox1.Count > 0 then
  begin
    bNeedDraw := TRUE;
    ReadFromFile(Self);
    sLatestFileName := StrListFile[ListBox1.ItemIndex];
  end;
  //1傫ꍇ
  if ListBox1.Count > 1 then
  begin
    ListBox1.SetFocus;
  end;
  //1̏ꍇ
  if (ListBox1.Count = 1) and (iDisplayMode = TEXT_MODE) then
  begin
    Editor1.SetFocus;
  end;
  if (ListBox1.Count = 1) and (iDisplayMode = GRID_MODE) then
  begin
    StringGrid1.SetFocus;
  end;
end;

procedure TFormMain.SetGridWidth(Sender: TObject);
var
  iCol1: Integer;
begin
  //Obh̕𔽉f
  for iCol1 := Low(iaGridWidth) to High(iaGridWidth) do
  begin
    //l 0 łȂԂ͔f
    if iaGridWidth[iCol1] = 0 then
    begin
      Break;
    end;
    //ݒ
    if MenuGridWidth.Checked = TRUE then
    begin
      StringGrid1.ColWidths[iCol1+1] := iaGridWidth[iCol1];
    end
    else
    begin
      StringGrid1.ColWidths[iCol1+1] := GRID_WIDTH;
    end;
  end;
end;

procedure TFormMain.ExecuteProgram(sFileName: String; sOption: String);
var
  ErrCode: Integer;
  sStrExe: String;
  sStrOpt: String;
  iPos: Integer;
begin
  //ǂݍݔ
  if ListBox1.Count = 0 then
  begin
    //bZ[W\
    MsgNoFileForEdit(Self);
    Exit;
  end;
  //t@C
  if FileExists(StrListFile[ListBox1.ItemIndex]) = FALSE then
  begin
    //bZ[W\
    MsgNoFileForEdit(Self);
    Exit;
  end;
  //t@Cݒ̔
  if FileExists(sFileName) = FALSE then
  begin
    //bZ[W\
    MsgCanNotFindExecuteFile(Self);
    Exit;
  end;
  //t@Cݒ̔
  iPos := Pos('%f', sOption);
  if iPos = 0 then
  begin
    //bZ[W\
    MsgCanNotFindOptionFaileName(Self);
    Exit;
  end;
//  //eLXg
//  if (iDisplayMode = STRETCH_MODE) or (iDisplayMode = ORIGINAL_MODE) then
//  begin
//    //bZ[W\
//    MsgFileTypeIsGraphic(Self);
//    Exit;
//  end;

  //ݒ
  sStrExe := sFileName;
  sStrOpt := AnsiReplaceText(sOption, '%f', '"' + StrListFile[ListBox1.ItemIndex] + '"');
  //N
  ErrCode := ShellExecute(Handle,
                          'open',
                          PChar(sStrExe),
                          PChar(sStrOpt),
                          PChar(ExtractFilePath(sStrExe)),
                          SW_SHOWDEFAULT);
  //vO̎sɎs
  if ErrCode <= 32 then
  begin
    //bZ[W\
    MsgFailedExecuteEditor(Self);
  end
end;

procedure TFormMain.BtnReadIndexClick(Sender: TObject);
var
  sStr1: String;
begin
  //pl
  if iBtnSelect = BTN_INIT then
  begin
    //ݒ
    iBtnSelect := BTN_INDEX;
    //eݒ
    sStr1 := ExtractFilePath(Paramstr(0)) + FILE_INDEX;
    if FileExists(sStr1) = TRUE then
    begin
      Editor5.Lines.BeginUpdate;
      try
        Editor5.Lines.Clear;
        Editor5.Lines.LoadFromFile(sStr1);
      finally
        Editor5.Lines.EndUpdate;
      end;
    end;
    Editor5.Modified := FALSE;
    //\ؑ
    Panel8.Visible := TRUE;
    Panel5.Visible := FALSE;
    Editor5.SetFocus;
    //ύX
    AllBtnDisabled(Self);
    TButton(Sender).Enabled := TRUE;
    BtnMakeIndex.Enabled := TRUE;
    BtnSaveIndex.Enabled := TRUE;
    BtnPrevWord.Enabled := TRUE;
    BtnNextWord.Enabled := TRUE;
    ComboBox2.Enabled := TRUE;
    Edit1.Enabled := TRUE;
    MenuSearch.Enabled := TRUE;
    MenuFind.Enabled := TRUE;
    MenuPrevWord.Enabled := TRUE;
    MenuNextWord.Enabled := TRUE;
  end
  else
  begin
    //pl
    if iBtnSelect = BTN_INDEX then
    begin
      //ύXmF
      if Editor5.Modified = TRUE then
      begin
        //mF
        if MsgIndexFileIsModified_DoYouExit(Sender) <> mrYes then
        begin
          Exit;
        end
        else
        begin
          ;
        end;
      end;
      //ݒ
      iBtnSelect := BTN_INIT;
      //\ؑ
      Panel5.Visible := TRUE;
      Panel8.Visible := FALSE;
      //ύX
      AllBtnEnabled(Self);
      TButton(Sender).Enabled := TRUE;
    end;
  end;
  //ݒ
  LanguageChange(Sender);
end;

procedure TFormMain.BtnMakeIndexClick(Sender: TObject);
var
  iRow1: Integer;
  iRow2: Integer;
  iFindRow1: Integer;
  iFindRow2: Integer;
  iFindPos1: Integer;
  sStr1: String;
begin
  //Y
  if ListBox1.Count > 0 then
  begin
    //NA
    Editor5.Lines.BeginUpdate;
    try
      Editor5.Lines.Clear;
    finally
      Editor5.Lines.EndUpdate;
    end;
    Editor5.Repaint;
    //ԑ҂
    SleepEx(SLEEP_TIME1);
    //Ō܂Ō
    for iRow1 := 0 to ListBox1.Count-1 do
    begin
      //t@Cǂݍ
      sStr1 := StrListFile.Strings[iRow1];
      if FileExists(sStr1) = TRUE then
      begin
        Editor10.Lines.LoadFromFile(sStr1);
        //g
        if Editor10.Lines.Count > 0 then
        begin
          //
          iFindRow1 := -1;
          iFindRow2 := -1;
          //Ō܂
          for iRow2 := 0 to Editor10.Lines.Count-1 do
          begin
            //L[[h
            iFindPos1 := Pos(SEPARATE_MARKER, Editor10.Lines.Strings[iRow2]);
            //L[[hL
            if iFindPos1 > 0 then
            begin
              //2
              if (iFindRow1 > -1) and (iFindRow2 = -1) then
              begin
                iFindRow2 := iRow2;
                Break;
              end;
              //1
              if iFindRow1 = -1 then
              begin
                iFindRow1 := iRow2;
              end;
            end;
          end;
          //2L
          if (iFindRow1 > -1) and (iFindRow2 > -1) then
          begin
            //
            Editor5.Lines.BeginUpdate;
            try
              //t@C
              Editor5.Lines.Add(' ' + sStr1);
              //͈͂o
              for iRow2 := iFindRow1 to iFindRow2 do
              begin
                Editor5.Lines.Add(Editor10.Lines.Strings[iRow2]);
              end;
              //s
              Editor5.Lines.Add('');
            finally
              Editor5.Lines.EndUpdate;
            end;
          end;
        end;
      end;
    end;
    //
    Editor5.SetFocus;
    EDitor5.Row := 0;
    EDitor5.TopRow := 0;
  end
  else
  begin
    //bZ[W\
    MsgNoFileForMakingIndexFile(Sender);
  end;;
end;

procedure TFormMain.Editor5DblClick(Sender: TObject);
var
  sStr1: String;
  sStr2: String;
  iRow1: Integer;
  iPos1: Integer;
begin
  //t@Ce̔
  if Editor5.Lines.Count > 0 then
  begin
    //ݒ
    sStr1 := Editor5.Lines.Strings[Editor5.Row];
    sStr2 := Copy(sStr1, 4, Length(sSTr1));
    //
    for iRow1 := 0 to StrListFile.Count-1 do
    begin
      //Y
      iPos1 := Pos(UpperCase(sStr2), UpperCase(StrListFile.Strings[iRow1]));
      if iPos1 > 0 then
      begin
        //ړāAǂݍł
        ListBox1.ItemIndex := iRow1;
        ListBox1Click(Sender);
        Break;
      end;
    end;
  end;
end;

procedure TFormMain.Timer1Timer(Sender: TObject);
begin
  //_ŕ\
  if Editor1.Modified = TRUE then
  begin
    //\ύX
    Label7.Font.Color := clRed;
    if bFlipTimer = TRUE then
    begin
      Label7.Visible := TRUE;
      bFlipTimer := FALSE;
    end
    else
    begin
      Label7.Visible := FALSE;
      bFlipTimer := TRUE;
    end;
  end
  else
  begin
    //\ύX
    Label7.Font.Color := clBlack;
    Label7.Visible := TRUE;
  end;
  //ݒ
  LanguageChange(Sender);
  if bTimerStop = TRUE then
  begin
    Timer1.Enabled := FALSE;
  end;
end;

procedure TFormMain.Timer2Timer(Sender: TObject);
begin
  //󋵕\
  Label10.Caption := 'List:' + Format('%.6d',[iFileListCount]);
  Label10.Update;
end;

procedure TFormMain.StringGrid1TopLeftChanged(Sender: TObject);
begin
  //Obh̏ꍇ̂
  if StringGrid1.Focused = TRUE then
  begin
    //Obh̍sƘAăGfB^[̃J[\ړ
    Editor1.Row := StringGrid1.Row-1;
    Editor1.TopRow := StringGrid1.TopRow-1;
  end;
end;

procedure TFormMain.StringGrid1Click(Sender: TObject);
begin
  StringGrid1TopLeftChanged(Sender);
end;

procedure TFormMain.StringGrid1RowMoved(Sender: TObject; FromIndex, ToIndex: Integer);
begin
  StringGrid1TopLeftChanged(Sender);
end;

procedure TFormMain.Editor1CaretMoved(Sender: TObject);
var
  iRow: Integer;
begin
  //\
  Label8.Caption := 'Row/Col:' + Format('%.6d',[Editor1.Row+1]) + '/' + Format('%.3d',[Editor1.Col]);
  //GfB^[̍sƘAăObh̃J[\ړ
  if Editor1.Lines.Count > 0 then
  begin
    //ŏsݒ肷
    iRow := StringGrid1.Row-10;
    if iRow < 1 then
    begin
      iRow := 1;
    end
    else if iRow > Editor1.Lines.Count-1 then
    begin
      iRow := Editor1.Lines.Count-1;
    end
    else
    begin
    end;
    StringGrid1.TopRow := iRow;
    //ݍs̐ݒ
    //GfB^̍s͎ۂ̍s+1܂ŕ\Ă̂Œӂ̎
    iRow := Editor1.Row+1;
    if iRow > StringGrid1.RowCount-1 then
    begin
      iRow := StringGrid1.RowCount-1;
    end;
    StringGrid1.Row := iRow;
  end
  //eꍇ
  else
  begin
    StringGrid1.TopRow := 2;
  end;
end;

procedure TFormMain.Editor1TopRowChange(Sender: TObject);
begin
  Editor1CaretMoved(Sender);
end;

procedure TFormMain.Editor1Click(Sender: TObject);
begin
  Editor1CaretMoved(Sender);
end;

procedure TFormMain.Editor1SelectionChange(Sender: TObject; Selected: Boolean);
begin
  Editor1CaretMoved(Sender);
end;

procedure TFormMain.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
  //tH[JX
  if StringGrid1.Focused = TRUE then
  begin
    //I
    if gdSelected in State then
    begin
      StringGrid1.Canvas.Brush.Color := clSkyBlue;
      StringGrid1.Canvas.Font.Color := clWindowText;
    end;
    //\
    StringGrid1.Canvas.FillRect(Rect);
    StringGrid1.Canvas.TextOut(Rect.Left, Rect.Top, StringGrid1.Cells[ACol, ARow]);
  end
  //tH[JXȂ
  else
  begin
    //I
    if gdSelected in State then
    begin
      StringGrid1.Canvas.Brush.Color := clLtGray;
      StringGrid1.Canvas.Font.Color := clWindowText;
    end;
    //\
    StringGrid1.Canvas.FillRect(Rect);
    StringGrid1.Canvas.TextOut(Rect.Left, Rect.Top, StringGrid1.Cells[ACol, ARow]);
  end;
end;

procedure TFormMain.MenuJapaneseSetClick(Sender: TObject);
begin
  //]
  MenuJapaneseSet.Checked := not MenuJapaneseSet.Checked;
  //ݒ
  LanguageChange(Sender);
end;


procedure TFormMain.AllBtnDisabled(Sender: TObject);
var
  iCnt: Integer;
begin
  //ݒ
  for iCnt := 0 to ComponentCount-1 do
  begin
    if Components[iCnt] is TButton then
    begin
      TButton(Components[iCnt]).Enabled := FALSE;
    end;
    if Components[iCnt] is TEdit then
    begin
      TEdit(Components[iCnt]).Enabled := FALSE;
    end;
    if Components[iCnt] is TCheckBox then
    begin
      TCheckBox(Components[iCnt]).Enabled := FALSE;
    end;
    if Components[iCnt] is TComboBox then
    begin
      TComboBox(Components[iCnt]).Enabled := FALSE;
    end;
    if Components[iCnt] is TListBox then
    begin
      TListBox(Components[iCnt]).Enabled := FALSE;
    end;
    if Components[iCnt] is TMenuItem then
    begin
      TMenuItem(Components[iCnt]).Enabled := FALSE;
    end;
    if Components[iCnt] is TRadioGroup then
    begin
      TRadioGroup(Components[iCnt]).Enabled := FALSE;
    end;
  end;
  //ݒ
  Editor1.Enabled := FALSE;
  //O
end;

procedure TFormMain.AllBtnEnabled(Sender: TObject);
var
  iCnt: Integer;
begin
  //ݒ
  for iCnt := 0 to ComponentCount-1 do
  begin
    if Components[iCnt] is TButton then
    begin
      TButton(Components[iCnt]).Enabled := TRUE;
    end;
    if Components[iCnt] is TEdit then
    begin
      TEdit(Components[iCnt]).Enabled := TRUE;
    end;
    if Components[iCnt] is TCheckBox then
    begin
      TCheckBox(Components[iCnt]).Enabled := TRUE;
    end;
    if Components[iCnt] is TComboBox then
    begin
      TComboBox(Components[iCnt]).Enabled := TRUE;
    end;
    if Components[iCnt] is TListBox then
    begin
      TListBox(Components[iCnt]).Enabled := TRUE;
    end;
    if Components[iCnt] is TMenuItem then
    begin
      TMenuItem(Components[iCnt]).Enabled := TRUE;
    end;
    if Components[iCnt] is TRadioGroup then
    begin
      TRadioGroup(Components[iCnt]).Enabled := TRUE;
    end;
  end;
  //ݒ
  Editor1.Enabled := TRUE;
  //O
  BtnReservedSave.Enabled := FALSE;
  BtnMakeIndex.Enabled := FALSE;
  BtnSaveIndex.Enabled := FALSE;
end;

procedure TFormMain.BtnSaveIndexClick(Sender: TObject);
var
  sStr1: String;
begin
  //t@Cۑ
  sStr1 := ExtractFilePath(Paramstr(0)) + FILE_INDEX;
  Editor5.Lines.SaveToFile(sStr1);
  Editor5.Modified := FALSE;
end;

procedure TFormMain.BtnStopListFileClick(Sender: TObject);
begin
  //~w
  bStopListFiles := TRUE;
end;

procedure TFormMain.BtnStopSearchWordClick(Sender: TObject);
begin
  //~w
  bStopSearchWord := TRUE;
  //JE^
  iStopSearchWordCounter := 0;
end;

procedure TFormMain.MenuQuitClick(Sender: TObject);
begin
  //I
  Close;
end;

procedure TFormMain.MenuSetEditorClick(Sender: TObject);
begin
  //\
  FormOption.PageControl1.ActivePageIndex := 0;
  FormOption.TabSheet1.TabVisible := TRUE;
  FormOption.TabSheet2.TabVisible := FALSE;
  FormOption.TabSheet3.TabVisible := FALSE;
  FormOption.TabSheet4.TabVisible := FALSE;
  FormOption.TabSheet5.TabVisible := FALSE;
  FormOption.ShowModal;
end;

procedure TFormMain.MenuSearchOptionsClick(Sender: TObject);
begin
  //\
  FormOption.PageControl1.ActivePageIndex := 1;
  FormOption.TabSheet2.TabVisible := TRUE;
  FormOption.TabSheet1.TabVisible := FALSE;
  FormOption.TabSheet3.TabVisible := FALSE;
  FormOption.TabSheet4.TabVisible := FALSE;
  FormOption.TabSheet5.TabVisible := FALSE;
  FormOption.ShowModal;
end;

procedure TFormMain.MenuFileListSettingClick(Sender: TObject);
begin
  //\
  FormOption.PageControl1.ActivePageIndex := 2;
  FormOption.TabSheet3.TabVisible := TRUE;
  FormOption.TabSheet1.TabVisible := FALSE;
  FormOption.TabSheet2.TabVisible := FALSE;
  FormOption.TabSheet4.TabVisible := FALSE;
  FormOption.TabSheet5.TabVisible := FALSE;
  FormOption.ShowModal;
end;

procedure TFormMain.MenuSetFolderHistoryClick(Sender: TObject);
var
  iIndex: Integer;
begin
  //\
  FormOption.PageControl1.ActivePageIndex := 3;
  FormOption.TabSheet4.TabVisible := TRUE;
  FormOption.TabSheet1.TabVisible := FALSE;
  FormOption.TabSheet2.TabVisible := FALSE;
  FormOption.TabSheet3.TabVisible := FALSE;
  FormOption.TabSheet5.TabVisible := FALSE;
  FormOption.ShowModal;
  //ԕA
  //Vݒ𔽉f
  ComboBox1.Items.Clear;
  for iIndex := 0 to FOLDER_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    if CheckBox11.Checked = TRUE then
    begin
      ComboBox1.Items.Add(saHistoryFolderBookmark[iIndex]);
    end
    else
    begin
      ComboBox1.Items.Add(saHistoryFolderNormal[iIndex]);
    end;
  end;
  ComboBox1.ItemIndex := 0;
end;

procedure TFormMain.MenuSetFindHitoryClick(Sender: TObject);
var
  iIndex: Integer;
begin
  //\
  FormOption.PageControl1.ActivePageIndex := 4;
  FormOption.TabSheet5.TabVisible := TRUE;
  FormOption.TabSheet1.TabVisible := FALSE;
  FormOption.TabSheet2.TabVisible := FALSE;
  FormOption.TabSheet3.TabVisible := FALSE;
  FormOption.TabSheet4.TabVisible := FALSE;
  FormOption.ShowModal;
  //Vݒ𔽉f
  ComboBox2.Items.Clear;
  for iIndex := 0 to FIND_COMBO_BOX_ITEM_NUMBER-1 do
  begin
    if CheckBox12.Checked = TRUE then
    begin
      ComboBox2.Items.Add(saHistoryFindBookmark[iIndex]);
    end
    else
    begin
      ComboBox2.Items.Add(saHistoryFindNormal[iIndex]);
    end;
  end;
  ComboBox2.ItemIndex := 0;
end;

procedure TFormMain.MenuFindClick(Sender: TObject);
begin
  //tH[JXݒ
  Edit1.SetFocus
end;

procedure TFormMain.MenuNextWordClick(Sender: TObject);
begin
  BtnNextWordClick(Sender);
end;

procedure TFormMain.MenuPrevWordClick(Sender: TObject);
begin
  BtnPrevWordClick(Sender);
end;

procedure TFormMain.MenuEditor1ExecuteClick(Sender: TObject);
begin
  //N
  ExecuteProgram(sEditorFileName[0], sEditorOption[0]);
end;

procedure TFormMain.MenuEditor2ExecuteClick(Sender: TObject);
begin
  //N
  ExecuteProgram(sEditorFileName[1], sEditorOption[1]);
end;

procedure TFormMain.MenuEditor3ExecuteClick(Sender: TObject);
begin
  //N
  ExecuteProgram(sEditorFileName[2], sEditorOption[2]);
end;

procedure TFormMain.MenuEditor4ExecuteClick(Sender: TObject);
begin
  //N
  ExecuteProgram(sEditorFileName[3], sEditorOption[3]);
end;

procedure TFormMain.MenuFileSaveAsClick(Sender: TObject);
begin
  //ǂݍݔ
  if ListBox1.Count = 0 then
  begin
    //bZ[W\
    MsgNoFileForSave(Sender);
    Exit;
  end;
  //eLXg
  if (iDisplayMode = STRETCH_MODE) or (iDisplayMode = ORIGINAL_MODE) then
  begin
    //bZ[W\
    MsgFileTypeIsGraphic(Sender);
    Exit;
  end;
  //ݒ
  SaveDialog1.InitialDir := ExtractFileDir (StrListFile.Strings[ListBox1.ItemIndex]);
  SaveDialog1.FileName   := StrListFile.Strings[ListBox1.ItemIndex];
  //s
  if SaveDialog1.Execute = TRUE then
  begin
    //t@CmF
    if FileExists(SaveDialog1.FileName) = TRUE then
    begin
      //t@Cۑ
      if MsgOverWriteThisFile(Sender) <> mrYes then
      begin
        //f
        Exit;
      end;
    end;
    //ۑ
    Editor1.Lines.SaveToFile(SaveDialog1.FileName);
    Editor1.Modified := FALSE;
    Timer1.Enabled := FALSE;
  end;
end;

procedure TFormMain.MenuGridModeClick(Sender: TObject);
begin
  //]
  CheckBox2.Checked := not CheckBox2.Checked;
  //Grid/Textؑ
  CheckBox2Click(Sender);
end;

procedure TFormMain.MenuEditModeClick(Sender: TObject);
begin
  //]
  CheckBox1.Checked := not CheckBox1.Checked;
  //Edit/Viewerؑ
  CheckBox1Click(Sender);
end;

procedure TFormMain.MenuBmp256ColorClick(Sender: TObject);
begin
  //]
  MenuBmp256Color.Checked := not MenuBmp256Color.Checked;
end;

procedure TFormMain.MenuEditorFontColorClick(Sender: TObject);
begin
  //Fݒ
  if ColorDialog1.Execute = TRUE then
  begin
    //Đݒ
    CheckBox1Click(Sender);
  end;
end;

procedure TFormMain.MenuViewerFontColorClick(Sender: TObject);
begin
  //Fݒ
  if ColorDialog2.Execute = TRUE then
  begin
    //Đݒ
    CheckBox1Click(Sender);
  end;
end;

procedure TFormMain.MenuReservedWordFontColorClick(Sender: TObject);
begin
  //Fݒ
  if ColorDialog3.Execute = TRUE then
  begin
    //Đݒ
    Editor1.View.Colors.Reserve.Color   := ColorDialog3.Color;
  end;
end;

procedure TFormMain.MenuGridWidthClick(Sender: TObject);
begin
  //]
  MenuGridWidth.Checked := not MenuGridWidth.Checked;
  //Obh̕𔽉f
  SetGridWidth(Sender);
end;

procedure TFormMain.MsgNoFolderFileForSearch(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('Ώۂ̃tH_܂̓t@CL܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('No folder or no file for search !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgNoFolderForSearch(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('Ώۂ̃tH_L܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('No folder for search !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgNoFileForSearch(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('Ώۂ̃t@CL܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('No files for search !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgNoFileForSave(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('ۑt@CL܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('No files for save !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgNoFileForView(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('\t@CL܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('No files for view !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgNoFileForEdit(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('ҏWt@CL܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('No files for edit !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgCanNotFindWord(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('ꂪ݂܂ ! '  + #13#10 + Edit1.Text, mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('Can not find word ! '  + #13#10 + Edit1.Text, mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgFindWordIsNotSet(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('ꂪݒ肳Ă܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('Find word is not set !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgNoFileForMakingIndexFile(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('ڎ쐬p̃t@CL܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('No files for making index file !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgCanNotFindExecuteFile(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('GfB^[p̃vOL܂ ! ', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('Can not find execute file ! ', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgCanNotFindOptionFaileName(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('GfB^[p̃IvVݒ %f ̐ݒ肪L܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('Can not find %f on option item !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgFailedExecuteEditor(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('GfB^[̋NɎs܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('Failed execute editor !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgListFilesStop(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('t@Cꗗ擾𒆎~܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('Get list files has stopped !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgSearchWordStop(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('𒆎~܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('Search word has stopped !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgFileTypeIsGraphic(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('eLXgt@Cł͂܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('This file is not text file !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgDrawFileSizeIsLarge(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('摜TCY傫ł܂ !', mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('This picture size is too large !', mtWarning, [mbOK], 0);
  end;
end;

procedure TFormMain.MsgDrawWaitTimeIsOutOfRange(Sender: TObject);
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    MessageDlgEx('摜҂Ԃ͈͊Oł (Dafault=350) !' +
      #13#10 + InttoStr(DRAW_WAITE_TIME_MAX) + ' >= time =>' + InttoStr(DRAW_WAITE_TIME_MIN),
    mtWarning, [mbOK], 0);
  end
  //p
  else
  begin
    //bZ[W\
    MessageDlgEx('The waite time of picture draw is out of range (Dafault=350) !' +
      #13#10 + InttoStr(DRAW_WAITE_TIME_MAX) + ' >= time =>' + InttoStr(DRAW_WAITE_TIME_MIN),
    mtWarning, [mbOK], 0);
    end;
end;

function TFormMain.MsgSaveThisFile(Sender: TObject): Integer;
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    Result := MessageDlgEx('̃t@Cۑ܂ ? ' + #13#10 + StrListFile.Strings[ListBox1.ItemIndex], mtInformation, [mbYes, mbNo], 0);
  end
  //p
  else
  begin
    //bZ[W\
    Result := MessageDlgEx('Save this file ? '  + #13#10 + StrListFile.Strings[ListBox1.ItemIndex], mtInformation, [mbYes, mbNo], 0);
  end;
end;

function TFormMain.MsgOverWriteThisFile(Sender: TObject): Integer;
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    Result := MessageDlgEx('̃t@C㏑ۑ܂ ? '  + #13#10 + SaveDialog1.FileName, mtInformation, [mbYes, mbNo], 0);
  end
  //p
  else
  begin
    //bZ[W\
    Result := MessageDlgEx('Overwrite this file ? '  + #13#10 + SaveDialog1.FileName, mtInformation, [mbYes, mbNo], 0);
  end;
end;

function  TFormMain.MsgReserverWordIsModified_SaveFile(Sender: TObject): Integer;
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    Result := MessageDlgEx('\ꂪύXĂ܂B̃t@Cۑ܂ ?', mtInformation, [mbYes, mbNo], 0);
  end
  //p
  else
  begin
    //bZ[W\
    Result := MessageDlgEx('Reserved word is modified. Save file ?', mtInformation, [mbYes, mbNo], 0);
  end;
end;

function  TFormMain.MsgHistoryOfReservedIsModified_SaveFile(Sender: TObject): Integer;
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    Result := MessageDlgEx('\̗ύXĂ܂B̃t@Cۑ܂ ?', mtInformation, [mbYes, mbNo], 0);
  end
  //p
  else
  begin
    //bZ[W\
    Result := MessageDlgEx('History of reserved word is modified. Save file ?', mtInformation, [mbYes, mbNo], 0);
  end;
end;

function  TFormMain.MsgSearchTargetIsRootOfDrive(Sender: TObject): Integer;
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    Result := MessageDlgEx('tH_̓hCũ[głB܂ ?', mtInformation, [mbYes, mbNo], 0);
  end
  //p
  else
  begin
    //bZ[W\
    Result := MessageDlgEx('Search target folder is root of drive. Do you search files ?', mtInformation, [mbYes, mbNo], 0);
  end;
end;

function  TFormMain.MsgIndexFileIsModified_DoYouExit(Sender: TObject): Integer;
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    Result := MessageDlgEx('ڎt@C̓eύXꂢ܂BۑȂĂǂł ?', mtInformation, [mbYes, mbNo], 0);
  end
  //p
  else
  begin
    //bZ[W\
    Result := MessageDlgEx('Index file is modified. Do you exit ?', mtInformation, [mbYes, mbNo], 0);
  end;
end;

function TFormMain.MsgEscapeKey(Sender: TObject): Integer;
begin
  //{
  if MenuJapaneseSet.Checked = TRUE then
  begin
    //bZ[W\
    Result := MessageDlgEx('I܂ ?', mtInformation, [mbYes, mbNo], 0);
  end
  //p
  else
  begin
    //bZ[W\
    Result := MessageDlgEx('Quit this program ?', mtInformation, [mbYes, mbNo], 0);
  end;
end;

function  TFormMain.MessageDlgEX(Msg: String; MsgDlgType:TMsgDlgType; Buttons:TMsgDlgButtons; iBtn: Integer): Integer;
var
  iIndex: Integer;
begin
  //^Cv\
  Case MsgDlgType of
    mtWarning      : saMessage[0] := 'Warning !';
    mtError        : saMessage[0] := 'Error !';
    mtInformation  : saMessage[0] := 'Information !';
    mtConfirmation : saMessage[0] := 'Confirmination !';
    mtCustom       : saMessage[0] := 'Custom !';
  end;
  //bZ[W\ ś@'Line1' + #13#10 + 'Line2'
  saMessage[1] := Msg;
  //{^̐ݒ
  for iIndex := Low(saButtonMsg) to High(saButtonMsg) do
  begin
    saButtonMsg [iIndex] := '';
  end;
  if      (Buttons = [mbYes] + [mbNo] + [mbCancel]) then
  begin
    saButtonMsg [0] := 'Yes(&Y)';
    saButtonSet [0] := mbYes;
    saButtonRet [0] := mrYes;
    saButtonMsg [1] := 'No(&N)';
    saButtonSet [1] := mbNo;
    saButtonRet [1] := mrNo;
    saButtonMsg [2] := 'Cancel(&C)';
    saButtonSet [2] := mbCancel;
    saButtonRet [2] := mrCancel;
  end
  else if (Buttons = [mbYes] + [mbNo]) then
  begin
    saButtonMsg [0] := 'Yes(&Y)';
    saButtonSet [0] := mbYes;
    saButtonRet [0] := mrYes;
    saButtonMsg [1] := 'No(&N)';
    saButtonSet [1] := mbNo;
    saButtonRet [1] := mrNo;
  end
  else if (Buttons = [mbYes]) then
  begin
    saButtonMsg [0] := 'Yes(&Y)';
    saButtonSet [0] := mbYes;
    saButtonRet [0] := mrYes;
  end
  else if (Buttons = [mbOK]) then
  begin
    saButtonMsg [0] := 'OK(&O)';
    saButtonSet [0] := mbOK;
    saButtonRet [0] := mrOK;
  end
  else if (Buttons = [mbCancel]) then
  begin
    saButtonMsg [0] := 'Cancel(&C)';
    saButtonSet [0] := mbCancel;
    saButtonRet [0] := mrCancel;
  end
  else
  begin
    saButtonMsg [0] := 'Cancel(&C)';
    saButtonSet [0] := mbCancel;
    saButtonRet [0] := mrCancel;
  end;
  //tH[JXݒ
  iButtonIndex := iBtn;
  //ߒlݒ
  Result := FormMsgDlgEx.ShowModal;
//  Label5.Caption := InttoStr(mrOK);     //1
//  Label5.Caption := InttoStr(mrYes);    //6
//  Label5.Caption := InttoStr(mrNo);     //7
//  Label5.Caption := InttoStr(mrCancel); //2
end;

procedure TFormMain.ComboBox2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  sStr1: String;
begin
  //ENTERŌ{
  if key = VK_RETURN then
  begin
    //󔒂̏ꍇ́AXV̂
    if ComboBox2.Text = '' then
    begin
      //XV
      sStr1 := ComboBox2.Text;
      UpdateFindComboBox(sStr1);
      //tH[JXړ
      ComboBox2.SetFocus;
      //
      key := 0;
    end
    //󔒂łȂꍇ́AXVătH[JXړ
    else
    begin
      //XV
      sStr1 := ComboBox2.Text;
      UpdateFindComboBox(sStr1);
      //ݒ
      Edit1.Text := ComboBox2.Items[0];
      //tH[JXړ
      Edit1.SetFocus;
      //
      key := 0;
    end;
  end;
end;

procedure TFormMain.ComboBox2CloseUp(Sender: TObject);
var
  sStr1: String;
begin
  //󔒂̏ꍇ́AXV̂
  if ComboBox2.Text = '' then
  begin
    //XV
    sStr1 := ComboBox2.Text;
    UpdateFindComboBox(sStr1);
    //tH[JXړ
    ComboBox2.SetFocus;
  end
  //󔒂łȂꍇ́AXVătH[JXړ
  else
  begin
      //XV
      sStr1 := ComboBox2.Text;
      UpdateFindComboBox(sStr1);
      //ݒ
      Edit1.Text := ComboBox2.Items[0];
      //tH[JXړ
      Edit1.SetFocus;
  end;
end;

function TFormMain.GetLongPathName(const sShortName: String): String;
var
  Buffer : array[0..MAX_PATH-1] of Char;
begin
  if (GetLongPathNameA(PChar(sShortName), Buffer, SizeOf(Buffer))) <> 0 then
  begin
    Result := Buffer;
  end else begin
    Result := sShortName;
  end;
end;

procedure TFormMain.DrawBmpFileClear(Sender: TObject);
begin
  Image1.Width := 1;
  Image1.Height := 1;
  Image2.Width := 1;
  Image2.Height := 1;
  Image11.Width := 1;
  Image11.Height := 1;
  Image12.Width := 1;
  Image12.Height := 1;
end;

procedure TFormMain.DrawBmpFile(sFileName: String; Bmp256Color: Boolean);

  //֐֐̊Jn
  procedure SetImageSize(Image: TImage; Panel: TPanel; Height: Integer; Width: Integer);
  var
    VerticalRate:   Real;
    HorizontalRate: Real;
  begin
    //摜TCY̐ݒ
    VerticalRate   := Height / Panel.ClientHeight;
    HorizontalRate := Width  / Panel.ClientWidth;
    //摜TCY̏cƉ œKȏԂŕ\悤ɐݒ肷
    if (VerticalRate > 1) and (HorizontalRate > 1) then
    begin
      if (VerticalRate >= HorizontalRate) then
      begin
        Image.Height := Panel.ClientHeight - 10;
        Image.Width  := Round(Image.Height  * Width / Height) - 10;
      end
      else
      begin
        Image.Width  := Panel.ClientWidth - 10;
        Image.Height := Round(Image.Width   * Height / Width) - 10;
      end;
    end
    else if (VerticalRate > 1) then
    begin
      Image.Height := Panel.ClientHeight - 10;
      Image.Width  := Round(Image.Height  * Width / Height) - 10;
    end
    else if (HorizontalRate > 1) then
    begin
      Image.Width  := Panel.ClientWidth - 10;
      Image.Height := Round(Image.Width   * Height / Width) - 10;
    end
    else
    begin
      Image.Height := Height;
      Image.Width  := Width;
    end;
    Image.Left := (Panel.ClientWidth  -  Image.Width ) div 2;
    Image.Top  := (Panel.ClientHeight -  Image.Height) div 2;
  end;
  //֐֐̏I


  //֐֐̊Jn
  procedure SetImageSizeEx(Image: TImage; Panel: TPanel; Height: Integer; Width: Integer);
  var
    VerticalRate:   Real;
    HorizontalRate: Real;
    VerticalRate1:   Real;
    HorizontalRate1: Real;
    VerticalRate2:   Real;
    HorizontalRate2: Real;
  begin
    //cƉ̐ݒ͂̂܂܂ŉ摜TCY̐ݒ
    VerticalRate1   := Height / Panel.ClientHeight;
    HorizontalRate1 := Width  / Panel.ClientWidth;
    //cƉ̐ݒtɂĉ摜TCY̐ݒ
    VerticalRate2   := Width  / Panel.ClientHeight; //̐ݒtɂ
    HorizontalRate2 := Height / Panel.ClientWidth;  //̐ݒtɂ
    //c\Ɖ\̔{vZāA傫̗p
    VerticalRate := VerticalRate1;
    if VerticalRate2 > VerticalRate then
    begin
      VerticalRate := VerticalRate2;
    end;
    HorizontalRate := HorizontalRate1;
    if HorizontalRate2 > HorizontalRate then
    begin
      HorizontalRate := HorizontalRate2;
    end;
    //摜TCY̏cƉ œKȏԂŕ\悤ɐݒ肷
    if (VerticalRate > 1) and (HorizontalRate > 1) then
    begin
      if (VerticalRate >= HorizontalRate) then
      begin
        Image.Height := Round(Height / VerticalRate) - 10;
        Image.Width  := Round(Image.Height * Width / Height) - 10;
      end
      else
      begin
        Image.Width  := Round(Width / HorizontalRate) - 10;
        Image.Height := Round(Image.Width  * Height / Width) - 10;
      end;
    end
    else if (VerticalRate > 1) then
    begin
        Image.Height := Round(Height / VerticalRate) - 10;
        Image.Width  := Round(Image.Height * Width / Height) - 10;
    end
    else if (HorizontalRate > 1) then
    begin
        Image.Width  := Round(Width / HorizontalRate) - 10;
        Image.Height := Round(Image.Width  * Height / Width) - 10;
    end
    else
    begin
      Image.Height := Height;
      Image.Width  := Width;
    end;
    Image.Left := (Panel.ClientWidth  -  Image.Width ) div 2;
    Image.Top  := (Panel.ClientHeight -  Image.Height) div 2;
  end;
  //֐֐̏I

  //֐֐̊Jn
  procedure SetImageSizeAuto(Image: TImage; Panel: TPanel; Height: Integer; Width: Integer; Ratio: integer);
  var
    VerticalRate:   Real;
    HorizontalRate: Real;
  begin
    //{0͎ݒ
    if Ratio = 0 then
    begin
      //摜TCY̐ݒ
      Scrollbox1.ClientWidth;
      VerticalRate   := Height / Panel.ClientHeight;
      HorizontalRate := Width  / Panel.ClientWidth;
      //摜TCY̏cƉ œKȏԂŕ\悤ɐݒ肷
      if (VerticalRate > 1) and (HorizontalRate > 1) then
      begin
        if (VerticalRate >= HorizontalRate) then
        begin
          Image.Height := Panel.ClientHeight - 10;
          Image.Width  := Round(Image.Height  * Width / Height) - 10;
        end
        else
        begin
          Image.Width  := Panel.ClientWidth - 10;
          Image.Height := Round(Image.Width   * Height / Width) - 10;
        end;
      end
      else if (VerticalRate > 1) then
      begin
          Image.Height := Panel.ClientHeight - 10;
          Image.Width  := Round(Image.Height  * Width / Height) - 10;
      end
      else if (HorizontalRate > 1) then
      begin
          Image.Width  := Panel.ClientWidth - 10;
          Image.Height := Round(Image.Width   * Height / Width) - 10;
      end
      else
      begin
          Image.Height := Height;
          Image.Width  := Width;
      end;
    end
    //{ݒ̏ꍇ
    else
    begin
      Image.Height := Round(Height * Ratio / 100);
      Image.Width  := Round(Width  * Ratio / 100);
    end;
  end;
  //֐֐̏I


  var
  BitMap: TBitMap;
  MS: TMemoryStream;
  JP: TJpegImage;
begin
  //쐬
  BitMap := TBitmap.Create;
  MS := TMemoryStream.Create;
  try
    //t@C݂Ȃ
    if FileExists(sFileName) = FALSE then
    begin
      ;
    end
    //t@C݂
    else
    begin
      //BMP t@C̎
      if (UpperCase(ExtractFileExt(sFileName)) = '.BMP') then
      begin
        //ǂݍ
        Application.ProcessMessages;
        BitMap.LoadFromFile(sFileName);
        try
          //256Fݒ̏ꍇ
          if Bmp256Color = TRUE then
          begin
            //256FMemoryStreanɍ쐬
            Application.ProcessMessages;
            JP := TJPegImage.Create;
            //ǂݍ
            try
              //摜ϊ
              JP.Performance := jpBestQuality;
              JP.Assign(BitMap);
              JP.SaveToStream(MS);
              MS.Seek(0, soFromBeginning);
            finally
              JP.Free;
            end;
            //쐬
            Application.ProcessMessages;
            JP := TJPegImage.Create;
            //ǂݍ
            try
              //ǂݍ
              JP.LoadFromStream(MS);
              //傫̐ݒƕ\
//            SetImageSize  (Image1, Panel5, Bitmap.Height, Bitmap.Width);
              SetImageSizeEx(Image1, Panel5, Bitmap.Height, Bitmap.Width);
              Image1.Picture.Graphic  := JP;
              //傫̐ݒƕ\
              SetImageSizeAuto(Image11, Panel5, Bitmap.Height, Bitmap.Width, SetRatio(ComboBox3));
              Image11.Picture.Graphic := JP;
            finally
              JP.Free;
            end;
          end
          //256FݒłȂ
          else
          begin
            //傫̐ݒƕ\
//          SetImageSize  (Image1, Panel5, Bitmap.Height, Bitmap.Width);
            SetImageSizeEx(Image1, Panel5, Bitmap.Height, Bitmap.Width);
            Image1.Picture.Graphic  := Bitmap;
            //傫̐ݒƕ\
            SetImageSizeAuto(Image11, Panel5, Bitmap.Height, Bitmap.Width, SetRatio(ComboBox3));
            Image11.Picture.Graphic := Bitmap;
          end;
        except
          ;
        end;
      end;
      {JPG t@C̎}
      if (UpperCase(ExtractFileExt(sFileName)) = '.JPG' ) or
         (UpperCase(ExtractFileExt(sFileName)) = '.JPEG') then
      begin
        {쐬}
        JP := TJPegImage.Create;
        try
          //ǂݍ
          Application.ProcessMessages;
          JP.LoadFromFile(sFileName);
          try
            //傫̐ݒƕ\
//          SetImageSize  (Image1, Panel5, JP.Height, JP.Width);
            SetImageSizeEx(Image1, Panel5, JP.Height, JP.Width);
            Image1.Picture.Graphic  := JP;
            //傫̐ݒƕ\
            SetImageSizeAuto(Image11, Panel5, JP.Height, JP.Width, SetRatio(ComboBox3));
            Image11.Picture.Graphic := JP;
          except
            ;
          end;
        finally
          JP.Free;
        end;
      end;
    end;
  finally
    MS.Free;
    BitMap.Free;
  end;
end;

procedure TFormMain.CheckBox2Click(Sender: TObject);
begin
  //eLXg
  if (iDisplayMode = GRID_MODE) or (iDisplayMode = TEXT_MODE) then
  begin
    //eLXg\ݒ
    if CheckBox2.Checked = TRUE then
    begin
      iDisplayMode := GRID_MODE;
    end
    else
    begin
      iDisplayMode := TEXT_MODE;
    end;
    //\ؑ
    if CheckBox2.Checked = TRUE then
    begin
      //ObhL
      StringGrid1.Visible := TRUE;
      Editor1.Visible := FALSE;
      ScrollBox2.Visible := FALSE;
      ScrollBox1.Visible := FALSE;
    end
    //\ؑ
    else
    begin
      //eLXgL
      Editor1.Visible := TRUE;
      StringGrid1.Visible := FALSE;
      ScrollBox2.Visible := FALSE;
      ScrollBox1.Visible := FALSE;
    end;
  end;
  //\ؑ
  if CheckBox2.Checked = TRUE then
  begin
    //Fݒ
    CheckBox2.Font.Color := clRed;
  end
  //\ؑ
  else
  begin
    //Fݒ
    CheckBox2.Font.Color := clBlack;
  end;
end;

procedure TFormMain.SetImageRotate(ImageSrc: TImage; ImageDst: TImage; AngleType: Integer);
var
  BitmapSrc: TBitmap;
  BitmapDst: TBitmap;
  SrcArray: array [0..SCANALLY_SIZE] of PRGBArray;
  DstArray: array [0..SCANALLY_SIZE] of PRGBArray;
  X: integer;
  Y: integer;
//Iz͎XŝŐÓIzɕύX
//  SrcArray: array of PRGBArray;
//  DstArray: array of PRGBArray;
begin
  //
  Application.ProcessMessages;
  Application.ProcessMessages;
  // 360x]
  if AngleType = 360 then
  begin
    //m
    BitmapSrc := TBitmap.Create;
    try
      //]f[^ǂݍ
      BitMapSrc.Assign(ImageSrc.Picture.Graphic);
      //c͕ύX
      ImageDst.Width  := ImageSrc.Width;
      ImageDst.Height := ImageSrc.Height;
      //摜ꎞ
      ImageDst.Visible := FALSE;
      //]f[^]ɂ̂܂ܐݒ
      ImageDst.Picture.Bitmap.Assign(BitmapSrc);
      //摜\
      ImageDst.Visible := TRUE;
    finally
      //j
      BitmapSrc.Free;
    end;
  end;

  // 0x]A90x]A180x]A270x]
  if (AngleType = 0) or (AngleType = 90) or (AngleType = 180)  or (AngleType = 270) then
  begin
    //m
    BitmapSrc := TBitmap.Create;
    BitmapDst := TBitmap.Create;
    //
    try
      try
        //]f[^ǂݍ
        BitMapSrc.Assign(ImageSrc.Picture.Graphic);
        //ScanLine Ńf[^₷悤24rbg
        BitMapSrc.PixelFormat :=pf24bit;

        //摜ꎞ
        ImageDst.Visible := FALSE;

        //]ɓ]̂܂ܐݒ肷
        BitMapDst.Assign(BitmapSrc);
        //ScanLine Ńf[^₷悤24rbg
        BitMapDst.PixelFormat :=pf24bit;

        //c̐ݒ
        if (AngleType =  90) or (AngleType = 270) then
        begin
          //cւ̂ő傫ς邪A]ɍĐݒ肷̂ŋCɂȂ
          BitMapDst.Height := BitMapSrc.Width;
          BitMapDst.Width  := BitMapSrc.Height;
        end;
        //c̐ݒ
        if (AngleType = 180) or (AngleType = 0) then
        begin
         //c͕ύX
          BitMapDst.Height := BitMapSrc.Height;
          BitMapDst.Width  := BitMapSrc.Width;
        end;

        //zTCY̊mF
        if (BitMapSrc.Height > SCANALLY_SIZE) or (BitMapDst.Height > SCANALLY_SIZE) then
        begin
          MsgDrawFileSizeIsLarge(Self);
        end
        else
        begin
          //c̐ݒ
          if (AngleType =  90) or (AngleType = 270) then
          begin
            //cւ
            ImageDst.Width  := ImageSrc.Height;
            ImageDst.Height := ImageSrc.Width;
          end;
          if (AngleType = 180) or (AngleType = 0) then
          begin
            //c͂̂܂
            ImageDst.Width  := ImageSrc.Width;
            ImageDst.Height := ImageSrc.Height;
          end;

          //Iz͎XŝŐÓIzɕύX
          //mۂsAۂ̃TCY͂Ō肳
          //GetMem(SrcArray,  BitMapSrc.Height * SizeOf(PRGBArray));
          //Initialize(SrcArray); //ɂ͕sv
          //GetMem(DstArray,  BitMapDst.Height * SizeOf(PRGBArray));
          //Initialize(DstArray); //ɂ͕sv

          //ϊ̃sNZf[^BytezɃLbV
          for Y := 0 to BitMapSrc.Height-1 do
          begin
            //
            Application.ProcessMessages;
            Application.ProcessMessages;
            SrcArray[Y]  := BitmapSrc.ScanLine[Y];
          end;
          //o͐̃sNZf[^BytezɃLbV
          for Y := 0 to BitMapDst.Height-1 do
          begin
            //
            Application.ProcessMessages;
            Application.ProcessMessages;
            DstArray[Y] := BitmapDst.ScanLine[Y];
          end;

          //ϊ
          if (AngleType =  0) then
          begin
            //f[^]
            for Y :=0 to BitmapDst.Height-1 do
            begin
              //
              Application.ProcessMessages;
              for X :=0 to BitmapDst.Width-1 do
              begin
                //
                Application.ProcessMessages;
                DstArray[Y][X].R :=SrcArray[Y][X].R;
                DstArray[Y][X].G :=SrcArray[Y][X].G;
                DstArray[Y][X].B :=SrcArray[Y][X].B;
              end;
            end;
          end;
          //ϊ
          if (AngleType =  90) then
          begin
            //f[^]
            for Y :=0 to BitmapDst.Height-1 do
            begin
              //
              Application.ProcessMessages;
              for X :=0 to BitmapDst.Width-1 do
              begin
                //
                Application.ProcessMessages;
                DstArray[Y][X].R :=SrcArray[BitmapSrc.Height-1-X][Y].R;
                DstArray[Y][X].G :=SrcArray[BitmapSrc.Height-1-X][Y].G;
                DstArray[Y][X].B :=SrcArray[BitmapSrc.Height-1-X][Y].B;
              end;
            end;
          end;
          //ϊ
          if (AngleType = 180) then
          begin
            //f[^]
            for Y :=0 to BitmapDst.Height-1 do
            begin
              //
              Application.ProcessMessages;
              for X :=0 to BitmapDst.Width-1 do
              begin
                //
                Application.ProcessMessages;
                DstArray[Y][X].R :=SrcArray[BitmapSrc.Height-1-Y][BitMapSrc.width-1-X].R;
                DstArray[Y][X].G :=SrcArray[BitmapSrc.Height-1-Y][BitMapSrc.width-1-X].G;
                DstArray[Y][X].B :=SrcArray[BitmapSrc.Height-1-Y][BitMapSrc.width-1-X].B;
              end;
            end;
          end;
          //ϊ
          if (AngleType = 270) then
          begin
            //f[^]
            for Y :=0 to BitmapDst.Height-1 do
            begin
              //
              Application.ProcessMessages;
              for X :=0 to BitmapDst.Width-1 do
              begin
                //
                Application.ProcessMessages;
                DstArray[Y][X].R :=SrcArray[X][BitmapSrc.Width-1-Y].R;
                DstArray[Y][X].G :=SrcArray[X][BitmapSrc.Width-1-Y].G;
                DstArray[Y][X].B :=SrcArray[X][BitmapSrc.Width-1-Y].B;
              end;
            end;
          end;

          //f
          ImageDst.Picture.Bitmap.Assign(BitmapDst);
        end;

        //摜\
        ImageDst.Visible := TRUE;
      finally
        //Iz͎XŝŐÓIzɕύX
        //jBĴFinalizesȂƁA|C^G[ɂȂ
        //FreeMem(DstArray, BitMapDst.Height * SizeOf(PRGBArray));
        //Finalize(DstArray);
        //FreeMem(SrcArray, BitMapSrc.Height * SizeOf(PRGBArray));
        //Finalize(SrcArray);
      end;
    finally
      //j
      BitmapDst.Free;
      BitmapSrc.Free;
    end;
  end;
  //
  Application.ProcessMessages;
end;

procedure TFormMain.ComboBox3Change(Sender: TObject);
begin
  //t@Cꍇ
  if ListBox1.Count > 0 then
  begin
    //摜`ݒ
    bNeedDraw := TRUE;
    //t@Cǂݍ
    ReadFromFile(Sender);
    sLatestFileName := StrListFile[ListBox1.ItemIndex];
    //摜I
    DrawImageSelect(Sender);
  end;
end;

procedure TFormMain.FlipFitSizeOrAutoSize(Sender: TObject);
begin
  //Fit  Auto ̐ݒ
  if SetRatio(ComboBox3) = DRAW_TYPE_FIT then
  begin
    iDisplayMode := STRETCH_MODE;
  end
  else
  begin
    iDisplayMode := ORIGINAL_MODE;
  end;
end;

function TFormMain.SetRatio(ComboBox: TComboBox): Integer;
var
  sStr1: String;
  sStr2: String;
begin
  //ݒ蕶̔o
  sStr1 := TrimLeft(UpperCase(ComboBox.Text));
  sStr2 := AnsiReplaceText(sStr1, '%', '');
  //̔
  if      sStr2 = 'FIT' then
  begin
    Result := DRAW_TYPE_FIT;
  end
  else if sStr2 = 'AUTO' then
  begin
    Result := DRAW_TYPE_AUTO;
  end
  else
  begin
     Result := StrToInt(sStr2);
  end;
end;

procedure TFormMain.CheckBoxGroupClick(Sender: TObject);
begin
  //NbN̋@\𖳌ɂ
  CheckBox21.OnClick := nil;
  CheckBox22.OnClick := nil;
  CheckBox23.OnClick := nil;
  CheckBox24.OnClick := nil;
  //Y`FbN
  if Sender <> CheckBox21 then
  begin
    CheckBox21.Checked := False;
  end;
  if Sender <> CheckBox22 then
  begin
    CheckBox22.Checked := False;
  end;
  if Sender <> CheckBox23 then
  begin
    CheckBox23.Checked := False;
  end;
  if Sender <> CheckBox24 then
  begin
    CheckBox24.Checked := False;
  end;
  //ēxNbN̋@\ݒ
  CheckBox21.OnClick := CheckBoxGroupClick;
  CheckBox22.OnClick := CheckBoxGroupClick;
  CheckBox23.OnClick := CheckBoxGroupClick;
  CheckBox24.OnClick := CheckBoxGroupClick;

  //t@Cꍇ
  if ListBox1.Count > 0 then
  begin
    //摜`ݒ
    bNeedDraw := TRUE;
    //t@Cǂݍ
    ReadFromFile(Sender);
    sLatestFileName := StrListFile[ListBox1.ItemIndex];
    //摜I
    DrawImageSelect(Sender);
  end;
end;

procedure TFormMain.DrawImageSelect(Sender: TObject);
begin
  //\ؑ
  if iDisplayMode = STRETCH_MODE then
  begin
    //C[WL
    ScrollBox1.Visible := FALSE;
    ScrollBox2.Visible := TRUE;
    Editor1.Visible := FALSE;
    StringGrid1.Visible := FALSE;
  end
  else if iDisplayMode = ORIGINAL_MODE then
  begin
    //XN[{bNXL
    ScrollBox2.Visible := FALSE;
    ScrollBox1.Visible := TRUE;
    Editor1.Visible := FALSE;
    StringGrid1.Visible := FALSE;
  end
  else
  begin
  end;
end;

procedure TFormMain.DrawImageRotate(Sender: TObject);
begin
  //k\
  if iDisplayMode = STRETCH_MODE then
  begin
    //\]
    if      CheckBox21.Checked = TRUE then
    begin
      SetImageRotate(Image1, Image2, 270);
    end
    else if CheckBox22.Checked = TRUE then
    begin
      SetImageRotate(Image1, Image2,   0);
    end
    else if CheckBox23.Checked = TRUE then
    begin
      SetImageRotate(Image1, Image2,  90);
    end
    else if CheckBox24.Checked = TRUE then
    begin
      SetImageRotate(Image1, Image2, 180);
    end
    else
    begin
    end;
    //ʒuw
    Image2.Left := (Panel5.ClientWidth  -  Image2.Width ) div 2;
    Image2.Top  := (Panel5.ClientHeight -  Image2.Height) div 2;
  end
  //ʏ\
  else if iDisplayMode = ORIGINAL_MODE then
  begin
    if      CheckBox21.Checked = TRUE then
    begin
      SetImageRotate(Image11, Image12, 270);
    end
    else if CheckBox22.Checked = TRUE then
    begin
      SetImageRotate(Image11, Image12,   0);
    end
    else if CheckBox23.Checked = TRUE then
    begin
      SetImageRotate(Image11, Image12,  90);
    end
    else if CheckBox24.Checked = TRUE then
    begin
      SetImageRotate(Image11, Image12, 180);
    end
    else
    begin
    end;
  end
  else
  begin
  end;
end;

// ҂֐  wJEgo߂ TRUE, fꂽȂ FALSE
function TFormMain.SleepEx(const t: integer): Boolean;
var
  Timeout: TDateTime;
begin
  // tȌ
  bWaitBreak := FALSE;
  // I
  Timeout := Now + t/24/3600/1000;
  //
  while (Now < Timeout) and (bWaitBreak = FALSE) do
  begin
    //
    Application.ProcessMessages;
    //x 10ms ȉŗǂꍇ
    Sleep(10);
  end;
  //
  Result := not bWaitBreak;
end;

procedure TFormMain.ListBox1DblClick(Sender: TObject);
var
  Key: Word;
begin
  //\҂
  if DrawWait(Self, Key) then
  begin
    Exit;
  end;
  //摜`ݒ
  bNeedDraw := TRUE;
    //\
  ReadFromFile(Sender);
  sLatestFileName := StrListFile[ListBox1.ItemIndex];
end;

procedure TFormMain.ListBox1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //
  if key = VK_RETURN then
  begin
    //\҂
    if DrawWait(Self, Key) then
    begin
      Exit;
    end;
    //摜`ݒ
    bNeedDraw := TRUE;
    //\
    ReadFromFile(Sender);
    sLatestFileName := StrListFile[ListBox1.ItemIndex];
  end;
end;

procedure TFormMain.ListBox1Click(Sender: TObject);
begin
  //摜`ݒ
  bNeedDraw := FALSE;
  //\
  ReadFromFile(Sender);
  sLatestFileName := StrListFile[ListBox1.ItemIndex];
end;

function  TFormMain.DrawWait(Sender: TObject; var Key: Word): Boolean;
var
  iIndex: Integer;
  sStr1: String;
  fFileStream: TFileStream;
  iWaitTime: Integer;
begin
  //ݒ
  iIndex := ListBox1.ItemIndex;
  sStr1 := StrListFile.Strings[iIndex];
  //摜̏ꍇ
  if (UpperCase(ExtractFileExt(sStr1)) = '.JPG' ) or
     (UpperCase(ExtractFileExt(sStr1)) = '.JPEG') or
     (UpperCase(ExtractFileExt(sStr1)) = '.BMP' ) then
  begin
    //ݒ莞ԈȓȂsȂ
    if Now < tKeyTimeout then
    begin
      Result := TRUE;
      Key := 0;
      Exit;
    end;
    //t@CTCYɍԂݒ肷
    fFileStream := TFileStream.Create(sStr1, fmOpenRead);
    try
      iWaitTime := Round((DRAW_WAITE_SIZE_CONST1 * fFileStream.Size) + DRAW_WAITE_SIZE_CONST2);
    finally
      //J
      fFileStream.Free;
     end;
    //K͑傫ɍĐݒ肷
    if iWaitTime < WAIT_TIME_MIN then
    begin
      iWaitTime := WAIT_TIME_MIN;
    end;
    if iWaitTime > WAIT_TIME_MAX then
    begin
      iWaitTime := WAIT_TIME_MAX;
    end;
    tKeyTimeout := Now + iWaitTime / 24 / 3600 / 1000;
    //
    Result := FALSE;
  end
  else
  begin
    //
    Result := FALSE;
  end;
end;


procedure TFormMain.Image12Click(Sender: TObject);
begin
  ScrollBox1.SetFocus;
end;

procedure TFormMain.Image11Click(Sender: TObject);
begin
  ScrollBox1.SetFocus;
end;

procedure TFormMain.Image1Click(Sender: TObject);
begin
  ScrollBox2.SetFocus;
end;

procedure TFormMain.Image2Click(Sender: TObject);
begin
  ScrollBox2.SetFocus;
end;

procedure TFormMain.ScrollBox1Click(Sender: TObject);
begin
  ScrollBox1.SetFocus;
end;

procedure TFormMain.ScrollBox2Click(Sender: TObject);
begin
  ScrollBox2.SetFocus;
end;

procedure TFormMain.Editor2DblClick(Sender: TObject);
var
  sStr1: String;
  iRow1: Integer;
  iPos1: Integer;
begin
  //t@Ce̔
  if Editor2.Lines.Count > 0 then
  begin
    //ݒ
    sStr1 := Editor2.Lines.Strings[Editor2.Row];
    //
    for iRow1 := 0 to StrListFile.Count-1 do
    begin
      //Y
      iPos1 := Pos(UpperCase(sStr1), UpperCase(StrListFile.Strings[iRow1]));
      if iPos1 > 0 then
      begin
        //ړāAǂݍł
        ListBox1.ItemIndex := iRow1;
        ListBox1Click(Sender);
        Break;
      end;
    end;
  end;
end;

end.



